# this file has been generated automatically; do not edit

import _lasso

_lasso.init()

def cptrToPy(cptr):
    if cptr is None:
        return None
    klass = getattr(lasso, cptr.typename)
    o = klass.__new__(klass)
    o._cptr = cptr
    return o

class frozendict(dict):
    '''Immutable dict'''
    # from Python Cookbook:
    #   http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/414283
    def _blocked_attribute(obj):
        raise AttributeError('A frozendict cannot be modified.')
    _blocked_attribute = property(_blocked_attribute)

    __delitem__ = __setitem__ = clear = _blocked_attribute
    pop = popitem = setdefault = update = _blocked_attribute

    def __new__(cls, *args):
        new = dict.__new__(cls)
        dict.__init__(new, *args)
        return new

    def __init__(self, *args):
        pass

    def __hash__(self):
        try:
            return self._cached_hash
        except AttributeError:
            h = self._cached_hash = hash(tuple(sorted(self.items())))
            return h

    def __repr__(self):
        return 'frozendict(%s)' % dict.__repr__(self)

class Error(Exception):
    code = None
    
    @staticmethod
    def raise_on_rc(rc):
        global exceptions_dict
        exception = exceptions_dict.get(rc, Error())
        exception.code = rc
        raise exception

    def __str__(self):
        return '<lasso.%s(%s): %s>' % (self.__class__.__name__, self.code, _lasso.strError(self.code))

    def __getitem__(self, i):
        # compatibility with SWIG bindings
        if i == 0:
            return self.code
        elif i == 1:
            return _lasso.strError(self.code)
        else:
            raise IndexError()

class ProfileError(Error):
    pass

class ProviderError(Error):
    pass

class ServerError(ProviderError):
    pass

class LoginError(ProfileError):
    pass

class LogoutError(ProfileError):
    pass

class DefederationError(ProfileError):
    pass

class NameIdentifierMappingError(ProfileError):
    pass

class WsfProfileError(ProfileError):
    pass

class DiscoveryError(WsfProfileError):
    pass

class DataServiceError(WsfProfileError):
    pass

class DstError(WsfProfileError):
    pass

class XmlError(Error):
    pass

class XmlNodeNotFoundError(XmlError):
    pass

class XmlNodeContentNotFoundError(XmlError):
    pass

class XmlAttrNotFoundError(XmlError):
    pass

class XmlAttrValueNotFoundError(XmlError):
    pass

class XmlInvalidFileError(XmlError):
    pass

class XmlObjectConstructionFailedError(XmlError):
    pass

class XmlMissingNamespaceError(XmlError):
    pass

class DsError(Error):
    pass

class DsSignatureNotFoundError(DsError):
    pass

class DsInvalidSignatureError(DsError):
    pass

class DsSignatureTmplCreationFailedError(DsError):
    pass

class DsContextCreationFailedError(DsError):
    pass

class DsPublicKeyLoadFailedError(DsError):
    pass

class DsPrivateKeyLoadFailedError(DsError):
    pass

class DsCertificateLoadFailedError(DsError):
    pass

class DsSignatureFailedError(DsError):
    pass

class DsKeysMngrCreationFailedError(DsError):
    pass

class DsKeysMngrInitFailedError(DsError):
    pass

class DsSignatureVerificationFailedError(DsError):
    pass

class DsCaCertChainLoadFailedError(DsError):
    pass

class DsInvalidSigalgError(DsError):
    pass

class DsDigestComputeFailedError(DsError):
    pass

class DsSignatureTemplateNotFoundError(DsError):
    pass

class ServerProviderNotFoundError(ServerError):
    pass

class ServerAddProviderFailedError(ServerError):
    pass

class ServerAddProviderProtocolMismatchError(ServerError):
    pass

class ServerSetEncryptionPrivateKeyFailedError(ServerError):
    pass

class ServerInvalidXmlError(ServerError):
    pass

class LogoutUnsupportedProfileError(LogoutError):
    pass

class LogoutRequestDeniedError(LogoutError):
    pass

class LogoutFederationNotFoundError(LogoutError):
    pass

class LogoutUnknownPrincipalError(LogoutError):
    pass

class ProfileInvalidQueryError(ProfileError):
    pass

class ProfileInvalidPostMsgError(ProfileError):
    pass

class ProfileInvalidSoapMsgError(ProfileError):
    pass

class ProfileMissingRequestError(ProfileError):
    pass

class ProfileInvalidHttpMethodError(ProfileError):
    pass

class ProfileInvalidProtocolprofileError(ProfileError):
    pass

class ProfileInvalidMsgError(ProfileError):
    pass

class ProfileMissingRemoteProvideridError(ProfileError):
    pass

class ProfileUnsupportedProfileError(ProfileError):
    pass

class ProfileUnknownProfileUrlError(ProfileError):
    pass

class ProfileIdentityNotFoundError(ProfileError):
    pass

class ProfileFederationNotFoundError(ProfileError):
    pass

class ProfileNameIdentifierNotFoundError(ProfileError):
    pass

class ProfileBuildingQueryFailedError(ProfileError):
    pass

class ProfileBuildingRequestFailedError(ProfileError):
    pass

class ProfileBuildingMessageFailedError(ProfileError):
    pass

class ProfileBuildingResponseFailedError(ProfileError):
    pass

class ProfileSessionNotFoundError(ProfileError):
    pass

class ProfileBadIdentityDumpError(ProfileError):
    pass

class ProfileBadSessionDumpError(ProfileError):
    pass

class ProfileMissingResponseError(ProfileError):
    pass

class ProfileMissingStatusCodeError(ProfileError):
    pass

class ProfileMissingArtifactError(ProfileError):
    pass

class ProfileMissingResourceOfferingError(ProfileError):
    pass

class ProfileMissingServiceDescriptionError(ProfileError):
    pass

class ProfileMissingServiceTypeError(ProfileError):
    pass

class ProfileMissingAssertionError(ProfileError):
    pass

class ProfileMissingSubjectError(ProfileError):
    pass

class ProfileMissingNameIdentifierError(ProfileError):
    pass

class ProfileInvalidArtifactError(ProfileError):
    pass

class ProfileMissingEncryptionPrivateKeyError(ProfileError):
    pass

class ProfileStatusNotSuccessError(ProfileError):
    pass

class ProfileMissingIssuerError(ProfileError):
    pass

class ProfileMissingServiceInstanceError(ProfileError):
    pass

class ProfileMissingEndpointReferenceError(ProfileError):
    pass

class ProfileMissingEndpointReferenceAddressError(ProfileError):
    pass

class ParamError(Error):
    pass

class ParamBadTypeOrNullObjError(ParamError):
    pass

class ParamInvalidValueError(ParamError):
    pass

class ParamCheckFailedError(ParamError):
    pass

class ParamNonInitializedObjectError(ParamError):
    pass

class LoginFederationNotFoundError(LoginError):
    pass

class LoginConsentNotObtainedError(LoginError):
    pass

class LoginInvalidNameidpolicyError(LoginError):
    pass

class LoginRequestDeniedError(LoginError):
    pass

class LoginInvalidSignatureError(LoginError):
    pass

class LoginUnsignedAuthnRequestError(LoginError):
    pass

class LoginStatusNotSuccessError(LoginError):
    pass

class LoginUnknownPrincipalError(LoginError):
    pass

class LoginNoDefaultEndpointError(LoginError):
    pass

class LoginAssertionReplayError(LoginError):
    pass

class DefederationMissingNameIdentifierError(DefederationError):
    pass

class SoapError(Error):
    pass

class SoapMissingEnvelopeError(SoapError):
    pass

class SoapMissingHeaderError(SoapError):
    pass

class SoapMissingBodyError(SoapError):
    pass

class SoapMissingSoapFaultDetailError(SoapError):
    pass

class NameidentifiermappingMissingTargetNamespaceError(NameIdentifierMappingError):
    pass

class NameidentifiermappingForbiddenCallOnThisSideError(NameIdentifierMappingError):
    pass

class NameidentifiermappingMissingTargetIdentifierError(NameIdentifierMappingError):
    pass

class DataserviceUnregisteredDstError(DataServiceError):
    pass

class WsfprofileMissingCorrelationError(WsfProfileError):
    pass

class WsfprofileMissingSecurityError(WsfProfileError):
    pass

class WsfprofileMissingAssertionIdError(WsfProfileError):
    pass

class WsfprofileMissingEndpointError(WsfProfileError):
    pass

class WsfprofileSoapFaultError(WsfProfileError):
    pass

class WsfprofileUnsupportedSecurityMechanismError(WsfProfileError):
    pass

class DiscoverySvcMetadataRegisterFailedError(DiscoveryError):
    pass

class DiscoverySvcMetadataAssociationAddFailedError(DiscoveryError):
    pass

class DiscoveryMissingRequestedServiceError(DiscoveryError):
    pass

class DiscoveryFailedToBuildEndpointReferenceError(DiscoveryError):
    pass

class DstMissingServiceDataError(DstError):
    pass

class DstQueryFailedError(DstError):
    pass

class DstQueryPartiallyFailedError(DstError):
    pass

class DstModifyFailedError(DstError):
    pass

class DstModifyPartiallyFailedError(DstError):
    pass

class DstNewDataMissingError(DstError):
    pass

exceptions_dict = {
    _lasso.PROFILE_ERROR_SESSION_NOT_FOUND: ProfileSessionNotFoundError,
    _lasso.WSF_PROFILE_ERROR_MISSING_ENDPOINT: WsfprofileMissingEndpointError,
    _lasso.LOGIN_ERROR_ASSERTION_REPLAY: LoginAssertionReplayError,
    _lasso.DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED: DiscoverySvcMetadataRegisterFailedError,
    _lasso.DS_ERROR_DIGEST_COMPUTE_FAILED: DsDigestComputeFailedError,
    _lasso.NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE: NameidentifiermappingMissingTargetNamespaceError,
    _lasso.DS_ERROR_SIGNATURE_NOT_FOUND: DsSignatureNotFoundError,
    _lasso.LOGIN_ERROR_FEDERATION_NOT_FOUND: LoginFederationNotFoundError,
    _lasso.DST_ERROR_QUERY_PARTIALLY_FAILED: DstQueryPartiallyFailedError,
    _lasso.DS_ERROR_SIGNATURE_FAILED: DsSignatureFailedError,
    _lasso.DS_ERROR_CERTIFICATE_LOAD_FAILED: DsCertificateLoadFailedError,
    _lasso.DST_ERROR_MODIFY_FAILED: DstModifyFailedError,
    _lasso.DS_ERROR_INVALID_SIGALG: DsInvalidSigalgError,
    _lasso.DS_ERROR_KEYS_MNGR_INIT_FAILED: DsKeysMngrInitFailedError,
    _lasso.DST_ERROR_MISSING_SERVICE_DATA: DstMissingServiceDataError,
    _lasso.LOGOUT_ERROR_UNSUPPORTED_PROFILE: LogoutUnsupportedProfileError,
    _lasso.PROFILE_ERROR_BUILDING_QUERY_FAILED: ProfileBuildingQueryFailedError,
    _lasso.LOGOUT_ERROR_UNKNOWN_PRINCIPAL: LogoutUnknownPrincipalError,
    _lasso.PROFILE_ERROR_INVALID_PROTOCOLPROFILE: ProfileInvalidProtocolprofileError,
    _lasso.DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND: DsSignatureTemplateNotFoundError,
    _lasso.LOGIN_ERROR_INVALID_NAMEIDPOLICY: LoginInvalidNameidpolicyError,
    _lasso.DS_ERROR_INVALID_SIGNATURE: DsInvalidSignatureError,
    _lasso.PROFILE_ERROR_STATUS_NOT_SUCCESS: ProfileStatusNotSuccessError,
    _lasso.DS_ERROR_PRIVATE_KEY_LOAD_FAILED: DsPrivateKeyLoadFailedError,
    _lasso.PROFILE_ERROR_FEDERATION_NOT_FOUND: ProfileFederationNotFoundError,
    _lasso.SERVER_ERROR_PROVIDER_NOT_FOUND: ServerProviderNotFoundError,
    _lasso.DST_ERROR_MODIFY_PARTIALLY_FAILED: DstModifyPartiallyFailedError,
    _lasso.SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL: SoapMissingSoapFaultDetailError,
    _lasso.XML_ERROR_ATTR_NOT_FOUND: XmlAttrNotFoundError,
    _lasso.PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ: ParamBadTypeOrNullObjError,
    _lasso.DS_ERROR_KEYS_MNGR_CREATION_FAILED: DsKeysMngrCreationFailedError,
    _lasso.DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED: DsCaCertChainLoadFailedError,
    _lasso.WSF_PROFILE_ERROR_SOAP_FAULT: WsfprofileSoapFaultError,
    _lasso.PROFILE_ERROR_BUILDING_REQUEST_FAILED: ProfileBuildingRequestFailedError,
    _lasso.PROFILE_ERROR_MISSING_SERVICE_TYPE: ProfileMissingServiceTypeError,
    _lasso.DST_ERROR_NEW_DATA_MISSING: DstNewDataMissingError,
    _lasso.LOGIN_ERROR_STATUS_NOT_SUCCESS: LoginStatusNotSuccessError,
    _lasso.XML_ERROR_NODE_NOT_FOUND: XmlNodeNotFoundError,
    _lasso.NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE: NameidentifiermappingForbiddenCallOnThisSideError,
    _lasso.XML_ERROR_ATTR_VALUE_NOT_FOUND: XmlAttrValueNotFoundError,
    _lasso.PROFILE_ERROR_INVALID_SOAP_MSG: ProfileInvalidSoapMsgError,
    _lasso.PROFILE_ERROR_MISSING_SUBJECT: ProfileMissingSubjectError,
    _lasso.PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS: ProfileMissingEndpointReferenceAddressError,
    _lasso.PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND: ProfileNameIdentifierNotFoundError,
    _lasso.WSF_PROFILE_ERROR_MISSING_SECURITY: WsfprofileMissingSecurityError,
    _lasso.LOGOUT_ERROR_FEDERATION_NOT_FOUND: LogoutFederationNotFoundError,
    _lasso.XML_ERROR_OBJECT_CONSTRUCTION_FAILED: XmlObjectConstructionFailedError,
    _lasso.PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE: ProfileMissingEndpointReferenceError,
    _lasso.NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER: NameidentifiermappingMissingTargetIdentifierError,
    _lasso.PROFILE_ERROR_INVALID_POST_MSG: ProfileInvalidPostMsgError,
    _lasso.PROFILE_ERROR_BUILDING_MESSAGE_FAILED: ProfileBuildingMessageFailedError,
    _lasso.XML_ERROR_INVALID_FILE: XmlInvalidFileError,
    _lasso.PROFILE_ERROR_MISSING_RESOURCE_OFFERING: ProfileMissingResourceOfferingError,
    _lasso.PARAM_ERROR_CHECK_FAILED: ParamCheckFailedError,
    _lasso.WSF_PROFILE_ERROR_MISSING_ASSERTION_ID: WsfprofileMissingAssertionIdError,
    _lasso.PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY: ProfileMissingEncryptionPrivateKeyError,
    _lasso.WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM: WsfprofileUnsupportedSecurityMechanismError,
    _lasso.PROFILE_ERROR_MISSING_NAME_IDENTIFIER: ProfileMissingNameIdentifierError,
    _lasso.LOGIN_ERROR_UNKNOWN_PRINCIPAL: LoginUnknownPrincipalError,
    _lasso.PROFILE_ERROR_MISSING_REQUEST: ProfileMissingRequestError,
    _lasso.PROFILE_ERROR_INVALID_ARTIFACT: ProfileInvalidArtifactError,
    _lasso.SOAP_ERROR_MISSING_ENVELOPE: SoapMissingEnvelopeError,
    _lasso.PROFILE_ERROR_IDENTITY_NOT_FOUND: ProfileIdentityNotFoundError,
    _lasso.PROFILE_ERROR_INVALID_MSG: ProfileInvalidMsgError,
    _lasso.PARAM_ERROR_INVALID_VALUE: ParamInvalidValueError,
    _lasso.LOGIN_ERROR_CONSENT_NOT_OBTAINED: LoginConsentNotObtainedError,
    _lasso.DST_ERROR_QUERY_FAILED: DstQueryFailedError,
    _lasso.PROFILE_ERROR_MISSING_SERVICE_INSTANCE: ProfileMissingServiceInstanceError,
    _lasso.DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE: DiscoveryFailedToBuildEndpointReferenceError,
    _lasso.DS_ERROR_PUBLIC_KEY_LOAD_FAILED: DsPublicKeyLoadFailedError,
    _lasso.SERVER_ERROR_INVALID_XML: ServerInvalidXmlError,
    _lasso.PROFILE_ERROR_MISSING_ASSERTION: ProfileMissingAssertionError,
    _lasso.PROFILE_ERROR_UNKNOWN_PROFILE_URL: ProfileUnknownProfileUrlError,
    _lasso.PROFILE_ERROR_INVALID_QUERY: ProfileInvalidQueryError,
    _lasso.DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER: DefederationMissingNameIdentifierError,
    _lasso.PROFILE_ERROR_UNSUPPORTED_PROFILE: ProfileUnsupportedProfileError,
    _lasso.DS_ERROR_SIGNATURE_VERIFICATION_FAILED: DsSignatureVerificationFailedError,
    _lasso.LOGIN_ERROR_REQUEST_DENIED: LoginRequestDeniedError,
    _lasso.DATA_SERVICE_ERROR_UNREGISTERED_DST: DataserviceUnregisteredDstError,
    _lasso.LOGIN_ERROR_INVALID_SIGNATURE: LoginInvalidSignatureError,
    _lasso.LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST: LoginUnsignedAuthnRequestError,
    _lasso.SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED: ServerSetEncryptionPrivateKeyFailedError,
    _lasso.DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED: DsSignatureTmplCreationFailedError,
    _lasso.DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED: DiscoverySvcMetadataAssociationAddFailedError,
    _lasso.DS_ERROR_CONTEXT_CREATION_FAILED: DsContextCreationFailedError,
    _lasso.PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION: ProfileMissingServiceDescriptionError,
    _lasso.PROFILE_ERROR_MISSING_REMOTE_PROVIDERID: ProfileMissingRemoteProvideridError,
    _lasso.PARAM_ERROR_NON_INITIALIZED_OBJECT: ParamNonInitializedObjectError,
    _lasso.PROFILE_ERROR_MISSING_RESPONSE: ProfileMissingResponseError,
    _lasso.LOGOUT_ERROR_REQUEST_DENIED: LogoutRequestDeniedError,
    _lasso.XML_ERROR_MISSING_NAMESPACE: XmlMissingNamespaceError,
    _lasso.PROFILE_ERROR_MISSING_ARTIFACT: ProfileMissingArtifactError,
    _lasso.WSF_PROFILE_ERROR_MISSING_CORRELATION: WsfprofileMissingCorrelationError,
    _lasso.SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH: ServerAddProviderProtocolMismatchError,
    _lasso.PROFILE_ERROR_MISSING_STATUS_CODE: ProfileMissingStatusCodeError,
    _lasso.PROFILE_ERROR_BAD_IDENTITY_DUMP: ProfileBadIdentityDumpError,
    _lasso.PROFILE_ERROR_BUILDING_RESPONSE_FAILED: ProfileBuildingResponseFailedError,
    _lasso.LOGIN_ERROR_NO_DEFAULT_ENDPOINT: LoginNoDefaultEndpointError,
    _lasso.PROFILE_ERROR_BAD_SESSION_DUMP: ProfileBadSessionDumpError,
    _lasso.DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE: DiscoveryMissingRequestedServiceError,
    _lasso.SOAP_ERROR_MISSING_BODY: SoapMissingBodyError,
    _lasso.SERVER_ERROR_ADD_PROVIDER_FAILED: ServerAddProviderFailedError,
    _lasso.PROFILE_ERROR_INVALID_HTTP_METHOD: ProfileInvalidHttpMethodError,
    _lasso.PROFILE_ERROR_MISSING_ISSUER: ProfileMissingIssuerError,
    _lasso.XML_ERROR_NODE_CONTENT_NOT_FOUND: XmlNodeContentNotFoundError,
    _lasso.SOAP_ERROR_MISSING_HEADER: SoapMissingHeaderError,
}

### Constants (both enums and defines)
ERROR_UNDEFINED = _lasso.ERROR_UNDEFINED
ERROR_UNIMPLEMENTED = _lasso.ERROR_UNIMPLEMENTED
XML_ERROR_NODE_NOT_FOUND = _lasso.XML_ERROR_NODE_NOT_FOUND
XML_ERROR_NODE_CONTENT_NOT_FOUND = _lasso.XML_ERROR_NODE_CONTENT_NOT_FOUND
XML_ERROR_ATTR_NOT_FOUND = _lasso.XML_ERROR_ATTR_NOT_FOUND
XML_ERROR_ATTR_VALUE_NOT_FOUND = _lasso.XML_ERROR_ATTR_VALUE_NOT_FOUND
XML_ERROR_INVALID_FILE = _lasso.XML_ERROR_INVALID_FILE
XML_ERROR_OBJECT_CONSTRUCTION_FAILED = _lasso.XML_ERROR_OBJECT_CONSTRUCTION_FAILED
XML_ERROR_MISSING_NAMESPACE = _lasso.XML_ERROR_MISSING_NAMESPACE
DS_ERROR_SIGNATURE_NOT_FOUND = _lasso.DS_ERROR_SIGNATURE_NOT_FOUND
DS_ERROR_INVALID_SIGNATURE = _lasso.DS_ERROR_INVALID_SIGNATURE
DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED = _lasso.DS_ERROR_SIGNATURE_TMPL_CREATION_FAILED
DS_ERROR_CONTEXT_CREATION_FAILED = _lasso.DS_ERROR_CONTEXT_CREATION_FAILED
DS_ERROR_PUBLIC_KEY_LOAD_FAILED = _lasso.DS_ERROR_PUBLIC_KEY_LOAD_FAILED
DS_ERROR_PRIVATE_KEY_LOAD_FAILED = _lasso.DS_ERROR_PRIVATE_KEY_LOAD_FAILED
DS_ERROR_CERTIFICATE_LOAD_FAILED = _lasso.DS_ERROR_CERTIFICATE_LOAD_FAILED
DS_ERROR_SIGNATURE_FAILED = _lasso.DS_ERROR_SIGNATURE_FAILED
DS_ERROR_KEYS_MNGR_CREATION_FAILED = _lasso.DS_ERROR_KEYS_MNGR_CREATION_FAILED
DS_ERROR_KEYS_MNGR_INIT_FAILED = _lasso.DS_ERROR_KEYS_MNGR_INIT_FAILED
DS_ERROR_SIGNATURE_VERIFICATION_FAILED = _lasso.DS_ERROR_SIGNATURE_VERIFICATION_FAILED
DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED = _lasso.DS_ERROR_CA_CERT_CHAIN_LOAD_FAILED
DS_ERROR_INVALID_SIGALG = _lasso.DS_ERROR_INVALID_SIGALG
DS_ERROR_DIGEST_COMPUTE_FAILED = _lasso.DS_ERROR_DIGEST_COMPUTE_FAILED
DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND = _lasso.DS_ERROR_SIGNATURE_TEMPLATE_NOT_FOUND
SERVER_ERROR_PROVIDER_NOT_FOUND = _lasso.SERVER_ERROR_PROVIDER_NOT_FOUND
SERVER_ERROR_ADD_PROVIDER_FAILED = _lasso.SERVER_ERROR_ADD_PROVIDER_FAILED
SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH = _lasso.SERVER_ERROR_ADD_PROVIDER_PROTOCOL_MISMATCH
SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED = _lasso.SERVER_ERROR_SET_ENCRYPTION_PRIVATE_KEY_FAILED
SERVER_ERROR_INVALID_XML = _lasso.SERVER_ERROR_INVALID_XML
LOGOUT_ERROR_UNSUPPORTED_PROFILE = _lasso.LOGOUT_ERROR_UNSUPPORTED_PROFILE
LOGOUT_ERROR_REQUEST_DENIED = _lasso.LOGOUT_ERROR_REQUEST_DENIED
LOGOUT_ERROR_FEDERATION_NOT_FOUND = _lasso.LOGOUT_ERROR_FEDERATION_NOT_FOUND
LOGOUT_ERROR_UNKNOWN_PRINCIPAL = _lasso.LOGOUT_ERROR_UNKNOWN_PRINCIPAL
PROFILE_ERROR_INVALID_QUERY = _lasso.PROFILE_ERROR_INVALID_QUERY
PROFILE_ERROR_INVALID_POST_MSG = _lasso.PROFILE_ERROR_INVALID_POST_MSG
PROFILE_ERROR_INVALID_SOAP_MSG = _lasso.PROFILE_ERROR_INVALID_SOAP_MSG
PROFILE_ERROR_MISSING_REQUEST = _lasso.PROFILE_ERROR_MISSING_REQUEST
PROFILE_ERROR_INVALID_HTTP_METHOD = _lasso.PROFILE_ERROR_INVALID_HTTP_METHOD
PROFILE_ERROR_INVALID_PROTOCOLPROFILE = _lasso.PROFILE_ERROR_INVALID_PROTOCOLPROFILE
PROFILE_ERROR_INVALID_MSG = _lasso.PROFILE_ERROR_INVALID_MSG
PROFILE_ERROR_MISSING_REMOTE_PROVIDERID = _lasso.PROFILE_ERROR_MISSING_REMOTE_PROVIDERID
PROFILE_ERROR_UNSUPPORTED_PROFILE = _lasso.PROFILE_ERROR_UNSUPPORTED_PROFILE
PROFILE_ERROR_UNKNOWN_PROFILE_URL = _lasso.PROFILE_ERROR_UNKNOWN_PROFILE_URL
PROFILE_ERROR_IDENTITY_NOT_FOUND = _lasso.PROFILE_ERROR_IDENTITY_NOT_FOUND
PROFILE_ERROR_FEDERATION_NOT_FOUND = _lasso.PROFILE_ERROR_FEDERATION_NOT_FOUND
PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND = _lasso.PROFILE_ERROR_NAME_IDENTIFIER_NOT_FOUND
PROFILE_ERROR_BUILDING_QUERY_FAILED = _lasso.PROFILE_ERROR_BUILDING_QUERY_FAILED
PROFILE_ERROR_BUILDING_REQUEST_FAILED = _lasso.PROFILE_ERROR_BUILDING_REQUEST_FAILED
PROFILE_ERROR_BUILDING_MESSAGE_FAILED = _lasso.PROFILE_ERROR_BUILDING_MESSAGE_FAILED
PROFILE_ERROR_BUILDING_RESPONSE_FAILED = _lasso.PROFILE_ERROR_BUILDING_RESPONSE_FAILED
PROFILE_ERROR_SESSION_NOT_FOUND = _lasso.PROFILE_ERROR_SESSION_NOT_FOUND
PROFILE_ERROR_BAD_IDENTITY_DUMP = _lasso.PROFILE_ERROR_BAD_IDENTITY_DUMP
PROFILE_ERROR_BAD_SESSION_DUMP = _lasso.PROFILE_ERROR_BAD_SESSION_DUMP
PROFILE_ERROR_MISSING_RESPONSE = _lasso.PROFILE_ERROR_MISSING_RESPONSE
PROFILE_ERROR_MISSING_STATUS_CODE = _lasso.PROFILE_ERROR_MISSING_STATUS_CODE
PROFILE_ERROR_MISSING_ARTIFACT = _lasso.PROFILE_ERROR_MISSING_ARTIFACT
PROFILE_ERROR_MISSING_RESOURCE_OFFERING = _lasso.PROFILE_ERROR_MISSING_RESOURCE_OFFERING
PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION = _lasso.PROFILE_ERROR_MISSING_SERVICE_DESCRIPTION
PROFILE_ERROR_MISSING_SERVICE_TYPE = _lasso.PROFILE_ERROR_MISSING_SERVICE_TYPE
PROFILE_ERROR_MISSING_ASSERTION = _lasso.PROFILE_ERROR_MISSING_ASSERTION
PROFILE_ERROR_MISSING_SUBJECT = _lasso.PROFILE_ERROR_MISSING_SUBJECT
PROFILE_ERROR_MISSING_NAME_IDENTIFIER = _lasso.PROFILE_ERROR_MISSING_NAME_IDENTIFIER
PROFILE_ERROR_INVALID_ARTIFACT = _lasso.PROFILE_ERROR_INVALID_ARTIFACT
PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY = _lasso.PROFILE_ERROR_MISSING_ENCRYPTION_PRIVATE_KEY
PROFILE_ERROR_STATUS_NOT_SUCCESS = _lasso.PROFILE_ERROR_STATUS_NOT_SUCCESS
PROFILE_ERROR_MISSING_ISSUER = _lasso.PROFILE_ERROR_MISSING_ISSUER
PROFILE_ERROR_MISSING_SERVICE_INSTANCE = _lasso.PROFILE_ERROR_MISSING_SERVICE_INSTANCE
PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE = _lasso.PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE
PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS = _lasso.PROFILE_ERROR_MISSING_ENDPOINT_REFERENCE_ADDRESS
PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ = _lasso.PARAM_ERROR_BAD_TYPE_OR_NULL_OBJ
PARAM_ERROR_INVALID_VALUE = _lasso.PARAM_ERROR_INVALID_VALUE
PARAM_ERROR_CHECK_FAILED = _lasso.PARAM_ERROR_CHECK_FAILED
PARAM_ERROR_NON_INITIALIZED_OBJECT = _lasso.PARAM_ERROR_NON_INITIALIZED_OBJECT
LOGIN_ERROR_FEDERATION_NOT_FOUND = _lasso.LOGIN_ERROR_FEDERATION_NOT_FOUND
LOGIN_ERROR_CONSENT_NOT_OBTAINED = _lasso.LOGIN_ERROR_CONSENT_NOT_OBTAINED
LOGIN_ERROR_INVALID_NAMEIDPOLICY = _lasso.LOGIN_ERROR_INVALID_NAMEIDPOLICY
LOGIN_ERROR_REQUEST_DENIED = _lasso.LOGIN_ERROR_REQUEST_DENIED
LOGIN_ERROR_INVALID_SIGNATURE = _lasso.LOGIN_ERROR_INVALID_SIGNATURE
LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST = _lasso.LOGIN_ERROR_UNSIGNED_AUTHN_REQUEST
LOGIN_ERROR_STATUS_NOT_SUCCESS = _lasso.LOGIN_ERROR_STATUS_NOT_SUCCESS
LOGIN_ERROR_UNKNOWN_PRINCIPAL = _lasso.LOGIN_ERROR_UNKNOWN_PRINCIPAL
LOGIN_ERROR_NO_DEFAULT_ENDPOINT = _lasso.LOGIN_ERROR_NO_DEFAULT_ENDPOINT
LOGIN_ERROR_ASSERTION_REPLAY = _lasso.LOGIN_ERROR_ASSERTION_REPLAY
DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER = _lasso.DEFEDERATION_ERROR_MISSING_NAME_IDENTIFIER
SOAP_FAULT_REDIRECT_REQUEST = _lasso.SOAP_FAULT_REDIRECT_REQUEST
SOAP_ERROR_MISSING_ENVELOPE = _lasso.SOAP_ERROR_MISSING_ENVELOPE
SOAP_ERROR_MISSING_HEADER = _lasso.SOAP_ERROR_MISSING_HEADER
SOAP_ERROR_MISSING_BODY = _lasso.SOAP_ERROR_MISSING_BODY
SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL = _lasso.SOAP_ERROR_MISSING_SOAP_FAULT_DETAIL
NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE = _lasso.NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_NAMESPACE
NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE = _lasso.NAME_IDENTIFIER_MAPPING_ERROR_FORBIDDEN_CALL_ON_THIS_SIDE
NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER = _lasso.NAME_IDENTIFIER_MAPPING_ERROR_MISSING_TARGET_IDENTIFIER
DATA_SERVICE_ERROR_UNREGISTERED_DST = _lasso.DATA_SERVICE_ERROR_UNREGISTERED_DST
WSF_PROFILE_ERROR_MISSING_CORRELATION = _lasso.WSF_PROFILE_ERROR_MISSING_CORRELATION
WSF_PROFILE_ERROR_MISSING_SECURITY = _lasso.WSF_PROFILE_ERROR_MISSING_SECURITY
WSF_PROFILE_ERROR_MISSING_ASSERTION_ID = _lasso.WSF_PROFILE_ERROR_MISSING_ASSERTION_ID
WSF_PROFILE_ERROR_MISSING_ENDPOINT = _lasso.WSF_PROFILE_ERROR_MISSING_ENDPOINT
WSF_PROFILE_ERROR_SOAP_FAULT = _lasso.WSF_PROFILE_ERROR_SOAP_FAULT
WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM = _lasso.WSF_PROFILE_ERROR_UNSUPPORTED_SECURITY_MECHANISM
DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED = _lasso.DISCOVERY_ERROR_SVC_METADATA_REGISTER_FAILED
DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED = _lasso.DISCOVERY_ERROR_SVC_METADATA_ASSOCIATION_ADD_FAILED
DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE = _lasso.DISCOVERY_ERROR_MISSING_REQUESTED_SERVICE
DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE = _lasso.DISCOVERY_ERROR_FAILED_TO_BUILD_ENDPOINT_REFERENCE
DST_ERROR_MISSING_SERVICE_DATA = _lasso.DST_ERROR_MISSING_SERVICE_DATA
DST_ERROR_QUERY_FAILED = _lasso.DST_ERROR_QUERY_FAILED
DST_ERROR_QUERY_PARTIALLY_FAILED = _lasso.DST_ERROR_QUERY_PARTIALLY_FAILED
DST_ERROR_MODIFY_FAILED = _lasso.DST_ERROR_MODIFY_FAILED
DST_ERROR_MODIFY_PARTIALLY_FAILED = _lasso.DST_ERROR_MODIFY_PARTIALLY_FAILED
DST_ERROR_NEW_DATA_MISSING = _lasso.DST_ERROR_NEW_DATA_MISSING
CHECK_VERSION_EXACT = _lasso.CHECK_VERSION_EXACT
CHECK_VERSIONABI_COMPATIBLE = _lasso.CHECK_VERSIONABI_COMPATIBLE
CHECK_VERSION_NUMERIC = _lasso.CHECK_VERSION_NUMERIC
MESSAGE_FORMAT_ERROR = _lasso.MESSAGE_FORMAT_ERROR
MESSAGE_FORMAT_UNKNOWN = _lasso.MESSAGE_FORMAT_UNKNOWN
MESSAGE_FORMAT_XML = _lasso.MESSAGE_FORMAT_XML
MESSAGE_FORMAT_BASE64 = _lasso.MESSAGE_FORMAT_BASE64
MESSAGE_FORMAT_QUERY = _lasso.MESSAGE_FORMAT_QUERY
MESSAGE_FORMAT_SOAP = _lasso.MESSAGE_FORMAT_SOAP
SIGNATURE_TYPE_NONE = _lasso.SIGNATURE_TYPE_NONE
SIGNATURE_TYPE_SIMPLE = _lasso.SIGNATURE_TYPE_SIMPLE
SIGNATURE_TYPE_WITHX509 = _lasso.SIGNATURE_TYPE_WITHX509
SIGNATURE_METHOD_RSA_SHA1 = _lasso.SIGNATURE_METHOD_RSA_SHA1
SIGNATURE_METHOD_DSA_SHA1 = _lasso.SIGNATURE_METHOD_DSA_SHA1
ENCRYPTION_SYM_KEY_TYPE_DEFAULT = _lasso.ENCRYPTION_SYM_KEY_TYPE_DEFAULT
ENCRYPTION_SYM_KEY_TYPE_AES_256 = _lasso.ENCRYPTION_SYM_KEY_TYPE_AES_256
ENCRYPTION_SYM_KEY_TYPE_AES_128 = _lasso.ENCRYPTION_SYM_KEY_TYPE_AES_128
ENCRYPTION_SYM_KEY_TYPE_3DES = _lasso.ENCRYPTION_SYM_KEY_TYPE_3DES
DS_HREF = _lasso.DS_HREF
DS_PREFIX = _lasso.DS_PREFIX
LASSO_HREF = _lasso.LASSO_HREF
LASSO_PREFIX = _lasso.LASSO_PREFIX
LIB_HREF = _lasso.LIB_HREF
LIB_PREFIX = _lasso.LIB_PREFIX
LIB_MAJOR_VERSION_N = _lasso.LIB_MAJOR_VERSION_N
LIB_MINOR_VERSION_N = _lasso.LIB_MINOR_VERSION_N
LIB_NAMEID_POLICY_TYPE_NONE = _lasso.LIB_NAMEID_POLICY_TYPE_NONE
LIB_NAMEID_POLICY_TYPE_ONE_TIME = _lasso.LIB_NAMEID_POLICY_TYPE_ONE_TIME
LIB_NAMEID_POLICY_TYPE_FEDERATED = _lasso.LIB_NAMEID_POLICY_TYPE_FEDERATED
LIB_NAMEID_POLICY_TYPE_ANY = _lasso.LIB_NAMEID_POLICY_TYPE_ANY
LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL
LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL_PASSWORD = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_INTERNET_PROTOCOL_PASSWORD
LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_UNREGISTERED = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_UNREGISTERED
LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_UNREGISTERED = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_UNREGISTERED
LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_CONTRACT = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_ONE_FACTOR_CONTRACT
LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_CONTRACT = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_MOBILE_TWO_FACTOR_CONTRACT
LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD
LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD_PROTECTED_TRANSPORT = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_PASSWORD_PROTECTED_TRANSPORT
LIB_AUTHN_CONTEXT_CLASS_REF_PREVIOUS_SESSION = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_PREVIOUS_SESSION
LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD
LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD_PKI = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_SMARTCARD_PKI
LIB_AUTHN_CONTEXT_CLASS_REF_SOFTWARE_PKI = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_SOFTWARE_PKI
LIB_AUTHN_CONTEXT_CLASS_REF_TIME_SYNC_TOKEN = _lasso.LIB_AUTHN_CONTEXT_CLASS_REF_TIME_SYNC_TOKEN
LIB_AUTHN_CONTEXT_COMPARISON_EXACT = _lasso.LIB_AUTHN_CONTEXT_COMPARISON_EXACT
LIB_AUTHN_CONTEXT_COMPARISON_MINIMUM = _lasso.LIB_AUTHN_CONTEXT_COMPARISON_MINIMUM
LIB_AUTHN_CONTEXT_COMPARISON_MAXIMUM = _lasso.LIB_AUTHN_CONTEXT_COMPARISON_MAXIMUM
LIB_AUTHN_CONTEXT_COMPARISON_BETTER = _lasso.LIB_AUTHN_CONTEXT_COMPARISON_BETTER
LIB_STATUS_CODE_FEDERATION_DOES_NOT_EXIST = _lasso.LIB_STATUS_CODE_FEDERATION_DOES_NOT_EXIST
LIB_STATUS_CODE_INVALID_ASSERTION_CONSUMER_SERVICE_INDEX = _lasso.LIB_STATUS_CODE_INVALID_ASSERTION_CONSUMER_SERVICE_INDEX
LIB_STATUS_CODE_INVALID_SIGNATURE = _lasso.LIB_STATUS_CODE_INVALID_SIGNATURE
LIB_STATUS_CODE_NO_AUTHN_CONTEXT = _lasso.LIB_STATUS_CODE_NO_AUTHN_CONTEXT
LIB_STATUS_CODE_NO_AVAILABLEIDP = _lasso.LIB_STATUS_CODE_NO_AVAILABLEIDP
LIB_STATUS_CODE_NO_PASSIVE = _lasso.LIB_STATUS_CODE_NO_PASSIVE
LIB_STATUS_CODE_NO_SUPPORTEDIDP = _lasso.LIB_STATUS_CODE_NO_SUPPORTEDIDP
LIB_STATUS_CODE_PROXY_COUNT_EXCEEDED = _lasso.LIB_STATUS_CODE_PROXY_COUNT_EXCEEDED
LIB_STATUS_CODE_UNKNOWN_PRINCIPAL = _lasso.LIB_STATUS_CODE_UNKNOWN_PRINCIPAL
LIB_STATUS_CODE_UNSIGNED_AUTHN_REQUEST = _lasso.LIB_STATUS_CODE_UNSIGNED_AUTHN_REQUEST
LIB_STATUS_CODE_UNSUPPORTED_PROFILE = _lasso.LIB_STATUS_CODE_UNSUPPORTED_PROFILE
LIB_PROTOCOL_PROFILE_BRWS_ART = _lasso.LIB_PROTOCOL_PROFILE_BRWS_ART
LIB_PROTOCOL_PROFILE_BRWS_POST = _lasso.LIB_PROTOCOL_PROFILE_BRWS_POST
LIB_PROTOCOL_PROFILE_BRWS_LECP = _lasso.LIB_PROTOCOL_PROFILE_BRWS_LECP
LIB_PROTOCOL_PROFILE_FED_TERM_IDP_HTTP = _lasso.LIB_PROTOCOL_PROFILE_FED_TERM_IDP_HTTP
LIB_PROTOCOL_PROFILE_FED_TERM_IDP_SOAP = _lasso.LIB_PROTOCOL_PROFILE_FED_TERM_IDP_SOAP
LIB_PROTOCOL_PROFILE_FED_TERM_SP_HTTP = _lasso.LIB_PROTOCOL_PROFILE_FED_TERM_SP_HTTP
LIB_PROTOCOL_PROFILE_FED_TERM_SP_SOAP = _lasso.LIB_PROTOCOL_PROFILE_FED_TERM_SP_SOAP
LIB_PROTOCOL_PROFILE_NIM_SP_HTTP = _lasso.LIB_PROTOCOL_PROFILE_NIM_SP_HTTP
LIB_PROTOCOL_PROFILE_RNI_IDP_HTTP = _lasso.LIB_PROTOCOL_PROFILE_RNI_IDP_HTTP
LIB_PROTOCOL_PROFILE_RNI_IDP_SOAP = _lasso.LIB_PROTOCOL_PROFILE_RNI_IDP_SOAP
LIB_PROTOCOL_PROFILE_RNI_SP_HTTP = _lasso.LIB_PROTOCOL_PROFILE_RNI_SP_HTTP
LIB_PROTOCOL_PROFILE_RNI_SP_SOAP = _lasso.LIB_PROTOCOL_PROFILE_RNI_SP_SOAP
LIB_PROTOCOL_PROFILE_SLO_SP_HTTP = _lasso.LIB_PROTOCOL_PROFILE_SLO_SP_HTTP
LIB_PROTOCOL_PROFILE_SLO_SP_SOAP = _lasso.LIB_PROTOCOL_PROFILE_SLO_SP_SOAP
LIB_PROTOCOL_PROFILE_SLO_IDP_HTTP = _lasso.LIB_PROTOCOL_PROFILE_SLO_IDP_HTTP
LIB_PROTOCOL_PROFILE_SLO_IDP_SOAP = _lasso.LIB_PROTOCOL_PROFILE_SLO_IDP_SOAP
LIB_NAME_IDENTIFIER_FORMAT_FEDERATED = _lasso.LIB_NAME_IDENTIFIER_FORMAT_FEDERATED
LIB_NAME_IDENTIFIER_FORMAT_ONE_TIME = _lasso.LIB_NAME_IDENTIFIER_FORMAT_ONE_TIME
LIB_NAME_IDENTIFIER_FORMAT_ENCRYPTED = _lasso.LIB_NAME_IDENTIFIER_FORMAT_ENCRYPTED
LIB_NAME_IDENTIFIER_FORMAT_ENTITYID = _lasso.LIB_NAME_IDENTIFIER_FORMAT_ENTITYID
LIB_CONSENT_OBTAINED = _lasso.LIB_CONSENT_OBTAINED
LIB_CONSENT_OBTAINED_PRIOR = _lasso.LIB_CONSENT_OBTAINED_PRIOR
LIB_CONSENT_OBTAINED_CURRENT_IMPLICIT = _lasso.LIB_CONSENT_OBTAINED_CURRENT_IMPLICIT
LIB_CONSENT_OBTAINED_CURRENT_EXPLICIT = _lasso.LIB_CONSENT_OBTAINED_CURRENT_EXPLICIT
LIB_CONSENT_UNAVAILABLE = _lasso.LIB_CONSENT_UNAVAILABLE
LIB_CONSENT_INAPPLICABLE = _lasso.LIB_CONSENT_INAPPLICABLE
SECURITY_MECH_NULL = _lasso.SECURITY_MECH_NULL
SECURITY_MECH_X509 = _lasso.SECURITY_MECH_X509
SECURITY_MECH_SAML = _lasso.SECURITY_MECH_SAML
SECURITY_MECH_BEARER = _lasso.SECURITY_MECH_BEARER
SECURITY_MECH_TLS = _lasso.SECURITY_MECH_TLS
SECURITY_MECH_TLS_X509 = _lasso.SECURITY_MECH_TLS_X509
SECURITY_MECH_TLS_SAML = _lasso.SECURITY_MECH_TLS_SAML
SECURITY_MECH_TLS_BEARER = _lasso.SECURITY_MECH_TLS_BEARER
SECURITY_MECH_CLIENT_TLS = _lasso.SECURITY_MECH_CLIENT_TLS
SECURITY_MECH_CLIENT_TLS_X509 = _lasso.SECURITY_MECH_CLIENT_TLS_X509
SECURITY_MECH_CLIENT_TLS_SAML = _lasso.SECURITY_MECH_CLIENT_TLS_SAML
SECURITY_MECH_CLIENT_TLS_BEARER = _lasso.SECURITY_MECH_CLIENT_TLS_BEARER
DISCO_HREF = _lasso.DISCO_HREF
DISCO_PREFIX = _lasso.DISCO_PREFIX
EP_HREF = _lasso.EP_HREF
EP_PREFIX = _lasso.EP_PREFIX
PP_HREF = _lasso.PP_HREF
PP_PREFIX = _lasso.PP_PREFIX
IS_HREF = _lasso.IS_HREF
IS_PREFIX = _lasso.IS_PREFIX
SA_HREF = _lasso.SA_HREF
SA_PREFIX = _lasso.SA_PREFIX
SEC_HREF = _lasso.SEC_HREF
SEC_PREFIX = _lasso.SEC_PREFIX
SA_SASL_SERVICE_NAME = _lasso.SA_SASL_SERVICE_NAME
IS_INTERACT_ATTR_INTERACT_IF_NEEDED = _lasso.IS_INTERACT_ATTR_INTERACT_IF_NEEDED
IS_INTERACT_ATTR_DO_NOT_INTERACT = _lasso.IS_INTERACT_ATTR_DO_NOT_INTERACT
IS_INTERACT_ATTR_DO_NOT_INTERACT_FOR_DATA = _lasso.IS_INTERACT_ATTR_DO_NOT_INTERACT_FOR_DATA
DISCO_STATUS_CODE_OK = _lasso.DISCO_STATUS_CODE_OK
DISCO_STATUS_CODE_FAILED = _lasso.DISCO_STATUS_CODE_FAILED
DISCO_STATUS_CODE_REMOVE_ENTRY = _lasso.DISCO_STATUS_CODE_REMOVE_ENTRY
DISCO_STATUS_CODE_FORBIDDEN = _lasso.DISCO_STATUS_CODE_FORBIDDEN
DISCO_STATUS_CODE_NO_RESULTS = _lasso.DISCO_STATUS_CODE_NO_RESULTS
DISCO_STATUS_CODE_DIRECTIVES = _lasso.DISCO_STATUS_CODE_DIRECTIVES
DST_STATUS_CODE_OK = _lasso.DST_STATUS_CODE_OK
DST_STATUS_CODE_FAILED = _lasso.DST_STATUS_CODE_FAILED
DST_STATUS_CODE_PARTIAL = _lasso.DST_STATUS_CODE_PARTIAL
DST_STATUS_CODE_ACTION_NOT_AUTHORIZED = _lasso.DST_STATUS_CODE_ACTION_NOT_AUTHORIZED
DST_STATUS_CODE_ACTION_NOT_SUPPORTED = _lasso.DST_STATUS_CODE_ACTION_NOT_SUPPORTED
DST_STATUS_CODE_ALL_RETURNED = _lasso.DST_STATUS_CODE_ALL_RETURNED
DST_STATUS_CODE_CHANGE_HISTORY_NOT_SUPPORTED = _lasso.DST_STATUS_CODE_CHANGE_HISTORY_NOT_SUPPORTED
DST_STATUS_CODE_CHANGED_SINCE_RETURNS_ALL = _lasso.DST_STATUS_CODE_CHANGED_SINCE_RETURNS_ALL
DST_STATUS_CODE_DATA_TOO_LONG = _lasso.DST_STATUS_CODE_DATA_TOO_LONG
DST_STATUS_CODE_EXISTS_ALREADY = _lasso.DST_STATUS_CODE_EXISTS_ALREADY
DST_STATUS_CODE_EXTENSION_NOT_SUPPORTED = _lasso.DST_STATUS_CODE_EXTENSION_NOT_SUPPORTED
DST_STATUS_CODE_INVALID_DATA = _lasso.DST_STATUS_CODE_INVALID_DATA
DST_STATUS_CODE_INVALID_RESOURCE_ID = _lasso.DST_STATUS_CODE_INVALID_RESOURCE_ID
DST_STATUS_CODE_INVALID_SELECT = _lasso.DST_STATUS_CODE_INVALID_SELECT
DST_STATUS_CODE_MISSING_NEW_DATA_ELEMENT = _lasso.DST_STATUS_CODE_MISSING_NEW_DATA_ELEMENT
DST_STATUS_CODE_MISSING_RESOURCE_ID_ELEMENT = _lasso.DST_STATUS_CODE_MISSING_RESOURCE_ID_ELEMENT
DST_STATUS_CODE_MISSING_SELECT = _lasso.DST_STATUS_CODE_MISSING_SELECT
DST_STATUS_CODE_MODIFIED_SINCE = _lasso.DST_STATUS_CODE_MODIFIED_SINCE
DST_STATUS_CODE_NO_MORE_ELEMENTS = _lasso.DST_STATUS_CODE_NO_MORE_ELEMENTS
DST_STATUS_CODE_NO_MULTIPLE_ALLOWED = _lasso.DST_STATUS_CODE_NO_MULTIPLE_ALLOWED
DST_STATUS_CODE_NO_MULTIPLE_RESOURCES = _lasso.DST_STATUS_CODE_NO_MULTIPLE_RESOURCES
DST_STATUS_CODE_TIME_OUT = _lasso.DST_STATUS_CODE_TIME_OUT
DST_STATUS_CODE_UNEXPECTED_ERROR = _lasso.DST_STATUS_CODE_UNEXPECTED_ERROR
SA_STATUS_CODE_OK = _lasso.SA_STATUS_CODE_OK
SA_STATUS_CODE_CONTINUE = _lasso.SA_STATUS_CODE_CONTINUE
SA_STATUS_CODE_ABORT = _lasso.SA_STATUS_CODE_ABORT
METADATA_HREF = _lasso.METADATA_HREF
METADATA_PREFIX = _lasso.METADATA_PREFIX
SAML_ASSERTION_HREF = _lasso.SAML_ASSERTION_HREF
SAML_ASSERTION_PREFIX = _lasso.SAML_ASSERTION_PREFIX
SAML_PROTOCOL_HREF = _lasso.SAML_PROTOCOL_HREF
SAML_PROTOCOL_PREFIX = _lasso.SAML_PROTOCOL_PREFIX
SAML_MAJOR_VERSION_N = _lasso.SAML_MAJOR_VERSION_N
SAML_MINOR_VERSION_N = _lasso.SAML_MINOR_VERSION_N
SAML_STATUS_CODE_SUCCESS = _lasso.SAML_STATUS_CODE_SUCCESS
SAML_STATUS_CODE_REQUEST_DENIED = _lasso.SAML_STATUS_CODE_REQUEST_DENIED
SAML_STATUS_CODE_VERSION_MISMATCH = _lasso.SAML_STATUS_CODE_VERSION_MISMATCH
SAML_STATUS_CODE_REQUESTER = _lasso.SAML_STATUS_CODE_REQUESTER
SAML_STATUS_CODE_RESPONDER = _lasso.SAML_STATUS_CODE_RESPONDER
SAML_STATUS_CODE_REQUEST_VERSION_TOO_HIGH = _lasso.SAML_STATUS_CODE_REQUEST_VERSION_TOO_HIGH
SAML_STATUS_CODE_REQUEST_VERSION_TOO_LOW = _lasso.SAML_STATUS_CODE_REQUEST_VERSION_TOO_LOW
SAML_STATUS_CODE_REQUEST_VERSION_DEPRECATED = _lasso.SAML_STATUS_CODE_REQUEST_VERSION_DEPRECATED
SAML_STATUS_CODE_TOO_MANY_RESPONSES = _lasso.SAML_STATUS_CODE_TOO_MANY_RESPONSES
SAML_STATUS_CODE_RESOURCE_NOT_RECOGNIZED = _lasso.SAML_STATUS_CODE_RESOURCE_NOT_RECOGNIZED
SAML_AUTHENTICATION_METHOD_PASSWORD = _lasso.SAML_AUTHENTICATION_METHOD_PASSWORD
SAML_AUTHENTICATION_METHOD_KERBEROS = _lasso.SAML_AUTHENTICATION_METHOD_KERBEROS
SAML_AUTHENTICATION_METHOD_SECURE_REMOTE_PASSWORD = _lasso.SAML_AUTHENTICATION_METHOD_SECURE_REMOTE_PASSWORD
SAML_AUTHENTICATION_METHOD_HARDWARE_TOKEN = _lasso.SAML_AUTHENTICATION_METHOD_HARDWARE_TOKEN
SAML_AUTHENTICATION_METHOD_SMARTCARD_PKI = _lasso.SAML_AUTHENTICATION_METHOD_SMARTCARD_PKI
SAML_AUTHENTICATION_METHOD_SOFTWARE_PKI = _lasso.SAML_AUTHENTICATION_METHOD_SOFTWARE_PKI
SAML_AUTHENTICATION_METHOD_PGP = _lasso.SAML_AUTHENTICATION_METHOD_PGP
SAML_AUTHENTICATION_METHODS_PKI = _lasso.SAML_AUTHENTICATION_METHODS_PKI
SAML_AUTHENTICATION_METHOD_XKMS = _lasso.SAML_AUTHENTICATION_METHOD_XKMS
SAML_AUTHENTICATION_METHOD_XMLD_SIG = _lasso.SAML_AUTHENTICATION_METHOD_XMLD_SIG
SAML_AUTHENTICATION_METHOD_UNSPECIFIED = _lasso.SAML_AUTHENTICATION_METHOD_UNSPECIFIED
SAML_AUTHENTICATION_METHOD_LIBERTY = _lasso.SAML_AUTHENTICATION_METHOD_LIBERTY
SAML_CONFIRMATION_METHOD_ARTIFACT = _lasso.SAML_CONFIRMATION_METHOD_ARTIFACT
SAML_CONFIRMATION_METHOD_ARTIFACT01 = _lasso.SAML_CONFIRMATION_METHOD_ARTIFACT01
SAML_CONFIRMATION_METHOD_BEARER = _lasso.SAML_CONFIRMATION_METHOD_BEARER
SAML_CONFIRMATION_METHOD_HOLDER_OF_KEY = _lasso.SAML_CONFIRMATION_METHOD_HOLDER_OF_KEY
SAML_CONFIRMATION_METHOD_SENDER_VOUCHES = _lasso.SAML_CONFIRMATION_METHOD_SENDER_VOUCHES
SOAP_ENV_HREF = _lasso.SOAP_ENV_HREF
SOAP_ENV_PREFIX = _lasso.SOAP_ENV_PREFIX
SOAP_ENV_ACTOR = _lasso.SOAP_ENV_ACTOR
SOAP_BINDING_HREF = _lasso.SOAP_BINDING_HREF
SOAP_BINDING_PREFIX = _lasso.SOAP_BINDING_PREFIX
IDWSF2_SB2_HREF = _lasso.IDWSF2_SB2_HREF
IDWSF2_SB2_PREFIX = _lasso.IDWSF2_SB2_PREFIX
IDWSF2_SBF_HREF = _lasso.IDWSF2_SBF_HREF
IDWSF2_SBF_PREFIX = _lasso.IDWSF2_SBF_PREFIX
SOAP_BINDING_EXT_HREF = _lasso.SOAP_BINDING_EXT_HREF
SOAP_BINDING_EXT_PREFIX = _lasso.SOAP_BINDING_EXT_PREFIX
WSSE_HREF = _lasso.WSSE_HREF
WSSE_PREFIX = _lasso.WSSE_PREFIX
WSSE1_HREF = _lasso.WSSE1_HREF
WSSE1_PREFIX = _lasso.WSSE1_PREFIX
WSUTIL1_HREF = _lasso.WSUTIL1_HREF
WSUTIL1_PREFIX = _lasso.WSUTIL1_PREFIX
SOAP_BINDING_PROCESS_CONTEXT_PRINCIPAL_OFFLINE = _lasso.SOAP_BINDING_PROCESS_CONTEXT_PRINCIPAL_OFFLINE
SOAP_BINDING_PROCESS_CONTEXT_PRINCIPAL_ONLINE = _lasso.SOAP_BINDING_PROCESS_CONTEXT_PRINCIPAL_ONLINE
SOAP_BINDING_PROCESS_CONTEXT_SIMULATE = _lasso.SOAP_BINDING_PROCESS_CONTEXT_SIMULATE
PAOS_HREF = _lasso.PAOS_HREF
PAOS_PREFIX = _lasso.PAOS_PREFIX
ECP_HREF = _lasso.ECP_HREF
ECP_PREFIX = _lasso.ECP_PREFIX
SAML2_METADATA_HREF = _lasso.SAML2_METADATA_HREF
SAML2_METADATA_BINDING_SOAP = _lasso.SAML2_METADATA_BINDING_SOAP
SAML2_METADATA_BINDING_REDIRECT = _lasso.SAML2_METADATA_BINDING_REDIRECT
SAML2_METADATA_BINDING_POST = _lasso.SAML2_METADATA_BINDING_POST
SAML2_METADATA_BINDING_ARTIFACT = _lasso.SAML2_METADATA_BINDING_ARTIFACT
SAML2_METADATA_BINDING_PAOS = _lasso.SAML2_METADATA_BINDING_PAOS
SAML2_PROTOCOL_HREF = _lasso.SAML2_PROTOCOL_HREF
SAML2_PROTOCOL_PREFIX = _lasso.SAML2_PROTOCOL_PREFIX
SAML2_ASSERTION_HREF = _lasso.SAML2_ASSERTION_HREF
SAML2_ASSERTION_PREFIX = _lasso.SAML2_ASSERTION_PREFIX
SAML2_DEFLATE_ENCODING = _lasso.SAML2_DEFLATE_ENCODING
SAML2_NAME_IDENTIFIER_FORMAT_UNSPECIFIED = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_UNSPECIFIED
SAML2_NAME_IDENTIFIER_FORMAT_EMAIL = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_EMAIL
SAML2_NAME_IDENTIFIER_FORMAT_X509 = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_X509
SAML2_NAME_IDENTIFIER_FORMAT_WINDOWS = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_WINDOWS
SAML2_NAME_IDENTIFIER_FORMAT_KERBEROS = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_KERBEROS
SAML2_NAME_IDENTIFIER_FORMAT_ENTITY = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_ENTITY
SAML2_NAME_IDENTIFIER_FORMAT_PERSISTENT = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_PERSISTENT
SAML2_NAME_IDENTIFIER_FORMAT_TRANSIENT = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_TRANSIENT
SAML2_NAME_IDENTIFIER_FORMAT_ENCRYPTED = _lasso.SAML2_NAME_IDENTIFIER_FORMAT_ENCRYPTED
SAML2_ATTRIBUTE_NAME_EPR = _lasso.SAML2_ATTRIBUTE_NAME_EPR
SAML2_ATTRIBUTE_NAME_FORMAT_URI = _lasso.SAML2_ATTRIBUTE_NAME_FORMAT_URI
SAML2_CONSENT_OBTAINED = _lasso.SAML2_CONSENT_OBTAINED
SAML2_CONSENT_PRIOR = _lasso.SAML2_CONSENT_PRIOR
SAML2_CONSENT_IMPLICIT = _lasso.SAML2_CONSENT_IMPLICIT
SAML2_CONSENT_EXPLICIT = _lasso.SAML2_CONSENT_EXPLICIT
SAML2_CONSENT_UNAVAILABLE = _lasso.SAML2_CONSENT_UNAVAILABLE
SAML2_CONSENT_INAPPLICABLE = _lasso.SAML2_CONSENT_INAPPLICABLE
SAML2_STATUS_CODE_SUCCESS = _lasso.SAML2_STATUS_CODE_SUCCESS
SAML2_STATUS_CODE_REQUESTER = _lasso.SAML2_STATUS_CODE_REQUESTER
SAML2_STATUS_CODE_RESPONDER = _lasso.SAML2_STATUS_CODE_RESPONDER
SAML2_STATUS_CODE_VERSION_MISMATCH = _lasso.SAML2_STATUS_CODE_VERSION_MISMATCH
SAML2_STATUS_CODE_AUTHN_FAILED = _lasso.SAML2_STATUS_CODE_AUTHN_FAILED
SAML2_STATUS_CODE_INVALID_ATTR_NAME = _lasso.SAML2_STATUS_CODE_INVALID_ATTR_NAME
SAML2_STATUS_CODE_INVALID_NAME_ID_POLICY = _lasso.SAML2_STATUS_CODE_INVALID_NAME_ID_POLICY
SAML2_STATUS_CODE_NO_AUTHN_CONTEXT = _lasso.SAML2_STATUS_CODE_NO_AUTHN_CONTEXT
SAML2_STATUS_CODE_NO_AVAILABLE_IDP = _lasso.SAML2_STATUS_CODE_NO_AVAILABLE_IDP
SAML2_STATUS_CODE_NO_PASSIVE = _lasso.SAML2_STATUS_CODE_NO_PASSIVE
SAML2_STATUS_CODE_NO_SUPPORTED_IDP = _lasso.SAML2_STATUS_CODE_NO_SUPPORTED_IDP
SAML2_STATUS_CODE_PARTIAL_LOGOUT = _lasso.SAML2_STATUS_CODE_PARTIAL_LOGOUT
SAML2_STATUS_CODE_PROXY_COUNT_EXCEEDED = _lasso.SAML2_STATUS_CODE_PROXY_COUNT_EXCEEDED
SAML2_STATUS_CODE_REQUEST_DENIED = _lasso.SAML2_STATUS_CODE_REQUEST_DENIED
SAML2_STATUS_CODE_REQUEST_UNSUPPORTED = _lasso.SAML2_STATUS_CODE_REQUEST_UNSUPPORTED
SAML2_STATUS_CODE_REQUEST_VERSION_DEPRECATED = _lasso.SAML2_STATUS_CODE_REQUEST_VERSION_DEPRECATED
SAML2_STATUS_CODE_REQUEST_VERSION_TOO_HIGH = _lasso.SAML2_STATUS_CODE_REQUEST_VERSION_TOO_HIGH
SAML2_STATUS_CODE_REQUEST_VERSION_TOO_LOW = _lasso.SAML2_STATUS_CODE_REQUEST_VERSION_TOO_LOW
SAML2_STATUS_CODE_RESOURCE_NOT_RECOGNIZED = _lasso.SAML2_STATUS_CODE_RESOURCE_NOT_RECOGNIZED
SAML2_STATUS_CODE_TOO_MANY_RESPONSES = _lasso.SAML2_STATUS_CODE_TOO_MANY_RESPONSES
SAML2_STATUS_CODE_UNKNOWN_ATTR_PROFILE = _lasso.SAML2_STATUS_CODE_UNKNOWN_ATTR_PROFILE
SAML2_STATUS_CODE_UNKNOWN_PRINCIPAL = _lasso.SAML2_STATUS_CODE_UNKNOWN_PRINCIPAL
SAML2_STATUS_CODE_UNSUPPORTED_BINDING = _lasso.SAML2_STATUS_CODE_UNSUPPORTED_BINDING
SAML2_AUTHN_CONTEXT_AUTHENTICATED_TELEPHONY = _lasso.SAML2_AUTHN_CONTEXT_AUTHENTICATED_TELEPHONY
SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL = _lasso.SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL
SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL_PASSWORD = _lasso.SAML2_AUTHN_CONTEXT_INTERNET_PROTOCOL_PASSWORD
SAML2_AUTHN_CONTEXT_KERBEROS = _lasso.SAML2_AUTHN_CONTEXT_KERBEROS
SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_CONTRACT = _lasso.SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_CONTRACT
SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_UNREGISTERED = _lasso.SAML2_AUTHN_CONTEXT_MOBILE_ONE_FACTOR_UNREGISTERED
SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_CONTRACT = _lasso.SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_CONTRACT
SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_UNREGISTERED = _lasso.SAML2_AUTHN_CONTEXT_MOBILE_TWO_FACTOR_UNREGISTERED
SAML2_AUTHN_CONTEXT_NOMAD_TELEPHONY = _lasso.SAML2_AUTHN_CONTEXT_NOMAD_TELEPHONY
SAML2_AUTHN_CONTEXT_PERSONALIZED_TELEPHONY = _lasso.SAML2_AUTHN_CONTEXT_PERSONALIZED_TELEPHONY
SAML2_AUTHN_CONTEXT_PGP = _lasso.SAML2_AUTHN_CONTEXT_PGP
SAML2_AUTHN_CONTEXT_PASSWORD_PROTECTED_TRANSPORT = _lasso.SAML2_AUTHN_CONTEXT_PASSWORD_PROTECTED_TRANSPORT
SAML2_AUTHN_CONTEXT_PASSWORD = _lasso.SAML2_AUTHN_CONTEXT_PASSWORD
SAML2_AUTHN_CONTEXT_PREVIOUS_SESSION = _lasso.SAML2_AUTHN_CONTEXT_PREVIOUS_SESSION
SAML2_AUTHN_CONTEXT_SMARTCARD = _lasso.SAML2_AUTHN_CONTEXT_SMARTCARD
SAML2_AUTHN_CONTEXT_SMARTCARD_PKI = _lasso.SAML2_AUTHN_CONTEXT_SMARTCARD_PKI
SAML2_AUTHN_CONTEXT_SOFTWARE_PKI = _lasso.SAML2_AUTHN_CONTEXT_SOFTWARE_PKI
SAML2_AUTHN_CONTEXT_SPKI = _lasso.SAML2_AUTHN_CONTEXT_SPKI
SAML2_AUTHN_CONTEXT_SECURE_REMOTE_PASSWORD = _lasso.SAML2_AUTHN_CONTEXT_SECURE_REMOTE_PASSWORD
SAML2_AUTHN_CONTEXT_TLS_CLIENT = _lasso.SAML2_AUTHN_CONTEXT_TLS_CLIENT
SAML2_AUTHN_CONTEXT_X509 = _lasso.SAML2_AUTHN_CONTEXT_X509
SAML2_AUTHN_CONTEXT_TELEPHONY = _lasso.SAML2_AUTHN_CONTEXT_TELEPHONY
SAML2_AUTHN_CONTEXT_TIME_SYNC_TOKEN = _lasso.SAML2_AUTHN_CONTEXT_TIME_SYNC_TOKEN
SAML2_AUTHN_CONTEXT_XMLDSIG = _lasso.SAML2_AUTHN_CONTEXT_XMLDSIG
SAML2_CONFIRMATION_METHOD_BEARER = _lasso.SAML2_CONFIRMATION_METHOD_BEARER
IDWSF2_DISCO_HREF = _lasso.IDWSF2_DISCO_HREF
IDWSF2_DISCO_PREFIX = _lasso.IDWSF2_DISCO_PREFIX
IDWSF2_DST_HREF = _lasso.IDWSF2_DST_HREF
IDWSF2_DST_PREFIX = _lasso.IDWSF2_DST_PREFIX
IDWSF2_DSTREF_HREF = _lasso.IDWSF2_DSTREF_HREF
IDWSF2_DSTREF_PREFIX = _lasso.IDWSF2_DSTREF_PREFIX
IDWSF2_IMS_HREF = _lasso.IDWSF2_IMS_HREF
IDWSF2_IMS_PREFIX = _lasso.IDWSF2_IMS_PREFIX
IDWSF2_IS_HREF = _lasso.IDWSF2_IS_HREF
IDWSF2_IS_PREFIX = _lasso.IDWSF2_IS_PREFIX
IDWSF2_PS_HREF = _lasso.IDWSF2_PS_HREF
IDWSF2_PS_PREFIX = _lasso.IDWSF2_PS_PREFIX
IDWSF2_SUBS_HREF = _lasso.IDWSF2_SUBS_HREF
IDWSF2_SUBS_PREFIX = _lasso.IDWSF2_SUBS_PREFIX
IDWSF2_SUBSREF_HREF = _lasso.IDWSF2_SUBSREF_HREF
IDWSF2_SUBSREF_PREFIX = _lasso.IDWSF2_SUBSREF_PREFIX
IDWSF2_UTIL_HREF = _lasso.IDWSF2_UTIL_HREF
IDWSF2_UTIL_PREFIX = _lasso.IDWSF2_UTIL_PREFIX
IDWSF2_SEC_HREF = _lasso.IDWSF2_SEC_HREF
IDWSF2_SEC_PREFIX = _lasso.IDWSF2_SEC_PREFIX
IDWSF2_SOAP_BINDING_HREF = _lasso.IDWSF2_SOAP_BINDING_HREF
IDWSF2_SOAP_BINDING_PREFIX = _lasso.IDWSF2_SOAP_BINDING_PREFIX
IDWSF2_SOAP_BINDING2_HREF = _lasso.IDWSF2_SOAP_BINDING2_HREF
IDWSF2_SOAP_BINDING2_PREFIX = _lasso.IDWSF2_SOAP_BINDING2_PREFIX
XSI_HREF = _lasso.XSI_HREF
XSI_PREFIX = _lasso.XSI_PREFIX
WSA_HREF = _lasso.WSA_HREF
WSA_PREFIX = _lasso.WSA_PREFIX
WSSE_200401_HREF = _lasso.WSSE_200401_HREF
WSSE_200401_PREFIX = _lasso.WSSE_200401_PREFIX
WSU_HREF = _lasso.WSU_HREF
WSU_PREFIX = _lasso.WSU_PREFIX
SOAP_FAULT_CODE_SERVER = _lasso.SOAP_FAULT_CODE_SERVER
SOAP_FAULT_STRING_SERVER = _lasso.SOAP_FAULT_STRING_SERVER
ASSERTION_QUERY_REQUEST_TYPE_UNSET = _lasso.ASSERTION_QUERY_REQUEST_TYPE_UNSET
ASSERTION_QUERY_REQUEST_TYPE_ASSERTION_ID = _lasso.ASSERTION_QUERY_REQUEST_TYPE_ASSERTION_ID
ASSERTION_QUERY_REQUEST_TYPE_AUTHN = _lasso.ASSERTION_QUERY_REQUEST_TYPE_AUTHN
ASSERTION_QUERY_REQUEST_TYPE_ATTRIBUTE = _lasso.ASSERTION_QUERY_REQUEST_TYPE_ATTRIBUTE
ASSERTION_QUERY_REQUEST_TYPE_AUTHZ_DECISION = _lasso.ASSERTION_QUERY_REQUEST_TYPE_AUTHZ_DECISION
REQUEST_TYPE_INVALID = _lasso.REQUEST_TYPE_INVALID
REQUEST_TYPE_LOGIN = _lasso.REQUEST_TYPE_LOGIN
REQUEST_TYPE_LOGOUT = _lasso.REQUEST_TYPE_LOGOUT
REQUEST_TYPE_DEFEDERATION = _lasso.REQUEST_TYPE_DEFEDERATION
REQUEST_TYPE_NAME_REGISTRATION = _lasso.REQUEST_TYPE_NAME_REGISTRATION
REQUEST_TYPE_NAME_IDENTIFIER_MAPPING = _lasso.REQUEST_TYPE_NAME_IDENTIFIER_MAPPING
REQUEST_TYPE_LECP = _lasso.REQUEST_TYPE_LECP
REQUEST_TYPE_DISCO_QUERY = _lasso.REQUEST_TYPE_DISCO_QUERY
REQUEST_TYPE_DISCO_MODIFY = _lasso.REQUEST_TYPE_DISCO_MODIFY
REQUEST_TYPE_DST_QUERY = _lasso.REQUEST_TYPE_DST_QUERY
REQUEST_TYPE_DST_MODIFY = _lasso.REQUEST_TYPE_DST_MODIFY
REQUEST_TYPE_SASL_REQUEST = _lasso.REQUEST_TYPE_SASL_REQUEST
REQUEST_TYPE_NAME_ID_MANAGEMENT = _lasso.REQUEST_TYPE_NAME_ID_MANAGEMENT
REQUEST_TYPE_IDWSF2_DISCO_SVCMD_REGISTER = _lasso.REQUEST_TYPE_IDWSF2_DISCO_SVCMD_REGISTER
REQUEST_TYPE_IDWSF2_DISCO_SVCMD_ASSOCIATION_ADD = _lasso.REQUEST_TYPE_IDWSF2_DISCO_SVCMD_ASSOCIATION_ADD
REQUEST_TYPE_IDWSF2_DISCO_QUERY = _lasso.REQUEST_TYPE_IDWSF2_DISCO_QUERY
HTTP_METHOD_NONE = _lasso.HTTP_METHOD_NONE
HTTP_METHOD_ANY = _lasso.HTTP_METHOD_ANY
HTTP_METHOD_IDP_INITIATED = _lasso.HTTP_METHOD_IDP_INITIATED
HTTP_METHOD_GET = _lasso.HTTP_METHOD_GET
HTTP_METHOD_POST = _lasso.HTTP_METHOD_POST
HTTP_METHOD_REDIRECT = _lasso.HTTP_METHOD_REDIRECT
HTTP_METHOD_SOAP = _lasso.HTTP_METHOD_SOAP
HTTP_METHOD_ARTIFACT_GET = _lasso.HTTP_METHOD_ARTIFACT_GET
HTTP_METHOD_ARTIFACT_POST = _lasso.HTTP_METHOD_ARTIFACT_POST
MD_PROTOCOL_TYPE_FEDERATION_TERMINATION = _lasso.MD_PROTOCOL_TYPE_FEDERATION_TERMINATION
MD_PROTOCOL_TYPE_NAME_IDENTIFIER_MAPPING = _lasso.MD_PROTOCOL_TYPE_NAME_IDENTIFIER_MAPPING
MD_PROTOCOL_TYPE_REGISTER_NAME_IDENTIFIER = _lasso.MD_PROTOCOL_TYPE_REGISTER_NAME_IDENTIFIER
MD_PROTOCOL_TYPE_SINGLE_LOGOUT = _lasso.MD_PROTOCOL_TYPE_SINGLE_LOGOUT
MD_PROTOCOL_TYPE_SINGLE_SIGN_ON = _lasso.MD_PROTOCOL_TYPE_SINGLE_SIGN_ON
MD_PROTOCOL_TYPE_ARTIFACT_RESOLUTION = _lasso.MD_PROTOCOL_TYPE_ARTIFACT_RESOLUTION
MD_PROTOCOL_TYPE_MANAGE_NAME_ID = _lasso.MD_PROTOCOL_TYPE_MANAGE_NAME_ID
MD_PROTOCOL_TYPE_ASSERTION_ID_REQUEST = _lasso.MD_PROTOCOL_TYPE_ASSERTION_ID_REQUEST
PROVIDER_ROLE_NONE = _lasso.PROVIDER_ROLE_NONE
PROVIDER_ROLE_SP = _lasso.PROVIDER_ROLE_SP
PROVIDER_ROLE_IDP = _lasso.PROVIDER_ROLE_IDP
PROTOCOL_NONE = _lasso.PROTOCOL_NONE
PROTOCOL_LIBERTY_1_0 = _lasso.PROTOCOL_LIBERTY_1_0
PROTOCOL_LIBERTY_1_1 = _lasso.PROTOCOL_LIBERTY_1_1
PROTOCOL_LIBERTY_1_2 = _lasso.PROTOCOL_LIBERTY_1_2
PROTOCOL_SAML_2_0 = _lasso.PROTOCOL_SAML_2_0
ENCRYPTION_MODE_NONE = _lasso.ENCRYPTION_MODE_NONE
ENCRYPTION_MODE_NAMEID = _lasso.ENCRYPTION_MODE_NAMEID
ENCRYPTION_MODE_ASSERTION = _lasso.ENCRYPTION_MODE_ASSERTION
LOGIN_PROTOCOL_PROFILE_BRWS_ART = _lasso.LOGIN_PROTOCOL_PROFILE_BRWS_ART
LOGIN_PROTOCOL_PROFILE_BRWS_POST = _lasso.LOGIN_PROTOCOL_PROFILE_BRWS_POST
LOGIN_PROTOCOL_PROFILE_BRWS_LECP = _lasso.LOGIN_PROTOCOL_PROFILE_BRWS_LECP
LOGIN_PROTOCOL_PROFILE_REDIRECT = _lasso.LOGIN_PROTOCOL_PROFILE_REDIRECT
WSF_ENABLED = _lasso.WSF_ENABLED
SAML2_SUPPORT = True

class Node(object):
    def __init__(self, ):
        self._cptr = _lasso.node_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.node_new_from_dump(dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    @classmethod
    def newFromSoap(cls, soap):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.node_new_from_soap(soap)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    @classmethod
    def newFromXmlNode(cls, node):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.node_new_from_xmlNode(node)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def dump(self):
        '''
        Dumps C{self}.  All datas in object are dumped in an XML format.
        
        @return: a full XML dump of C{self}.
        '''
        return _lasso.node_dump(self._cptr)

    def exportToBase64(self):
        '''
        Exports C{self} to a base64-encoded message.
        
        @return: a base64-encoded export of C{self}.
        '''
        return _lasso.node_export_to_base64(self._cptr)

    def exportToQuery(self, sign_method, private_key_file):
        '''
        Exports C{self} to a HTTP query string.  If C{private_key_file} is
        None, query won't be signed.
        
        @param sign_method:  the Signature transform method
        @param private_key_file:  the path to the private key (may be None)
        @return: a HTTP query export of C{self}.
        '''
        return _lasso.node_export_to_query(self._cptr, sign_method, private_key_file)

    def exportToSoap(self):
        '''
        Exports C{self} to a SOAP message.
        
        @return: a SOAP export of C{self}.
        '''
        return _lasso.node_export_to_soap(self._cptr)

    def exportToXml(self):
        '''
        Exports C{self} to an xml message.
        
        @return: an xml export of C{self}.
        '''
        return _lasso.node_export_to_xml(self._cptr)

    def exportToPaosRequest(self, issuer, responseConsumerURL, relay_state):
        '''
        Exports C{self} to a PAOS message.
        
        @return: a PAOS export of C{self}.
        '''
        return _lasso.node_export_to_paos_request(self._cptr, issuer, responseConsumerURL, relay_state)

    def exportToEcpSoapResponse(self, assertionConsumerURL):
        '''
        Exports C{self} to a ECP SOAP message.
        
        @return: a ECP SOAP export of C{self}.
        '''
        return _lasso.node_export_to_ecp_soap_response(self._cptr, assertionConsumerURL)

    def getXmlNode(self, lasso_dump):
        '''
        Builds an XML representation of C{self}.
        
        @param lasso_dump:  whether to include lasso-specific nodes
        @return: a new xmlNode.
        '''
        return _lasso.node_get_xmlNode(self._cptr, lasso_dump)

    def initFromMessage(self, message):
        '''
        Parses C{message} and initialiazes C{self} fields with data from it.
        Message type may be base64, SOAP, XML or query string, correct type is
        found automatically.
        
        @param message:  a Liberty message
        @return: message format
        '''
        return _lasso.node_init_from_message(self._cptr, message)

    def initFromQuery(self, query):
        '''
        Initialiazes C{self} fields with data from C{query} string.
        
        @param query:  the query string
        @return: True if success
        '''
        return _lasso.node_init_from_query(self._cptr, query)

    def initFromXml(self, xmlnode):
        '''
        Initialiazes C{self} fields with data from C{xmlnode} XML node.
        
        @param xmlnode:  the libxml2 node
        '''
        rc = _lasso.node_init_from_xml(self._cptr, xmlnode)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class SamlAttributeDesignator(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_attribute_designator_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_attributeName(self):
        return _lasso.SamlAttributeDesignator_attributeName_get(self._cptr)
    def set_attributeName(self, value):
        _lasso.SamlAttributeDesignator_attributeName_set(self._cptr, value)
    attributeName = property(get_attributeName, set_attributeName)

    def get_attributeNamespace(self):
        return _lasso.SamlAttributeDesignator_attributeNamespace_get(self._cptr)
    def set_attributeNamespace(self, value):
        _lasso.SamlAttributeDesignator_attributeNamespace_set(self._cptr, value)
    attributeNamespace = property(get_attributeNamespace, set_attributeNamespace)


class DsKeyInfo(Node):
    def __init__(self, ):
        self._cptr = _lasso.ds_key_info_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_keyValue(self):
        t = _lasso.DsKeyInfo_keyValue_get(self._cptr)
        return cptrToPy(t)
    def set_keyValue(self, value):
        if value is not None:
            value = value._cptr
        _lasso.DsKeyInfo_keyValue_set(self._cptr, value)
    keyValue = property(get_keyValue, set_keyValue)


class SamlAttributeValue(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_attribute_value_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_any(self):
        l = _lasso.SamlAttributeValue_any_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_any(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlAttributeValue_any_set(self._cptr, value)
    any = property(get_any, set_any)


class SamlpStatusCode(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp_status_code_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_statusCode(self):
        t = _lasso.SamlpStatusCode_statusCode_get(self._cptr)
        return cptrToPy(t)
    def set_statusCode(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlpStatusCode_statusCode_set(self._cptr, value)
    statusCode = property(get_statusCode, set_statusCode)

    def get_value(self):
        return _lasso.SamlpStatusCode_value_get(self._cptr)
    def set_value(self, value):
        _lasso.SamlpStatusCode_value_set(self._cptr, value)
    value = property(get_value, set_value)


class LibAuthnContext(Node):
    def __init__(self, ):
        self._cptr = _lasso.lib_authn_context_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_authnContextClassRef(self):
        return _lasso.LibAuthnContext_authnContextClassRef_get(self._cptr)
    def set_authnContextClassRef(self, value):
        _lasso.LibAuthnContext_authnContextClassRef_set(self._cptr, value)
    authnContextClassRef = property(get_authnContextClassRef, set_authnContextClassRef)

    def get_authnContextStatementRef(self):
        return _lasso.LibAuthnContext_authnContextStatementRef_get(self._cptr)
    def set_authnContextStatementRef(self, value):
        _lasso.LibAuthnContext_authnContextStatementRef_set(self._cptr, value)
    authnContextStatementRef = property(get_authnContextStatementRef, set_authnContextStatementRef)

    def get_authenticationContextStatement(self):
        t = _lasso.LibAuthnContext_authenticationContextStatement_get(self._cptr)
        return cptrToPy(t)
    def set_authenticationContextStatement(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibAuthnContext_authenticationContextStatement_set(self._cptr, value)
    authenticationContextStatement = property(get_authenticationContextStatement, set_authenticationContextStatement)


class LibIDPEntry(Node):
    def get_providerId(self):
        return _lasso.LibIDPEntry_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibIDPEntry_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_providerName(self):
        return _lasso.LibIDPEntry_providerName_get(self._cptr)
    def set_providerName(self, value):
        _lasso.LibIDPEntry_providerName_set(self._cptr, value)
    providerName = property(get_providerName, set_providerName)

    def get_loc(self):
        return _lasso.LibIDPEntry_loc_get(self._cptr)
    def set_loc(self, value):
        _lasso.LibIDPEntry_loc_set(self._cptr, value)
    loc = property(get_loc, set_loc)


class DsKeyValue(Node):
    def __init__(self, ):
        self._cptr = _lasso.ds_key_value_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_rSAKeyValue(self):
        t = _lasso.DsKeyValue_rSAKeyValue_get(self._cptr)
        return cptrToPy(t)
    def set_rSAKeyValue(self, value):
        if value is not None:
            value = value._cptr
        _lasso.DsKeyValue_rSAKeyValue_set(self._cptr, value)
    rSAKeyValue = property(get_rSAKeyValue, set_rSAKeyValue)


class LibAuthnRequestEnvelope(Node):
    def __init__(self, ):
        self._cptr = _lasso.lib_authn_request_envelope_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, authnRequest, providerID, assertionConsumerServiceURL):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_authn_request_envelope_new_full(authnRequest._cptr, providerID, assertionConsumerServiceURL)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_extension(self):
        return _lasso.LibAuthnRequestEnvelope_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibAuthnRequestEnvelope_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_authnRequest(self):
        t = _lasso.LibAuthnRequestEnvelope_authnRequest_get(self._cptr)
        return cptrToPy(t)
    def set_authnRequest(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibAuthnRequestEnvelope_authnRequest_set(self._cptr, value)
    authnRequest = property(get_authnRequest, set_authnRequest)

    def get_providerId(self):
        return _lasso.LibAuthnRequestEnvelope_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibAuthnRequestEnvelope_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_providerName(self):
        return _lasso.LibAuthnRequestEnvelope_providerName_get(self._cptr)
    def set_providerName(self, value):
        _lasso.LibAuthnRequestEnvelope_providerName_set(self._cptr, value)
    providerName = property(get_providerName, set_providerName)

    def get_assertionConsumerServiceURL(self):
        return _lasso.LibAuthnRequestEnvelope_assertionConsumerServiceURL_get(self._cptr)
    def set_assertionConsumerServiceURL(self, value):
        _lasso.LibAuthnRequestEnvelope_assertionConsumerServiceURL_set(self._cptr, value)
    assertionConsumerServiceURL = property(get_assertionConsumerServiceURL, set_assertionConsumerServiceURL)

    def get_iDPList(self):
        t = _lasso.LibAuthnRequestEnvelope_iDPList_get(self._cptr)
        return cptrToPy(t)
    def set_iDPList(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibAuthnRequestEnvelope_iDPList_set(self._cptr, value)
    iDPList = property(get_iDPList, set_iDPList)

    def get_isPassive(self):
        return _lasso.LibAuthnRequestEnvelope_isPassive_get(self._cptr)
    def set_isPassive(self, value):
        _lasso.LibAuthnRequestEnvelope_isPassive_set(self._cptr, value)
    isPassive = property(get_isPassive, set_isPassive)


class SamlAttribute(SamlAttributeDesignator):
    def __init__(self, ):
        self._cptr = _lasso.saml_attribute_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_attributeName(self):
        return _lasso.SamlAttribute_attributeName_get(self._cptr)
    def set_attributeName(self, value):
        _lasso.SamlAttribute_attributeName_set(self._cptr, value)
    attributeName = property(get_attributeName, set_attributeName)

    def get_attributeNameSpace(self):
        return _lasso.SamlAttribute_attributeNameSpace_get(self._cptr)
    def set_attributeNameSpace(self, value):
        _lasso.SamlAttribute_attributeNameSpace_set(self._cptr, value)
    attributeNameSpace = property(get_attributeNameSpace, set_attributeNameSpace)

    def get_attributeValue(self):
        l = _lasso.SamlAttribute_attributeValue_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_attributeValue(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlAttribute_attributeValue_set(self._cptr, value)
    attributeValue = property(get_attributeValue, set_attributeValue)


class SamlpStatus(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp_status_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_statusCode(self):
        t = _lasso.SamlpStatus_statusCode_get(self._cptr)
        return cptrToPy(t)
    def set_statusCode(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlpStatus_statusCode_set(self._cptr, value)
    statusCode = property(get_statusCode, set_statusCode)

    def get_statusMessage(self):
        return _lasso.SamlpStatus_statusMessage_get(self._cptr)
    def set_statusMessage(self, value):
        _lasso.SamlpStatus_statusMessage_set(self._cptr, value)
    statusMessage = property(get_statusMessage, set_statusMessage)


class LibRequestAuthnContext(Node):
    def __init__(self, ):
        self._cptr = _lasso.lib_request_authn_context_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_authnContextClassRef(self):
        return _lasso.LibRequestAuthnContext_authnContextClassRef_get(self._cptr)
    def set_authnContextClassRef(self, value):
        _lasso.LibRequestAuthnContext_authnContextClassRef_set(self._cptr, value)
    authnContextClassRef = property(get_authnContextClassRef, set_authnContextClassRef)

    def get_authnContextStatementRef(self):
        return _lasso.LibRequestAuthnContext_authnContextStatementRef_get(self._cptr)
    def set_authnContextStatementRef(self, value):
        _lasso.LibRequestAuthnContext_authnContextStatementRef_set(self._cptr, value)
    authnContextStatementRef = property(get_authnContextStatementRef, set_authnContextStatementRef)

    def get_authnContextComparison(self):
        return _lasso.LibRequestAuthnContext_authnContextComparison_get(self._cptr)
    def set_authnContextComparison(self, value):
        _lasso.LibRequestAuthnContext_authnContextComparison_set(self._cptr, value)
    authnContextComparison = property(get_authnContextComparison, set_authnContextComparison)


class LibIDPList(Node):
    def get_iDPEntries(self):
        t = _lasso.LibIDPList_iDPEntries_get(self._cptr)
        return cptrToPy(t)
    def set_iDPEntries(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibIDPList_iDPEntries_set(self._cptr, value)
    iDPEntries = property(get_iDPEntries, set_iDPEntries)

    def get_getComplete(self):
        return _lasso.LibIDPList_getComplete_get(self._cptr)
    def set_getComplete(self, value):
        _lasso.LibIDPList_getComplete_set(self._cptr, value)
    getComplete = property(get_getComplete, set_getComplete)


class LibIDPEntries(Node):
    def get_iDPEntry(self):
        l = _lasso.LibIDPEntries_iDPEntry_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_iDPEntry(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.LibIDPEntries_iDPEntry_set(self._cptr, value)
    iDPEntry = property(get_iDPEntry, set_iDPEntry)


class LibAuthnResponseEnvelope(Node):
    def __init__(self, response, assertionConsumerServiceURL):
        self._cptr = _lasso.lib_authn_response_envelope_new(response._cptr, assertionConsumerServiceURL)
        if self._cptr is None:
            raise Error('failed to create object')

    def get_extension(self):
        return _lasso.LibAuthnResponseEnvelope_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibAuthnResponseEnvelope_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_authnResponse(self):
        t = _lasso.LibAuthnResponseEnvelope_authnResponse_get(self._cptr)
        return cptrToPy(t)
    def set_authnResponse(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibAuthnResponseEnvelope_authnResponse_set(self._cptr, value)
    authnResponse = property(get_authnResponse, set_authnResponse)

    def get_assertionConsumerServiceURL(self):
        return _lasso.LibAuthnResponseEnvelope_assertionConsumerServiceURL_get(self._cptr)
    def set_assertionConsumerServiceURL(self, value):
        _lasso.LibAuthnResponseEnvelope_assertionConsumerServiceURL_set(self._cptr, value)
    assertionConsumerServiceURL = property(get_assertionConsumerServiceURL, set_assertionConsumerServiceURL)


class LibScoping(Node):
    def __init__(self, ):
        self._cptr = _lasso.lib_scoping_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_proxyCount(self):
        return _lasso.LibScoping_proxyCount_get(self._cptr)
    def set_proxyCount(self, value):
        _lasso.LibScoping_proxyCount_set(self._cptr, value)
    proxyCount = property(get_proxyCount, set_proxyCount)

    def get_iDPList(self):
        t = _lasso.LibScoping_iDPList_get(self._cptr)
        return cptrToPy(t)
    def set_iDPList(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibScoping_iDPList_set(self._cptr, value)
    iDPList = property(get_iDPList, set_iDPList)


class SamlAuthorityBinding(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_authority_binding_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_authorityKind(self):
        return _lasso.SamlAuthorityBinding_authorityKind_get(self._cptr)
    def set_authorityKind(self, value):
        _lasso.SamlAuthorityBinding_authorityKind_set(self._cptr, value)
    authorityKind = property(get_authorityKind, set_authorityKind)

    def get_location(self):
        return _lasso.SamlAuthorityBinding_location_get(self._cptr)
    def set_location(self, value):
        _lasso.SamlAuthorityBinding_location_set(self._cptr, value)
    location = property(get_location, set_location)

    def get_binding(self):
        return _lasso.SamlAuthorityBinding_binding_get(self._cptr)
    def set_binding(self, value):
        _lasso.SamlAuthorityBinding_binding_set(self._cptr, value)
    binding = property(get_binding, set_binding)


class SamlAdvice(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_advice_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_assertionIdReference(self):
        l = _lasso.SamlAdvice_assertionIdReference_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertionIdReference(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlAdvice_assertionIdReference_set(self._cptr, value)
    assertionIdReference = property(get_assertionIdReference, set_assertionIdReference)

    def get_assertion(self):
        t = _lasso.SamlAdvice_assertion_get(self._cptr)
        return cptrToPy(t)
    def set_assertion(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAdvice_assertion_set(self._cptr, value)
    assertion = property(get_assertion, set_assertion)


class MiscTextNode(Node):
    def __init__(self, ):
        self._cptr = _lasso.misc_text_node_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newWithString(cls, content):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.misc_text_node_new_with_string(content)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_content(self):
        return _lasso.MiscTextNode_content_get(self._cptr)
    def set_content(self, value):
        _lasso.MiscTextNode_content_set(self._cptr, value)
    content = property(get_content, set_content)

    def get_name(self):
        return _lasso.MiscTextNode_name_get(self._cptr)
    def set_name(self, value):
        _lasso.MiscTextNode_name_set(self._cptr, value)
    name = property(get_name, set_name)

    def get_nsHref(self):
        return _lasso.MiscTextNode_nsHref_get(self._cptr)
    def set_nsHref(self, value):
        _lasso.MiscTextNode_nsHref_set(self._cptr, value)
    nsHref = property(get_nsHref, set_nsHref)

    def get_nsPrefix(self):
        return _lasso.MiscTextNode_nsPrefix_get(self._cptr)
    def set_nsPrefix(self, value):
        _lasso.MiscTextNode_nsPrefix_set(self._cptr, value)
    nsPrefix = property(get_nsPrefix, set_nsPrefix)

    def get_textChild(self):
        return _lasso.MiscTextNode_textChild_get(self._cptr)
    def set_textChild(self, value):
        _lasso.MiscTextNode_textChild_set(self._cptr, value)
    textChild = property(get_textChild, set_textChild)


class SamlConditions(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_conditions_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_condition(self):
        l = _lasso.SamlConditions_condition_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_condition(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlConditions_condition_set(self._cptr, value)
    condition = property(get_condition, set_condition)

    def get_audienceRestrictionCondition(self):
        l = _lasso.SamlConditions_audienceRestrictionCondition_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_audienceRestrictionCondition(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlConditions_audienceRestrictionCondition_set(self._cptr, value)
    audienceRestrictionCondition = property(get_audienceRestrictionCondition, set_audienceRestrictionCondition)

    def get_notBefore(self):
        return _lasso.SamlConditions_notBefore_get(self._cptr)
    def set_notBefore(self, value):
        _lasso.SamlConditions_notBefore_set(self._cptr, value)
    notBefore = property(get_notBefore, set_notBefore)

    def get_notOnOrAfter(self):
        return _lasso.SamlConditions_notOnOrAfter_get(self._cptr)
    def set_notOnOrAfter(self, value):
        _lasso.SamlConditions_notOnOrAfter_set(self._cptr, value)
    notOnOrAfter = property(get_notOnOrAfter, set_notOnOrAfter)


class SamlpResponseAbstract(Node):
    def get_responseId(self):
        return _lasso.SamlpResponseAbstract_responseId_get(self._cptr)
    def set_responseId(self, value):
        _lasso.SamlpResponseAbstract_responseId_set(self._cptr, value)
    responseId = property(get_responseId, set_responseId)

    def get_inResponseTo(self):
        return _lasso.SamlpResponseAbstract_inResponseTo_get(self._cptr)
    def set_inResponseTo(self, value):
        _lasso.SamlpResponseAbstract_inResponseTo_set(self._cptr, value)
    inResponseTo = property(get_inResponseTo, set_inResponseTo)

    def get_majorVersion(self):
        return _lasso.SamlpResponseAbstract_majorVersion_get(self._cptr)
    def set_majorVersion(self, value):
        _lasso.SamlpResponseAbstract_majorVersion_set(self._cptr, value)
    majorVersion = property(get_majorVersion, set_majorVersion)

    def get_minorVersion(self):
        return _lasso.SamlpResponseAbstract_minorVersion_get(self._cptr)
    def set_minorVersion(self, value):
        _lasso.SamlpResponseAbstract_minorVersion_set(self._cptr, value)
    minorVersion = property(get_minorVersion, set_minorVersion)

    def get_issueInstant(self):
        return _lasso.SamlpResponseAbstract_issueInstant_get(self._cptr)
    def set_issueInstant(self, value):
        _lasso.SamlpResponseAbstract_issueInstant_set(self._cptr, value)
    issueInstant = property(get_issueInstant, set_issueInstant)

    def get_recipient(self):
        return _lasso.SamlpResponseAbstract_recipient_get(self._cptr)
    def set_recipient(self, value):
        _lasso.SamlpResponseAbstract_recipient_set(self._cptr, value)
    recipient = property(get_recipient, set_recipient)

    def get_signType(self):
        return _lasso.SamlpResponseAbstract_signType_get(self._cptr)
    def set_signType(self, value):
        _lasso.SamlpResponseAbstract_signType_set(self._cptr, value)
    signType = property(get_signType, set_signType)

    def get_signMethod(self):
        return _lasso.SamlpResponseAbstract_signMethod_get(self._cptr)
    def set_signMethod(self, value):
        _lasso.SamlpResponseAbstract_signMethod_set(self._cptr, value)
    signMethod = property(get_signMethod, set_signMethod)

    def get_privateKeyFile(self):
        return _lasso.SamlpResponseAbstract_privateKeyFile_get(self._cptr)
    def set_privateKeyFile(self, value):
        _lasso.SamlpResponseAbstract_privateKeyFile_set(self._cptr, value)
    privateKeyFile = property(get_privateKeyFile, set_privateKeyFile)

    def get_certificateFile(self):
        return _lasso.SamlpResponseAbstract_certificateFile_get(self._cptr)
    def set_certificateFile(self, value):
        _lasso.SamlpResponseAbstract_certificateFile_set(self._cptr, value)
    certificateFile = property(get_certificateFile, set_certificateFile)

    def fill(self, InResponseTo, Recipient):
        _lasso.samlp_response_abstract_fill(self._cptr, InResponseTo, Recipient)


class LibStatusResponse(SamlpResponseAbstract):
    def __init__(self, ):
        self._cptr = _lasso.lib_status_response_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_extension(self):
        return _lasso.LibStatusResponse_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibStatusResponse_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibStatusResponse_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibStatusResponse_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_status(self):
        t = _lasso.LibStatusResponse_status_get(self._cptr)
        return cptrToPy(t)
    def set_status(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibStatusResponse_status_set(self._cptr, value)
    status = property(get_status, set_status)

    def get_relayState(self):
        return _lasso.LibStatusResponse_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.LibStatusResponse_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)


class LibLogoutResponse(LibStatusResponse):
    pass

class LibNameIdentifierMappingResponse(SamlpResponseAbstract):
    def __init__(self, ):
        self._cptr = _lasso.lib_name_identifier_mapping_response_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, provideRID, statusCodeValue, request, sign_type, sign_method):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_name_identifier_mapping_response_new_full(provideRID, statusCodeValue, request._cptr, sign_type, sign_method)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_extension(self):
        return _lasso.LibNameIdentifierMappingResponse_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibNameIdentifierMappingResponse_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibNameIdentifierMappingResponse_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibNameIdentifierMappingResponse_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_status(self):
        t = _lasso.LibNameIdentifierMappingResponse_status_get(self._cptr)
        return cptrToPy(t)
    def set_status(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibNameIdentifierMappingResponse_status_set(self._cptr, value)
    status = property(get_status, set_status)

    def get_nameIdentifier(self):
        t = _lasso.LibNameIdentifierMappingResponse_nameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibNameIdentifierMappingResponse_nameIdentifier_set(self._cptr, value)
    nameIdentifier = property(get_nameIdentifier, set_nameIdentifier)


class SamlStatementAbstract(Node):
    pass

class SamlSubject(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_subject_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_nameIdentifier(self):
        t = _lasso.SamlSubject_nameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlSubject_nameIdentifier_set(self._cptr, value)
    nameIdentifier = property(get_nameIdentifier, set_nameIdentifier)

    def get_subjectConfirmation(self):
        t = _lasso.SamlSubject_subjectConfirmation_get(self._cptr)
        return cptrToPy(t)
    def set_subjectConfirmation(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlSubject_subjectConfirmation_set(self._cptr, value)
    subjectConfirmation = property(get_subjectConfirmation, set_subjectConfirmation)

    def get_encryptedNameIdentifier(self):
        t = _lasso.SamlSubject_encryptedNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_encryptedNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlSubject_encryptedNameIdentifier_set(self._cptr, value)
    encryptedNameIdentifier = property(get_encryptedNameIdentifier, set_encryptedNameIdentifier)


class LibSubject(SamlSubject):
    def __init__(self, ):
        self._cptr = _lasso.lib_subject_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_iDPProvidedNameIdentifier(self):
        t = _lasso.LibSubject_iDPProvidedNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_iDPProvidedNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibSubject_iDPProvidedNameIdentifier_set(self._cptr, value)
    iDPProvidedNameIdentifier = property(get_iDPProvidedNameIdentifier, set_iDPProvidedNameIdentifier)


class SamlpRequestAbstract(Node):
    def get_respondWith(self):
        return _lasso.SamlpRequestAbstract_respondWith_get(self._cptr)
    def set_respondWith(self, value):
        _lasso.SamlpRequestAbstract_respondWith_set(self._cptr, value)
    respondWith = property(get_respondWith, set_respondWith)

    def get_requestId(self):
        return _lasso.SamlpRequestAbstract_requestId_get(self._cptr)
    def set_requestId(self, value):
        _lasso.SamlpRequestAbstract_requestId_set(self._cptr, value)
    requestId = property(get_requestId, set_requestId)

    def get_majorVersion(self):
        return _lasso.SamlpRequestAbstract_majorVersion_get(self._cptr)
    def set_majorVersion(self, value):
        _lasso.SamlpRequestAbstract_majorVersion_set(self._cptr, value)
    majorVersion = property(get_majorVersion, set_majorVersion)

    def get_minorVersion(self):
        return _lasso.SamlpRequestAbstract_minorVersion_get(self._cptr)
    def set_minorVersion(self, value):
        _lasso.SamlpRequestAbstract_minorVersion_set(self._cptr, value)
    minorVersion = property(get_minorVersion, set_minorVersion)

    def get_issueInstant(self):
        return _lasso.SamlpRequestAbstract_issueInstant_get(self._cptr)
    def set_issueInstant(self, value):
        _lasso.SamlpRequestAbstract_issueInstant_set(self._cptr, value)
    issueInstant = property(get_issueInstant, set_issueInstant)

    def get_signType(self):
        return _lasso.SamlpRequestAbstract_signType_get(self._cptr)
    def set_signType(self, value):
        _lasso.SamlpRequestAbstract_signType_set(self._cptr, value)
    signType = property(get_signType, set_signType)

    def get_signMethod(self):
        return _lasso.SamlpRequestAbstract_signMethod_get(self._cptr)
    def set_signMethod(self, value):
        _lasso.SamlpRequestAbstract_signMethod_set(self._cptr, value)
    signMethod = property(get_signMethod, set_signMethod)

    def get_privateKeyFile(self):
        return _lasso.SamlpRequestAbstract_privateKeyFile_get(self._cptr)
    def set_privateKeyFile(self, value):
        _lasso.SamlpRequestAbstract_privateKeyFile_set(self._cptr, value)
    privateKeyFile = property(get_privateKeyFile, set_privateKeyFile)

    def get_certificateFile(self):
        return _lasso.SamlpRequestAbstract_certificateFile_get(self._cptr)
    def set_certificateFile(self, value):
        _lasso.SamlpRequestAbstract_certificateFile_set(self._cptr, value)
    certificateFile = property(get_certificateFile, set_certificateFile)


class SamlpRequest(SamlpRequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp_request_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_assertionArtifact(self):
        return _lasso.SamlpRequest_assertionArtifact_get(self._cptr)
    def set_assertionArtifact(self, value):
        _lasso.SamlpRequest_assertionArtifact_set(self._cptr, value)
    assertionArtifact = property(get_assertionArtifact, set_assertionArtifact)


class LibAuthnRequest(SamlpRequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.lib_authn_request_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_extension(self):
        return _lasso.LibAuthnRequest_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibAuthnRequest_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibAuthnRequest_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibAuthnRequest_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_affiliationId(self):
        return _lasso.LibAuthnRequest_affiliationId_get(self._cptr)
    def set_affiliationId(self, value):
        _lasso.LibAuthnRequest_affiliationId_set(self._cptr, value)
    affiliationId = property(get_affiliationId, set_affiliationId)

    def get_nameIdPolicy(self):
        return _lasso.LibAuthnRequest_nameIdPolicy_get(self._cptr)
    def set_nameIdPolicy(self, value):
        _lasso.LibAuthnRequest_nameIdPolicy_set(self._cptr, value)
    nameIdPolicy = property(get_nameIdPolicy, set_nameIdPolicy)

    def get_forceAuthn(self):
        return _lasso.LibAuthnRequest_forceAuthn_get(self._cptr)
    def set_forceAuthn(self, value):
        _lasso.LibAuthnRequest_forceAuthn_set(self._cptr, value)
    forceAuthn = property(get_forceAuthn, set_forceAuthn)

    def get_isPassive(self):
        return _lasso.LibAuthnRequest_isPassive_get(self._cptr)
    def set_isPassive(self, value):
        _lasso.LibAuthnRequest_isPassive_set(self._cptr, value)
    isPassive = property(get_isPassive, set_isPassive)

    def get_protocolProfile(self):
        return _lasso.LibAuthnRequest_protocolProfile_get(self._cptr)
    def set_protocolProfile(self, value):
        _lasso.LibAuthnRequest_protocolProfile_set(self._cptr, value)
    protocolProfile = property(get_protocolProfile, set_protocolProfile)

    def get_assertionConsumerServiceId(self):
        return _lasso.LibAuthnRequest_assertionConsumerServiceId_get(self._cptr)
    def set_assertionConsumerServiceId(self, value):
        _lasso.LibAuthnRequest_assertionConsumerServiceId_set(self._cptr, value)
    assertionConsumerServiceId = property(get_assertionConsumerServiceId, set_assertionConsumerServiceId)

    def get_requestAuthnContext(self):
        t = _lasso.LibAuthnRequest_requestAuthnContext_get(self._cptr)
        return cptrToPy(t)
    def set_requestAuthnContext(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibAuthnRequest_requestAuthnContext_set(self._cptr, value)
    requestAuthnContext = property(get_requestAuthnContext, set_requestAuthnContext)

    def get_relayState(self):
        return _lasso.LibAuthnRequest_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.LibAuthnRequest_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)

    def get_scoping(self):
        t = _lasso.LibAuthnRequest_scoping_get(self._cptr)
        return cptrToPy(t)
    def set_scoping(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibAuthnRequest_scoping_set(self._cptr, value)
    scoping = property(get_scoping, set_scoping)

    def get_consent(self):
        return _lasso.LibAuthnRequest_consent_get(self._cptr)
    def set_consent(self, value):
        _lasso.LibAuthnRequest_consent_set(self._cptr, value)
    consent = property(get_consent, set_consent)


class LibNameIdentifierMappingRequest(SamlpRequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.lib_name_identifier_mapping_request_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, providerID, nameIdentifier, targetNamespace, sign_type, sign_method):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_name_identifier_mapping_request_new_full(providerID, nameIdentifier._cptr, targetNamespace, sign_type, sign_method)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_extension(self):
        return _lasso.LibNameIdentifierMappingRequest_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibNameIdentifierMappingRequest_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibNameIdentifierMappingRequest_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibNameIdentifierMappingRequest_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_nameIdentifier(self):
        t = _lasso.LibNameIdentifierMappingRequest_nameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibNameIdentifierMappingRequest_nameIdentifier_set(self._cptr, value)
    nameIdentifier = property(get_nameIdentifier, set_nameIdentifier)

    def get_targetNamespace(self):
        return _lasso.LibNameIdentifierMappingRequest_targetNamespace_get(self._cptr)
    def set_targetNamespace(self, value):
        _lasso.LibNameIdentifierMappingRequest_targetNamespace_set(self._cptr, value)
    targetNamespace = property(get_targetNamespace, set_targetNamespace)

    def get_consent(self):
        return _lasso.LibNameIdentifierMappingRequest_consent_get(self._cptr)
    def set_consent(self, value):
        _lasso.LibNameIdentifierMappingRequest_consent_set(self._cptr, value)
    consent = property(get_consent, set_consent)


class LibFederationTerminationNotification(SamlpRequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.lib_federation_termination_notification_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, providerID, nameIdentifier, sign_type, sign_method):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_federation_termination_notification_new_full(providerID, nameIdentifier._cptr, sign_type, sign_method)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_extension(self):
        return _lasso.LibFederationTerminationNotification_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibFederationTerminationNotification_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibFederationTerminationNotification_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibFederationTerminationNotification_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_nameIdentifier(self):
        t = _lasso.LibFederationTerminationNotification_nameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibFederationTerminationNotification_nameIdentifier_set(self._cptr, value)
    nameIdentifier = property(get_nameIdentifier, set_nameIdentifier)

    def get_consent(self):
        return _lasso.LibFederationTerminationNotification_consent_get(self._cptr)
    def set_consent(self, value):
        _lasso.LibFederationTerminationNotification_consent_set(self._cptr, value)
    consent = property(get_consent, set_consent)

    def get_relayState(self):
        return _lasso.LibFederationTerminationNotification_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.LibFederationTerminationNotification_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)


class LibLogoutRequest(SamlpRequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.lib_logout_request_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, providerID, nameIdentifier, sign_type, sign_method):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_logout_request_new_full(providerID, nameIdentifier._cptr, sign_type, sign_method)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_extension(self):
        return _lasso.LibLogoutRequest_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibLogoutRequest_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibLogoutRequest_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibLogoutRequest_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_nameIdentifier(self):
        t = _lasso.LibLogoutRequest_nameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibLogoutRequest_nameIdentifier_set(self._cptr, value)
    nameIdentifier = property(get_nameIdentifier, set_nameIdentifier)

    def get_sessionIndex(self):
        return _lasso.LibLogoutRequest_sessionIndex_get(self._cptr)
    def set_sessionIndex(self, value):
        _lasso.LibLogoutRequest_sessionIndex_set(self._cptr, value)
    sessionIndex = property(get_sessionIndex, set_sessionIndex)

    def get_relayState(self):
        return _lasso.LibLogoutRequest_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.LibLogoutRequest_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)

    def get_consent(self):
        return _lasso.LibLogoutRequest_consent_get(self._cptr)
    def set_consent(self, value):
        _lasso.LibLogoutRequest_consent_set(self._cptr, value)
    consent = property(get_consent, set_consent)

    def get_notOnOrAfter(self):
        return _lasso.LibLogoutRequest_notOnOrAfter_get(self._cptr)
    def set_notOnOrAfter(self, value):
        _lasso.LibLogoutRequest_notOnOrAfter_set(self._cptr, value)
    notOnOrAfter = property(get_notOnOrAfter, set_notOnOrAfter)


class SamlSubjectLocality(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_subject_locality_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_iPAddress(self):
        return _lasso.SamlSubjectLocality_iPAddress_get(self._cptr)
    def set_iPAddress(self, value):
        _lasso.SamlSubjectLocality_iPAddress_set(self._cptr, value)
    iPAddress = property(get_iPAddress, set_iPAddress)

    def get_dNSAddress(self):
        return _lasso.SamlSubjectLocality_dNSAddress_get(self._cptr)
    def set_dNSAddress(self, value):
        _lasso.SamlSubjectLocality_dNSAddress_set(self._cptr, value)
    dNSAddress = property(get_dNSAddress, set_dNSAddress)


class SamlConditionAbstract(Node):
    pass

class LibRegisterNameIdentifierRequest(SamlpRequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.lib_register_name_identifier_request_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, providerID, idpNameIdentifier, spNameIdentifier, oldNameIdentifier, sign_type, sign_method):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_register_name_identifier_request_new_full(providerID, idpNameIdentifier._cptr, spNameIdentifier._cptr, oldNameIdentifier._cptr, sign_type, sign_method)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_extension(self):
        return _lasso.LibRegisterNameIdentifierRequest_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibRegisterNameIdentifierRequest_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibRegisterNameIdentifierRequest_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibRegisterNameIdentifierRequest_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_iDPProvidedNameIdentifier(self):
        t = _lasso.LibRegisterNameIdentifierRequest_iDPProvidedNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_iDPProvidedNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibRegisterNameIdentifierRequest_iDPProvidedNameIdentifier_set(self._cptr, value)
    iDPProvidedNameIdentifier = property(get_iDPProvidedNameIdentifier, set_iDPProvidedNameIdentifier)

    def get_sPProvidedNameIdentifier(self):
        t = _lasso.LibRegisterNameIdentifierRequest_sPProvidedNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_sPProvidedNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibRegisterNameIdentifierRequest_sPProvidedNameIdentifier_set(self._cptr, value)
    sPProvidedNameIdentifier = property(get_sPProvidedNameIdentifier, set_sPProvidedNameIdentifier)

    def get_oldProvidedNameIdentifier(self):
        t = _lasso.LibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_oldProvidedNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibRegisterNameIdentifierRequest_oldProvidedNameIdentifier_set(self._cptr, value)
    oldProvidedNameIdentifier = property(get_oldProvidedNameIdentifier, set_oldProvidedNameIdentifier)

    def get_relayState(self):
        return _lasso.LibRegisterNameIdentifierRequest_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.LibRegisterNameIdentifierRequest_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)


class LibRegisterNameIdentifierResponse(LibStatusResponse):
    pass

class SamlNameIdentifier(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_name_identifier_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromXmlNode(cls, xmlnode):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.saml_name_identifier_new_from_xmlNode(xmlnode)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_nameQualifier(self):
        return _lasso.SamlNameIdentifier_nameQualifier_get(self._cptr)
    def set_nameQualifier(self, value):
        _lasso.SamlNameIdentifier_nameQualifier_set(self._cptr, value)
    nameQualifier = property(get_nameQualifier, set_nameQualifier)

    def get_format(self):
        return _lasso.SamlNameIdentifier_format_get(self._cptr)
    def set_format(self, value):
        _lasso.SamlNameIdentifier_format_set(self._cptr, value)
    format = property(get_format, set_format)

    def get_content(self):
        return _lasso.SamlNameIdentifier_content_get(self._cptr)
    def set_content(self, value):
        _lasso.SamlNameIdentifier_content_set(self._cptr, value)
    content = property(get_content, set_content)


class SamlSubjectConfirmation(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_subject_confirmation_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_confirmationMethod(self):
        l = _lasso.SamlSubjectConfirmation_confirmationMethod_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_confirmationMethod(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlSubjectConfirmation_confirmationMethod_set(self._cptr, value)
    confirmationMethod = property(get_confirmationMethod, set_confirmationMethod)

    def get_subjectConfirmationData(self):
        return _lasso.SamlSubjectConfirmation_subjectConfirmationData_get(self._cptr)
    def set_subjectConfirmationData(self, value):
        _lasso.SamlSubjectConfirmation_subjectConfirmationData_set(self._cptr, value)
    subjectConfirmationData = property(get_subjectConfirmationData, set_subjectConfirmationData)

    def get_keyInfo(self):
        t = _lasso.SamlSubjectConfirmation_keyInfo_get(self._cptr)
        return cptrToPy(t)
    def set_keyInfo(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlSubjectConfirmation_keyInfo_set(self._cptr, value)
    keyInfo = property(get_keyInfo, set_keyInfo)


class SamlAudienceRestrictionCondition(SamlConditionAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml_audience_restriction_condition_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, audience):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.saml_audience_restriction_condition_new_full(audience)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_audience(self):
        l = _lasso.SamlAudienceRestrictionCondition_audience_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_audience(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlAudienceRestrictionCondition_audience_set(self._cptr, value)
    audience = property(get_audience, set_audience)


class SamlSubjectStatementAbstract(SamlStatementAbstract):
    def get_subject(self):
        t = _lasso.SamlSubjectStatementAbstract_subject_get(self._cptr)
        return cptrToPy(t)
    def set_subject(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlSubjectStatementAbstract_subject_set(self._cptr, value)
    subject = property(get_subject, set_subject)


class SamlAttributeStatement(SamlSubjectStatementAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml_attribute_statement_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_attribute(self):
        l = _lasso.SamlAttributeStatement_attribute_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_attribute(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlAttributeStatement_attribute_set(self._cptr, value)
    attribute = property(get_attribute, set_attribute)


class SamlAuthenticationStatement(SamlSubjectStatementAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml_authentication_statement_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_subjectLocality(self):
        t = _lasso.SamlAuthenticationStatement_subjectLocality_get(self._cptr)
        return cptrToPy(t)
    def set_subjectLocality(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAuthenticationStatement_subjectLocality_set(self._cptr, value)
    subjectLocality = property(get_subjectLocality, set_subjectLocality)

    def get_authorityBinding(self):
        l = _lasso.SamlAuthenticationStatement_authorityBinding_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_authorityBinding(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlAuthenticationStatement_authorityBinding_set(self._cptr, value)
    authorityBinding = property(get_authorityBinding, set_authorityBinding)

    def get_authenticationMethod(self):
        return _lasso.SamlAuthenticationStatement_authenticationMethod_get(self._cptr)
    def set_authenticationMethod(self, value):
        _lasso.SamlAuthenticationStatement_authenticationMethod_set(self._cptr, value)
    authenticationMethod = property(get_authenticationMethod, set_authenticationMethod)

    def get_authenticationInstant(self):
        return _lasso.SamlAuthenticationStatement_authenticationInstant_get(self._cptr)
    def set_authenticationInstant(self, value):
        _lasso.SamlAuthenticationStatement_authenticationInstant_set(self._cptr, value)
    authenticationInstant = property(get_authenticationInstant, set_authenticationInstant)


class LibAuthenticationStatement(SamlAuthenticationStatement):
    def __init__(self, ):
        self._cptr = _lasso.lib_authentication_statement_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, authenticationMethod, authenticationInstant, reauthenticateOnOrAfter, sp_identifier, idp_identifier):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_authentication_statement_new_full(authenticationMethod, authenticationInstant, reauthenticateOnOrAfter, sp_identifier._cptr, idp_identifier._cptr)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_authnContext(self):
        t = _lasso.LibAuthenticationStatement_authnContext_get(self._cptr)
        return cptrToPy(t)
    def set_authnContext(self, value):
        if value is not None:
            value = value._cptr
        _lasso.LibAuthenticationStatement_authnContext_set(self._cptr, value)
    authnContext = property(get_authnContext, set_authnContext)

    def get_reauthenticateOnOrAfter(self):
        return _lasso.LibAuthenticationStatement_reauthenticateOnOrAfter_get(self._cptr)
    def set_reauthenticateOnOrAfter(self, value):
        _lasso.LibAuthenticationStatement_reauthenticateOnOrAfter_set(self._cptr, value)
    reauthenticateOnOrAfter = property(get_reauthenticateOnOrAfter, set_reauthenticateOnOrAfter)

    def get_sessionIndex(self):
        return _lasso.LibAuthenticationStatement_sessionIndex_get(self._cptr)
    def set_sessionIndex(self, value):
        _lasso.LibAuthenticationStatement_sessionIndex_set(self._cptr, value)
    sessionIndex = property(get_sessionIndex, set_sessionIndex)


class SamlSubjectStatement(SamlSubjectStatementAbstract):
    pass

class SamlAssertion(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml_assertion_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_conditions(self):
        t = _lasso.SamlAssertion_conditions_get(self._cptr)
        return cptrToPy(t)
    def set_conditions(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAssertion_conditions_set(self._cptr, value)
    conditions = property(get_conditions, set_conditions)

    def get_advice(self):
        t = _lasso.SamlAssertion_advice_get(self._cptr)
        return cptrToPy(t)
    def set_advice(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAssertion_advice_set(self._cptr, value)
    advice = property(get_advice, set_advice)

    def get_statement(self):
        t = _lasso.SamlAssertion_statement_get(self._cptr)
        return cptrToPy(t)
    def set_statement(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAssertion_statement_set(self._cptr, value)
    statement = property(get_statement, set_statement)

    def get_subjectStatement(self):
        t = _lasso.SamlAssertion_subjectStatement_get(self._cptr)
        return cptrToPy(t)
    def set_subjectStatement(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAssertion_subjectStatement_set(self._cptr, value)
    subjectStatement = property(get_subjectStatement, set_subjectStatement)

    def get_authenticationStatement(self):
        t = _lasso.SamlAssertion_authenticationStatement_get(self._cptr)
        return cptrToPy(t)
    def set_authenticationStatement(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAssertion_authenticationStatement_set(self._cptr, value)
    authenticationStatement = property(get_authenticationStatement, set_authenticationStatement)

    def get_authorizationDecisionStatement(self):
        t = _lasso.SamlAssertion_authorizationDecisionStatement_get(self._cptr)
        return cptrToPy(t)
    def set_authorizationDecisionStatement(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAssertion_authorizationDecisionStatement_set(self._cptr, value)
    authorizationDecisionStatement = property(get_authorizationDecisionStatement, set_authorizationDecisionStatement)

    def get_attributeStatement(self):
        t = _lasso.SamlAssertion_attributeStatement_get(self._cptr)
        return cptrToPy(t)
    def set_attributeStatement(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlAssertion_attributeStatement_set(self._cptr, value)
    attributeStatement = property(get_attributeStatement, set_attributeStatement)

    def get_majorVersion(self):
        return _lasso.SamlAssertion_majorVersion_get(self._cptr)
    def set_majorVersion(self, value):
        _lasso.SamlAssertion_majorVersion_set(self._cptr, value)
    majorVersion = property(get_majorVersion, set_majorVersion)

    def get_minorVersion(self):
        return _lasso.SamlAssertion_minorVersion_get(self._cptr)
    def set_minorVersion(self, value):
        _lasso.SamlAssertion_minorVersion_set(self._cptr, value)
    minorVersion = property(get_minorVersion, set_minorVersion)

    def get_assertionId(self):
        return _lasso.SamlAssertion_assertionId_get(self._cptr)
    def set_assertionId(self, value):
        _lasso.SamlAssertion_assertionId_set(self._cptr, value)
    assertionId = property(get_assertionId, set_assertionId)

    def get_issuer(self):
        return _lasso.SamlAssertion_issuer_get(self._cptr)
    def set_issuer(self, value):
        _lasso.SamlAssertion_issuer_set(self._cptr, value)
    issuer = property(get_issuer, set_issuer)

    def get_issueInstant(self):
        return _lasso.SamlAssertion_issueInstant_get(self._cptr)
    def set_issueInstant(self, value):
        _lasso.SamlAssertion_issueInstant_set(self._cptr, value)
    issueInstant = property(get_issueInstant, set_issueInstant)

    def get_signType(self):
        return _lasso.SamlAssertion_signType_get(self._cptr)
    def set_signType(self, value):
        _lasso.SamlAssertion_signType_set(self._cptr, value)
    signType = property(get_signType, set_signType)

    def get_signMethod(self):
        return _lasso.SamlAssertion_signMethod_get(self._cptr)
    def set_signMethod(self, value):
        _lasso.SamlAssertion_signMethod_set(self._cptr, value)
    signMethod = property(get_signMethod, set_signMethod)

    def get_privateKeyFile(self):
        return _lasso.SamlAssertion_privateKeyFile_get(self._cptr)
    def set_privateKeyFile(self, value):
        _lasso.SamlAssertion_privateKeyFile_set(self._cptr, value)
    privateKeyFile = property(get_privateKeyFile, set_privateKeyFile)

    def get_certificateFile(self):
        return _lasso.SamlAssertion_certificateFile_get(self._cptr)
    def set_certificateFile(self, value):
        _lasso.SamlAssertion_certificateFile_set(self._cptr, value)
    certificateFile = property(get_certificateFile, set_certificateFile)


class LibAssertion(SamlAssertion):
    def __init__(self, ):
        self._cptr = _lasso.lib_assertion_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFull(cls, issuer, requestID, audience, notBefore, notOnOrAfter):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.lib_assertion_new_full(issuer, requestID, audience, notBefore, notOnOrAfter)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_inResponseTo(self):
        return _lasso.LibAssertion_inResponseTo_get(self._cptr)
    def set_inResponseTo(self, value):
        _lasso.LibAssertion_inResponseTo_set(self._cptr, value)
    inResponseTo = property(get_inResponseTo, set_inResponseTo)


class SamlpResponse(SamlpResponseAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp_response_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_status(self):
        t = _lasso.SamlpResponse_status_get(self._cptr)
        return cptrToPy(t)
    def set_status(self, value):
        if value is not None:
            value = value._cptr
        _lasso.SamlpResponse_status_set(self._cptr, value)
    status = property(get_status, set_status)

    def get_assertion(self):
        l = _lasso.SamlpResponse_assertion_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertion(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.SamlpResponse_assertion_set(self._cptr, value)
    assertion = property(get_assertion, set_assertion)


class LibAuthnResponse(SamlpResponse):
    def __init__(self, providerID, request):
        self._cptr = _lasso.lib_authn_response_new(providerID, request._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    def get_extension(self):
        return _lasso.LibAuthnResponse_extension_get(self._cptr)
    def set_extension(self, value):
        _lasso.LibAuthnResponse_extension_set(self._cptr, value)
    extension = property(get_extension, set_extension)

    def get_providerId(self):
        return _lasso.LibAuthnResponse_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.LibAuthnResponse_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_relayState(self):
        return _lasso.LibAuthnResponse_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.LibAuthnResponse_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)

    def get_consent(self):
        return _lasso.LibAuthnResponse_consent_get(self._cptr)
    def set_consent(self, value):
        _lasso.LibAuthnResponse_consent_set(self._cptr, value)
    consent = property(get_consent, set_consent)


class DsRsaKeyValue(Node):
    def __init__(self, ):
        self._cptr = _lasso.ds_rsa_key_value_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_modulus(self):
        return _lasso.DsRsaKeyValue_modulus_get(self._cptr)
    def set_modulus(self, value):
        _lasso.DsRsaKeyValue_modulus_set(self._cptr, value)
    modulus = property(get_modulus, set_modulus)

    def get_exponent(self):
        return _lasso.DsRsaKeyValue_exponent_get(self._cptr)
    def set_exponent(self, value):
        _lasso.DsRsaKeyValue_exponent_set(self._cptr, value)
    exponent = property(get_exponent, set_exponent)


class Samlp2Terminate(Node):
    pass

class Saml2SubjectConfirmation(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_subject_confirmation_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_baseId(self):
        t = _lasso.Saml2SubjectConfirmation_baseId_get(self._cptr)
        return cptrToPy(t)
    def set_baseId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2SubjectConfirmation_baseId_set(self._cptr, value)
    baseId = property(get_baseId, set_baseId)

    def get_nameId(self):
        t = _lasso.Saml2SubjectConfirmation_nameId_get(self._cptr)
        return cptrToPy(t)
    def set_nameId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2SubjectConfirmation_nameId_set(self._cptr, value)
    nameId = property(get_nameId, set_nameId)

    def get_encryptedId(self):
        t = _lasso.Saml2SubjectConfirmation_encryptedId_get(self._cptr)
        return cptrToPy(t)
    def set_encryptedId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2SubjectConfirmation_encryptedId_set(self._cptr, value)
    encryptedId = property(get_encryptedId, set_encryptedId)

    def get_subjectConfirmationData(self):
        t = _lasso.Saml2SubjectConfirmation_subjectConfirmationData_get(self._cptr)
        return cptrToPy(t)
    def set_subjectConfirmationData(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2SubjectConfirmation_subjectConfirmationData_set(self._cptr, value)
    subjectConfirmationData = property(get_subjectConfirmationData, set_subjectConfirmationData)

    def get_method(self):
        return _lasso.Saml2SubjectConfirmation_method_get(self._cptr)
    def set_method(self, value):
        _lasso.Saml2SubjectConfirmation_method_set(self._cptr, value)
    method = property(get_method, set_method)


class Samlp2RequestAbstract(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_request_abstract_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_issuer(self):
        t = _lasso.Samlp2RequestAbstract_issuer_get(self._cptr)
        return cptrToPy(t)
    def set_issuer(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2RequestAbstract_issuer_set(self._cptr, value)
    issuer = property(get_issuer, set_issuer)

    def get_extensions(self):
        t = _lasso.Samlp2RequestAbstract_extensions_get(self._cptr)
        return cptrToPy(t)
    def set_extensions(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2RequestAbstract_extensions_set(self._cptr, value)
    extensions = property(get_extensions, set_extensions)

    def get_iD(self):
        return _lasso.Samlp2RequestAbstract_iD_get(self._cptr)
    def set_iD(self, value):
        _lasso.Samlp2RequestAbstract_iD_set(self._cptr, value)
    iD = property(get_iD, set_iD)

    def get_version(self):
        return _lasso.Samlp2RequestAbstract_version_get(self._cptr)
    def set_version(self, value):
        _lasso.Samlp2RequestAbstract_version_set(self._cptr, value)
    version = property(get_version, set_version)

    def get_issueInstant(self):
        return _lasso.Samlp2RequestAbstract_issueInstant_get(self._cptr)
    def set_issueInstant(self, value):
        _lasso.Samlp2RequestAbstract_issueInstant_set(self._cptr, value)
    issueInstant = property(get_issueInstant, set_issueInstant)

    def get_destination(self):
        return _lasso.Samlp2RequestAbstract_destination_get(self._cptr)
    def set_destination(self, value):
        _lasso.Samlp2RequestAbstract_destination_set(self._cptr, value)
    destination = property(get_destination, set_destination)

    def get_consent(self):
        return _lasso.Samlp2RequestAbstract_consent_get(self._cptr)
    def set_consent(self, value):
        _lasso.Samlp2RequestAbstract_consent_set(self._cptr, value)
    consent = property(get_consent, set_consent)


class Samlp2NameIDMappingRequest(Samlp2RequestAbstract):
    def get_baseId(self):
        t = _lasso.Samlp2NameIDMappingRequest_baseId_get(self._cptr)
        return cptrToPy(t)
    def set_baseId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2NameIDMappingRequest_baseId_set(self._cptr, value)
    baseId = property(get_baseId, set_baseId)

    def get_nameId(self):
        t = _lasso.Samlp2NameIDMappingRequest_nameId_get(self._cptr)
        return cptrToPy(t)
    def set_nameId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2NameIDMappingRequest_nameId_set(self._cptr, value)
    nameId = property(get_nameId, set_nameId)

    def get_encryptedId(self):
        t = _lasso.Samlp2NameIDMappingRequest_encryptedId_get(self._cptr)
        return cptrToPy(t)
    def set_encryptedId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2NameIDMappingRequest_encryptedId_set(self._cptr, value)
    encryptedId = property(get_encryptedId, set_encryptedId)

    def get_nameIdPolicy(self):
        t = _lasso.Samlp2NameIDMappingRequest_nameIdPolicy_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdPolicy(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2NameIDMappingRequest_nameIdPolicy_set(self._cptr, value)
    nameIdPolicy = property(get_nameIdPolicy, set_nameIdPolicy)


class Samlp2ArtifactResolve(Samlp2RequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_artifact_resolve_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_artifact(self):
        return _lasso.Samlp2ArtifactResolve_artifact_get(self._cptr)
    def set_artifact(self, value):
        _lasso.Samlp2ArtifactResolve_artifact_set(self._cptr, value)
    artifact = property(get_artifact, set_artifact)


class Samlp2LogoutRequest(Samlp2RequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_logout_request_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_baseId(self):
        t = _lasso.Samlp2LogoutRequest_baseId_get(self._cptr)
        return cptrToPy(t)
    def set_baseId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2LogoutRequest_baseId_set(self._cptr, value)
    baseId = property(get_baseId, set_baseId)

    def get_nameId(self):
        t = _lasso.Samlp2LogoutRequest_nameId_get(self._cptr)
        return cptrToPy(t)
    def set_nameId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2LogoutRequest_nameId_set(self._cptr, value)
    nameId = property(get_nameId, set_nameId)

    def get_encryptedId(self):
        t = _lasso.Samlp2LogoutRequest_encryptedId_get(self._cptr)
        return cptrToPy(t)
    def set_encryptedId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2LogoutRequest_encryptedId_set(self._cptr, value)
    encryptedId = property(get_encryptedId, set_encryptedId)

    def get_sessionIndex(self):
        return _lasso.Samlp2LogoutRequest_sessionIndex_get(self._cptr)
    def set_sessionIndex(self, value):
        _lasso.Samlp2LogoutRequest_sessionIndex_set(self._cptr, value)
    sessionIndex = property(get_sessionIndex, set_sessionIndex)

    def get_reason(self):
        return _lasso.Samlp2LogoutRequest_reason_get(self._cptr)
    def set_reason(self, value):
        _lasso.Samlp2LogoutRequest_reason_set(self._cptr, value)
    reason = property(get_reason, set_reason)

    def get_notOnOrAfter(self):
        return _lasso.Samlp2LogoutRequest_notOnOrAfter_get(self._cptr)
    def set_notOnOrAfter(self, value):
        _lasso.Samlp2LogoutRequest_notOnOrAfter_set(self._cptr, value)
    notOnOrAfter = property(get_notOnOrAfter, set_notOnOrAfter)

    def get_relayState(self):
        return _lasso.Samlp2LogoutRequest_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.Samlp2LogoutRequest_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)


class Saml2AttributeValue(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_attribute_value_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_any(self):
        l = _lasso.Saml2AttributeValue_any_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_any(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2AttributeValue_any_set(self._cptr, value)
    any = property(get_any, set_any)


class Saml2ConditionAbstract(Node):
    pass

class Samlp2AuthnRequest(Samlp2RequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_authn_request_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_subject(self):
        t = _lasso.Samlp2AuthnRequest_subject_get(self._cptr)
        return cptrToPy(t)
    def set_subject(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthnRequest_subject_set(self._cptr, value)
    subject = property(get_subject, set_subject)

    def get_nameIdPolicy(self):
        t = _lasso.Samlp2AuthnRequest_nameIdPolicy_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdPolicy(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthnRequest_nameIdPolicy_set(self._cptr, value)
    nameIdPolicy = property(get_nameIdPolicy, set_nameIdPolicy)

    def get_conditions(self):
        t = _lasso.Samlp2AuthnRequest_conditions_get(self._cptr)
        return cptrToPy(t)
    def set_conditions(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthnRequest_conditions_set(self._cptr, value)
    conditions = property(get_conditions, set_conditions)

    def get_requestedAuthnContext(self):
        t = _lasso.Samlp2AuthnRequest_requestedAuthnContext_get(self._cptr)
        return cptrToPy(t)
    def set_requestedAuthnContext(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthnRequest_requestedAuthnContext_set(self._cptr, value)
    requestedAuthnContext = property(get_requestedAuthnContext, set_requestedAuthnContext)

    def get_scoping(self):
        t = _lasso.Samlp2AuthnRequest_scoping_get(self._cptr)
        return cptrToPy(t)
    def set_scoping(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthnRequest_scoping_set(self._cptr, value)
    scoping = property(get_scoping, set_scoping)

    def get_forceAuthn(self):
        return _lasso.Samlp2AuthnRequest_forceAuthn_get(self._cptr)
    def set_forceAuthn(self, value):
        _lasso.Samlp2AuthnRequest_forceAuthn_set(self._cptr, value)
    forceAuthn = property(get_forceAuthn, set_forceAuthn)

    def get_isPassive(self):
        return _lasso.Samlp2AuthnRequest_isPassive_get(self._cptr)
    def set_isPassive(self, value):
        _lasso.Samlp2AuthnRequest_isPassive_set(self._cptr, value)
    isPassive = property(get_isPassive, set_isPassive)

    def get_protocolBinding(self):
        return _lasso.Samlp2AuthnRequest_protocolBinding_get(self._cptr)
    def set_protocolBinding(self, value):
        _lasso.Samlp2AuthnRequest_protocolBinding_set(self._cptr, value)
    protocolBinding = property(get_protocolBinding, set_protocolBinding)

    def get_assertionConsumerServiceIndex(self):
        return _lasso.Samlp2AuthnRequest_assertionConsumerServiceIndex_get(self._cptr)
    def set_assertionConsumerServiceIndex(self, value):
        _lasso.Samlp2AuthnRequest_assertionConsumerServiceIndex_set(self._cptr, value)
    assertionConsumerServiceIndex = property(get_assertionConsumerServiceIndex, set_assertionConsumerServiceIndex)

    def get_assertionConsumerServiceURL(self):
        return _lasso.Samlp2AuthnRequest_assertionConsumerServiceURL_get(self._cptr)
    def set_assertionConsumerServiceURL(self, value):
        _lasso.Samlp2AuthnRequest_assertionConsumerServiceURL_set(self._cptr, value)
    assertionConsumerServiceURL = property(get_assertionConsumerServiceURL, set_assertionConsumerServiceURL)

    def get_attributeConsumingServiceIndex(self):
        return _lasso.Samlp2AuthnRequest_attributeConsumingServiceIndex_get(self._cptr)
    def set_attributeConsumingServiceIndex(self, value):
        _lasso.Samlp2AuthnRequest_attributeConsumingServiceIndex_set(self._cptr, value)
    attributeConsumingServiceIndex = property(get_attributeConsumingServiceIndex, set_attributeConsumingServiceIndex)

    def get_providerName(self):
        return _lasso.Samlp2AuthnRequest_providerName_get(self._cptr)
    def set_providerName(self, value):
        _lasso.Samlp2AuthnRequest_providerName_set(self._cptr, value)
    providerName = property(get_providerName, set_providerName)

    def get_relayState(self):
        return _lasso.Samlp2AuthnRequest_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.Samlp2AuthnRequest_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)


class Samlp2Extensions(Node):
    pass

class Saml2Advice(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_advice_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_assertionIdRef(self):
        l = _lasso.Saml2Advice_assertionIdRef_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertionIdRef(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Advice_assertionIdRef_set(self._cptr, value)
    assertionIdRef = property(get_assertionIdRef, set_assertionIdRef)

    def get_assertionURIRef(self):
        l = _lasso.Saml2Advice_assertionURIRef_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertionURIRef(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Advice_assertionURIRef_set(self._cptr, value)
    assertionURIRef = property(get_assertionURIRef, set_assertionURIRef)

    def get_assertion(self):
        l = _lasso.Saml2Advice_assertion_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertion(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Advice_assertion_set(self._cptr, value)
    assertion = property(get_assertion, set_assertion)

    def get_encryptedAssertion(self):
        l = _lasso.Saml2Advice_encryptedAssertion_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_encryptedAssertion(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Advice_encryptedAssertion_set(self._cptr, value)
    encryptedAssertion = property(get_encryptedAssertion, set_encryptedAssertion)


class Saml2Evidence(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_evidence_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_assertionIdRef(self):
        l = _lasso.Saml2Evidence_assertionIdRef_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertionIdRef(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Evidence_assertionIdRef_set(self._cptr, value)
    assertionIdRef = property(get_assertionIdRef, set_assertionIdRef)

    def get_assertionURIRef(self):
        l = _lasso.Saml2Evidence_assertionURIRef_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertionURIRef(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Evidence_assertionURIRef_set(self._cptr, value)
    assertionURIRef = property(get_assertionURIRef, set_assertionURIRef)

    def get_assertion(self):
        l = _lasso.Saml2Evidence_assertion_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertion(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Evidence_assertion_set(self._cptr, value)
    assertion = property(get_assertion, set_assertion)

    def get_encryptedAssertion(self):
        l = _lasso.Saml2Evidence_encryptedAssertion_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_encryptedAssertion(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Evidence_encryptedAssertion_set(self._cptr, value)
    encryptedAssertion = property(get_encryptedAssertion, set_encryptedAssertion)


class Saml2SubjectLocality(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_subject_locality_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_address(self):
        return _lasso.Saml2SubjectLocality_address_get(self._cptr)
    def set_address(self, value):
        _lasso.Saml2SubjectLocality_address_set(self._cptr, value)
    address = property(get_address, set_address)

    def get_dNSName(self):
        return _lasso.Saml2SubjectLocality_dNSName_get(self._cptr)
    def set_dNSName(self, value):
        _lasso.Saml2SubjectLocality_dNSName_set(self._cptr, value)
    dNSName = property(get_dNSName, set_dNSName)


class Samlp2RequestedAuthnContext(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_requested_authn_context_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_authnContextClassRef(self):
        return _lasso.Samlp2RequestedAuthnContext_authnContextClassRef_get(self._cptr)
    def set_authnContextClassRef(self, value):
        _lasso.Samlp2RequestedAuthnContext_authnContextClassRef_set(self._cptr, value)
    authnContextClassRef = property(get_authnContextClassRef, set_authnContextClassRef)

    def get_authnContextDeclRef(self):
        return _lasso.Samlp2RequestedAuthnContext_authnContextDeclRef_get(self._cptr)
    def set_authnContextDeclRef(self, value):
        _lasso.Samlp2RequestedAuthnContext_authnContextDeclRef_set(self._cptr, value)
    authnContextDeclRef = property(get_authnContextDeclRef, set_authnContextDeclRef)

    def get_comparison(self):
        return _lasso.Samlp2RequestedAuthnContext_comparison_get(self._cptr)
    def set_comparison(self, value):
        _lasso.Samlp2RequestedAuthnContext_comparison_set(self._cptr, value)
    comparison = property(get_comparison, set_comparison)


class Samlp2SubjectQueryAbstract(Samlp2RequestAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_subject_query_abstract_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_subject(self):
        t = _lasso.Samlp2SubjectQueryAbstract_subject_get(self._cptr)
        return cptrToPy(t)
    def set_subject(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2SubjectQueryAbstract_subject_set(self._cptr, value)
    subject = property(get_subject, set_subject)


class Samlp2AuthnQuery(Samlp2SubjectQueryAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_authn_query_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_requestedAuthnContext(self):
        t = _lasso.Samlp2AuthnQuery_requestedAuthnContext_get(self._cptr)
        return cptrToPy(t)
    def set_requestedAuthnContext(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthnQuery_requestedAuthnContext_set(self._cptr, value)
    requestedAuthnContext = property(get_requestedAuthnContext, set_requestedAuthnContext)

    def get_sessionIndex(self):
        return _lasso.Samlp2AuthnQuery_sessionIndex_get(self._cptr)
    def set_sessionIndex(self, value):
        _lasso.Samlp2AuthnQuery_sessionIndex_set(self._cptr, value)
    sessionIndex = property(get_sessionIndex, set_sessionIndex)


class Samlp2Status(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_status_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_statusCode(self):
        t = _lasso.Samlp2Status_statusCode_get(self._cptr)
        return cptrToPy(t)
    def set_statusCode(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2Status_statusCode_set(self._cptr, value)
    statusCode = property(get_statusCode, set_statusCode)

    def get_statusMessage(self):
        return _lasso.Samlp2Status_statusMessage_get(self._cptr)
    def set_statusMessage(self, value):
        _lasso.Samlp2Status_statusMessage_set(self._cptr, value)
    statusMessage = property(get_statusMessage, set_statusMessage)

    def get_statusDetail(self):
        t = _lasso.Samlp2Status_statusDetail_get(self._cptr)
        return cptrToPy(t)
    def set_statusDetail(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2Status_statusDetail_set(self._cptr, value)
    statusDetail = property(get_statusDetail, set_statusDetail)


class Saml2AuthnContext(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_authn_context_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_authnContextClassRef(self):
        return _lasso.Saml2AuthnContext_authnContextClassRef_get(self._cptr)
    def set_authnContextClassRef(self, value):
        _lasso.Saml2AuthnContext_authnContextClassRef_set(self._cptr, value)
    authnContextClassRef = property(get_authnContextClassRef, set_authnContextClassRef)

    def get_authnContextDeclRef(self):
        return _lasso.Saml2AuthnContext_authnContextDeclRef_get(self._cptr)
    def set_authnContextDeclRef(self, value):
        _lasso.Saml2AuthnContext_authnContextDeclRef_set(self._cptr, value)
    authnContextDeclRef = property(get_authnContextDeclRef, set_authnContextDeclRef)

    def get_authenticatingAuthority(self):
        return _lasso.Saml2AuthnContext_authenticatingAuthority_get(self._cptr)
    def set_authenticatingAuthority(self, value):
        _lasso.Saml2AuthnContext_authenticatingAuthority_set(self._cptr, value)
    authenticatingAuthority = property(get_authenticatingAuthority, set_authenticatingAuthority)


class Saml2ProxyRestriction(Saml2ConditionAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml2_proxy_restriction_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_audience(self):
        return _lasso.Saml2ProxyRestriction_audience_get(self._cptr)
    def set_audience(self, value):
        _lasso.Saml2ProxyRestriction_audience_set(self._cptr, value)
    audience = property(get_audience, set_audience)

    def get_count(self):
        return _lasso.Saml2ProxyRestriction_count_get(self._cptr)
    def set_count(self, value):
        _lasso.Saml2ProxyRestriction_count_set(self._cptr, value)
    count = property(get_count, set_count)


class Saml2EncryptedElement(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_encrypted_element_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_encryptedData(self):
        return _lasso.Saml2EncryptedElement_encryptedData_get(self._cptr)
    def set_encryptedData(self, value):
        _lasso.Saml2EncryptedElement_encryptedData_set(self._cptr, value)
    encryptedData = property(get_encryptedData, set_encryptedData)

    def get_encryptedKey(self):
        return _lasso.Saml2EncryptedElement_encryptedKey_get(self._cptr)
    def set_encryptedKey(self, value):
        _lasso.Saml2EncryptedElement_encryptedKey_set(self._cptr, value)
    encryptedKey = property(get_encryptedKey, set_encryptedKey)

    def get_originalData(self):
        t = _lasso.Saml2EncryptedElement_originalData_get(self._cptr)
        return cptrToPy(t)
    def set_originalData(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2EncryptedElement_originalData_set(self._cptr, value)
    originalData = property(get_originalData, set_originalData)


class Samlp2AuthzDecisionQuery(Samlp2SubjectQueryAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_authz_decision_query_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_action(self):
        t = _lasso.Samlp2AuthzDecisionQuery_action_get(self._cptr)
        return cptrToPy(t)
    def set_action(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthzDecisionQuery_action_set(self._cptr, value)
    action = property(get_action, set_action)

    def get_evidence(self):
        t = _lasso.Samlp2AuthzDecisionQuery_evidence_get(self._cptr)
        return cptrToPy(t)
    def set_evidence(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2AuthzDecisionQuery_evidence_set(self._cptr, value)
    evidence = property(get_evidence, set_evidence)

    def get_resource(self):
        return _lasso.Samlp2AuthzDecisionQuery_resource_get(self._cptr)
    def set_resource(self, value):
        _lasso.Samlp2AuthzDecisionQuery_resource_set(self._cptr, value)
    resource = property(get_resource, set_resource)


class Samlp2StatusDetail(Node):
    pass

class Saml2Conditions(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_conditions_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_condition(self):
        l = _lasso.Saml2Conditions_condition_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_condition(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Conditions_condition_set(self._cptr, value)
    condition = property(get_condition, set_condition)

    def get_audienceRestriction(self):
        l = _lasso.Saml2Conditions_audienceRestriction_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_audienceRestriction(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Conditions_audienceRestriction_set(self._cptr, value)
    audienceRestriction = property(get_audienceRestriction, set_audienceRestriction)

    def get_oneTimeUse(self):
        l = _lasso.Saml2Conditions_oneTimeUse_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_oneTimeUse(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Conditions_oneTimeUse_set(self._cptr, value)
    oneTimeUse = property(get_oneTimeUse, set_oneTimeUse)

    def get_proxyRestriction(self):
        l = _lasso.Saml2Conditions_proxyRestriction_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_proxyRestriction(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Conditions_proxyRestriction_set(self._cptr, value)
    proxyRestriction = property(get_proxyRestriction, set_proxyRestriction)

    def get_notBefore(self):
        return _lasso.Saml2Conditions_notBefore_get(self._cptr)
    def set_notBefore(self, value):
        _lasso.Saml2Conditions_notBefore_set(self._cptr, value)
    notBefore = property(get_notBefore, set_notBefore)

    def get_notOnOrAfter(self):
        return _lasso.Saml2Conditions_notOnOrAfter_get(self._cptr)
    def set_notOnOrAfter(self, value):
        _lasso.Saml2Conditions_notOnOrAfter_set(self._cptr, value)
    notOnOrAfter = property(get_notOnOrAfter, set_notOnOrAfter)


class Samlp2StatusCode(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_status_code_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_statusCode(self):
        t = _lasso.Samlp2StatusCode_statusCode_get(self._cptr)
        return cptrToPy(t)
    def set_statusCode(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2StatusCode_statusCode_set(self._cptr, value)
    statusCode = property(get_statusCode, set_statusCode)

    def get_value(self):
        return _lasso.Samlp2StatusCode_value_get(self._cptr)
    def set_value(self, value):
        _lasso.Samlp2StatusCode_value_set(self._cptr, value)
    value = property(get_value, set_value)


class Saml2Subject(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_subject_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_baseId(self):
        t = _lasso.Saml2Subject_baseId_get(self._cptr)
        return cptrToPy(t)
    def set_baseId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Subject_baseId_set(self._cptr, value)
    baseId = property(get_baseId, set_baseId)

    def get_nameId(self):
        t = _lasso.Saml2Subject_nameId_get(self._cptr)
        return cptrToPy(t)
    def set_nameId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Subject_nameId_set(self._cptr, value)
    nameId = property(get_nameId, set_nameId)

    def get_encryptedId(self):
        t = _lasso.Saml2Subject_encryptedId_get(self._cptr)
        return cptrToPy(t)
    def set_encryptedId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Subject_encryptedId_set(self._cptr, value)
    encryptedId = property(get_encryptedId, set_encryptedId)

    def get_subjectConfirmation(self):
        t = _lasso.Saml2Subject_subjectConfirmation_get(self._cptr)
        return cptrToPy(t)
    def set_subjectConfirmation(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Subject_subjectConfirmation_set(self._cptr, value)
    subjectConfirmation = property(get_subjectConfirmation, set_subjectConfirmation)


class Samlp2AssertionIDRequest(Samlp2RequestAbstract):
    def get_assertionIdRef(self):
        return _lasso.Samlp2AssertionIDRequest_assertionIdRef_get(self._cptr)
    def set_assertionIdRef(self, value):
        _lasso.Samlp2AssertionIDRequest_assertionIdRef_set(self._cptr, value)
    assertionIdRef = property(get_assertionIdRef, set_assertionIdRef)


class Saml2Attribute(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_attribute_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_attributeValue(self):
        l = _lasso.Saml2Attribute_attributeValue_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_attributeValue(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Attribute_attributeValue_set(self._cptr, value)
    attributeValue = property(get_attributeValue, set_attributeValue)

    def get_name(self):
        return _lasso.Saml2Attribute_name_get(self._cptr)
    def set_name(self, value):
        _lasso.Saml2Attribute_name_set(self._cptr, value)
    name = property(get_name, set_name)

    def get_nameFormat(self):
        return _lasso.Saml2Attribute_nameFormat_get(self._cptr)
    def set_nameFormat(self, value):
        _lasso.Saml2Attribute_nameFormat_set(self._cptr, value)
    nameFormat = property(get_nameFormat, set_nameFormat)

    def get_friendlyName(self):
        return _lasso.Saml2Attribute_friendlyName_get(self._cptr)
    def set_friendlyName(self, value):
        _lasso.Saml2Attribute_friendlyName_set(self._cptr, value)
    friendlyName = property(get_friendlyName, set_friendlyName)


class Saml2StatementAbstract(Node):
    pass

class Saml2AuthnStatement(Saml2StatementAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml2_authn_statement_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_subjectLocality(self):
        t = _lasso.Saml2AuthnStatement_subjectLocality_get(self._cptr)
        return cptrToPy(t)
    def set_subjectLocality(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2AuthnStatement_subjectLocality_set(self._cptr, value)
    subjectLocality = property(get_subjectLocality, set_subjectLocality)

    def get_authnContext(self):
        t = _lasso.Saml2AuthnStatement_authnContext_get(self._cptr)
        return cptrToPy(t)
    def set_authnContext(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2AuthnStatement_authnContext_set(self._cptr, value)
    authnContext = property(get_authnContext, set_authnContext)

    def get_authnInstant(self):
        return _lasso.Saml2AuthnStatement_authnInstant_get(self._cptr)
    def set_authnInstant(self, value):
        _lasso.Saml2AuthnStatement_authnInstant_set(self._cptr, value)
    authnInstant = property(get_authnInstant, set_authnInstant)

    def get_sessionIndex(self):
        return _lasso.Saml2AuthnStatement_sessionIndex_get(self._cptr)
    def set_sessionIndex(self, value):
        _lasso.Saml2AuthnStatement_sessionIndex_set(self._cptr, value)
    sessionIndex = property(get_sessionIndex, set_sessionIndex)

    def get_sessionNotOnOrAfter(self):
        return _lasso.Saml2AuthnStatement_sessionNotOnOrAfter_get(self._cptr)
    def set_sessionNotOnOrAfter(self, value):
        _lasso.Saml2AuthnStatement_sessionNotOnOrAfter_set(self._cptr, value)
    sessionNotOnOrAfter = property(get_sessionNotOnOrAfter, set_sessionNotOnOrAfter)


class Saml2AuthzDecisionStatement(Saml2StatementAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml2_authz_decision_statement_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_action(self):
        t = _lasso.Saml2AuthzDecisionStatement_action_get(self._cptr)
        return cptrToPy(t)
    def set_action(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2AuthzDecisionStatement_action_set(self._cptr, value)
    action = property(get_action, set_action)

    def get_evidence(self):
        t = _lasso.Saml2AuthzDecisionStatement_evidence_get(self._cptr)
        return cptrToPy(t)
    def set_evidence(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2AuthzDecisionStatement_evidence_set(self._cptr, value)
    evidence = property(get_evidence, set_evidence)

    def get_resource(self):
        return _lasso.Saml2AuthzDecisionStatement_resource_get(self._cptr)
    def set_resource(self, value):
        _lasso.Saml2AuthzDecisionStatement_resource_set(self._cptr, value)
    resource = property(get_resource, set_resource)

    def get_decision(self):
        return _lasso.Saml2AuthzDecisionStatement_decision_get(self._cptr)
    def set_decision(self, value):
        _lasso.Saml2AuthzDecisionStatement_decision_set(self._cptr, value)
    decision = property(get_decision, set_decision)


class Saml2AttributeStatement(Saml2StatementAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml2_attribute_statement_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_attribute(self):
        l = _lasso.Saml2AttributeStatement_attribute_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_attribute(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2AttributeStatement_attribute_set(self._cptr, value)
    attribute = property(get_attribute, set_attribute)

    def get_encryptedAttribute(self):
        l = _lasso.Saml2AttributeStatement_encryptedAttribute_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_encryptedAttribute(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2AttributeStatement_encryptedAttribute_set(self._cptr, value)
    encryptedAttribute = property(get_encryptedAttribute, set_encryptedAttribute)


class Saml2SubjectConfirmationData(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_subject_confirmation_data_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_notBefore(self):
        return _lasso.Saml2SubjectConfirmationData_notBefore_get(self._cptr)
    def set_notBefore(self, value):
        _lasso.Saml2SubjectConfirmationData_notBefore_set(self._cptr, value)
    notBefore = property(get_notBefore, set_notBefore)

    def get_notOnOrAfter(self):
        return _lasso.Saml2SubjectConfirmationData_notOnOrAfter_get(self._cptr)
    def set_notOnOrAfter(self, value):
        _lasso.Saml2SubjectConfirmationData_notOnOrAfter_set(self._cptr, value)
    notOnOrAfter = property(get_notOnOrAfter, set_notOnOrAfter)

    def get_recipient(self):
        return _lasso.Saml2SubjectConfirmationData_recipient_get(self._cptr)
    def set_recipient(self, value):
        _lasso.Saml2SubjectConfirmationData_recipient_set(self._cptr, value)
    recipient = property(get_recipient, set_recipient)

    def get_inResponseTo(self):
        return _lasso.Saml2SubjectConfirmationData_inResponseTo_get(self._cptr)
    def set_inResponseTo(self, value):
        _lasso.Saml2SubjectConfirmationData_inResponseTo_set(self._cptr, value)
    inResponseTo = property(get_inResponseTo, set_inResponseTo)

    def get_address(self):
        return _lasso.Saml2SubjectConfirmationData_address_get(self._cptr)
    def set_address(self, value):
        _lasso.Saml2SubjectConfirmationData_address_set(self._cptr, value)
    address = property(get_address, set_address)


class Saml2OneTimeUse(Saml2ConditionAbstract):
    pass

class Saml2KeyInfoConfirmationData(Node):
    pass

class Saml2Action(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_action_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newWithString(cls, content):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.saml2_action_new_with_string(content)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_content(self):
        return _lasso.Saml2Action_content_get(self._cptr)
    def set_content(self, value):
        _lasso.Saml2Action_content_set(self._cptr, value)
    content = property(get_content, set_content)

    def get_namespace(self):
        return _lasso.Saml2Action_namespace_get(self._cptr)
    def set_namespace(self, value):
        _lasso.Saml2Action_namespace_set(self._cptr, value)
    namespace = property(get_namespace, set_namespace)


class Samlp2Scoping(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_scoping_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_iDPList(self):
        t = _lasso.Samlp2Scoping_iDPList_get(self._cptr)
        return cptrToPy(t)
    def set_iDPList(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2Scoping_iDPList_set(self._cptr, value)
    iDPList = property(get_iDPList, set_iDPList)

    def get_requesterId(self):
        return _lasso.Samlp2Scoping_requesterId_get(self._cptr)
    def set_requesterId(self, value):
        _lasso.Samlp2Scoping_requesterId_set(self._cptr, value)
    requesterId = property(get_requesterId, set_requesterId)

    def get_proxyCount(self):
        return _lasso.Samlp2Scoping_proxyCount_get(self._cptr)
    def set_proxyCount(self, value):
        _lasso.Samlp2Scoping_proxyCount_set(self._cptr, value)
    proxyCount = property(get_proxyCount, set_proxyCount)


class Samlp2AttributeQuery(Samlp2SubjectQueryAbstract):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_attribute_query_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_attribute(self):
        l = _lasso.Samlp2AttributeQuery_attribute_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_attribute(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Samlp2AttributeQuery_attribute_set(self._cptr, value)
    attribute = property(get_attribute, set_attribute)


class Samlp2NameIDPolicy(Node):
    def get_format(self):
        return _lasso.Samlp2NameIDPolicy_format_get(self._cptr)
    def set_format(self, value):
        _lasso.Samlp2NameIDPolicy_format_set(self._cptr, value)
    format = property(get_format, set_format)

    def get_sPNameQualifier(self):
        return _lasso.Samlp2NameIDPolicy_sPNameQualifier_get(self._cptr)
    def set_sPNameQualifier(self, value):
        _lasso.Samlp2NameIDPolicy_sPNameQualifier_set(self._cptr, value)
    sPNameQualifier = property(get_sPNameQualifier, set_sPNameQualifier)

    def get_allowCreate(self):
        return _lasso.Samlp2NameIDPolicy_allowCreate_get(self._cptr)
    def set_allowCreate(self, value):
        _lasso.Samlp2NameIDPolicy_allowCreate_set(self._cptr, value)
    allowCreate = property(get_allowCreate, set_allowCreate)


class Saml2AudienceRestriction(Saml2ConditionAbstract):
    def __init__(self, ):
        self._cptr = _lasso.saml2_audience_restriction_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_audience(self):
        return _lasso.Saml2AudienceRestriction_audience_get(self._cptr)
    def set_audience(self, value):
        _lasso.Saml2AudienceRestriction_audience_set(self._cptr, value)
    audience = property(get_audience, set_audience)


class Saml2NameID(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_name_id_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newWithString(cls, content):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.saml2_name_id_new_with_string(content)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_content(self):
        return _lasso.Saml2NameID_content_get(self._cptr)
    def set_content(self, value):
        _lasso.Saml2NameID_content_set(self._cptr, value)
    content = property(get_content, set_content)

    def get_format(self):
        return _lasso.Saml2NameID_format_get(self._cptr)
    def set_format(self, value):
        _lasso.Saml2NameID_format_set(self._cptr, value)
    format = property(get_format, set_format)

    def get_sPProvidedId(self):
        return _lasso.Saml2NameID_sPProvidedId_get(self._cptr)
    def set_sPProvidedId(self, value):
        _lasso.Saml2NameID_sPProvidedId_set(self._cptr, value)
    sPProvidedId = property(get_sPProvidedId, set_sPProvidedId)

    def get_nameQualifier(self):
        return _lasso.Saml2NameID_nameQualifier_get(self._cptr)
    def set_nameQualifier(self, value):
        _lasso.Saml2NameID_nameQualifier_set(self._cptr, value)
    nameQualifier = property(get_nameQualifier, set_nameQualifier)

    def get_sPNameQualifier(self):
        return _lasso.Saml2NameID_sPNameQualifier_get(self._cptr)
    def set_sPNameQualifier(self, value):
        _lasso.Saml2NameID_sPNameQualifier_set(self._cptr, value)
    sPNameQualifier = property(get_sPNameQualifier, set_sPNameQualifier)


class Saml2BaseIDAbstract(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_base_idabstract_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_nameQualifier(self):
        return _lasso.Saml2BaseIDAbstract_nameQualifier_get(self._cptr)
    def set_nameQualifier(self, value):
        _lasso.Saml2BaseIDAbstract_nameQualifier_set(self._cptr, value)
    nameQualifier = property(get_nameQualifier, set_nameQualifier)

    def get_sPNameQualifier(self):
        return _lasso.Saml2BaseIDAbstract_sPNameQualifier_get(self._cptr)
    def set_sPNameQualifier(self, value):
        _lasso.Saml2BaseIDAbstract_sPNameQualifier_set(self._cptr, value)
    sPNameQualifier = property(get_sPNameQualifier, set_sPNameQualifier)


class Samlp2ManageNameIDRequest(Samlp2RequestAbstract):
    def get_nameId(self):
        t = _lasso.Samlp2ManageNameIDRequest_nameId_get(self._cptr)
        return cptrToPy(t)
    def set_nameId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2ManageNameIDRequest_nameId_set(self._cptr, value)
    nameId = property(get_nameId, set_nameId)

    def get_encryptedId(self):
        t = _lasso.Samlp2ManageNameIDRequest_encryptedId_get(self._cptr)
        return cptrToPy(t)
    def set_encryptedId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2ManageNameIDRequest_encryptedId_set(self._cptr, value)
    encryptedId = property(get_encryptedId, set_encryptedId)

    def get_newId(self):
        return _lasso.Samlp2ManageNameIDRequest_newId_get(self._cptr)
    def set_newId(self, value):
        _lasso.Samlp2ManageNameIDRequest_newId_set(self._cptr, value)
    newId = property(get_newId, set_newId)

    def get_newEncryptedId(self):
        t = _lasso.Samlp2ManageNameIDRequest_newEncryptedId_get(self._cptr)
        return cptrToPy(t)
    def set_newEncryptedId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2ManageNameIDRequest_newEncryptedId_set(self._cptr, value)
    newEncryptedId = property(get_newEncryptedId, set_newEncryptedId)

    def get_terminate(self):
        t = _lasso.Samlp2ManageNameIDRequest_terminate_get(self._cptr)
        return cptrToPy(t)
    def set_terminate(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2ManageNameIDRequest_terminate_set(self._cptr, value)
    terminate = property(get_terminate, set_terminate)


class Samlp2IDPEntry(Node):
    def get_providerId(self):
        return _lasso.Samlp2IDPEntry_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.Samlp2IDPEntry_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_name(self):
        return _lasso.Samlp2IDPEntry_name_get(self._cptr)
    def set_name(self, value):
        _lasso.Samlp2IDPEntry_name_set(self._cptr, value)
    name = property(get_name, set_name)

    def get_loc(self):
        return _lasso.Samlp2IDPEntry_loc_get(self._cptr)
    def set_loc(self, value):
        _lasso.Samlp2IDPEntry_loc_set(self._cptr, value)
    loc = property(get_loc, set_loc)


class Saml2Assertion(Node):
    def __init__(self, ):
        self._cptr = _lasso.saml2_assertion_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_issuer(self):
        t = _lasso.Saml2Assertion_issuer_get(self._cptr)
        return cptrToPy(t)
    def set_issuer(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Assertion_issuer_set(self._cptr, value)
    issuer = property(get_issuer, set_issuer)

    def get_subject(self):
        t = _lasso.Saml2Assertion_subject_get(self._cptr)
        return cptrToPy(t)
    def set_subject(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Assertion_subject_set(self._cptr, value)
    subject = property(get_subject, set_subject)

    def get_conditions(self):
        t = _lasso.Saml2Assertion_conditions_get(self._cptr)
        return cptrToPy(t)
    def set_conditions(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Assertion_conditions_set(self._cptr, value)
    conditions = property(get_conditions, set_conditions)

    def get_advice(self):
        t = _lasso.Saml2Assertion_advice_get(self._cptr)
        return cptrToPy(t)
    def set_advice(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Saml2Assertion_advice_set(self._cptr, value)
    advice = property(get_advice, set_advice)

    def get_statement(self):
        l = _lasso.Saml2Assertion_statement_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_statement(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Assertion_statement_set(self._cptr, value)
    statement = property(get_statement, set_statement)

    def get_authnStatement(self):
        l = _lasso.Saml2Assertion_authnStatement_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_authnStatement(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Assertion_authnStatement_set(self._cptr, value)
    authnStatement = property(get_authnStatement, set_authnStatement)

    def get_authzDecisionStatement(self):
        l = _lasso.Saml2Assertion_authzDecisionStatement_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_authzDecisionStatement(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Assertion_authzDecisionStatement_set(self._cptr, value)
    authzDecisionStatement = property(get_authzDecisionStatement, set_authzDecisionStatement)

    def get_attributeStatement(self):
        l = _lasso.Saml2Assertion_attributeStatement_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_attributeStatement(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Saml2Assertion_attributeStatement_set(self._cptr, value)
    attributeStatement = property(get_attributeStatement, set_attributeStatement)

    def get_version(self):
        return _lasso.Saml2Assertion_version_get(self._cptr)
    def set_version(self, value):
        _lasso.Saml2Assertion_version_set(self._cptr, value)
    version = property(get_version, set_version)

    def get_iD(self):
        return _lasso.Saml2Assertion_iD_get(self._cptr)
    def set_iD(self, value):
        _lasso.Saml2Assertion_iD_set(self._cptr, value)
    iD = property(get_iD, set_iD)

    def get_issueInstant(self):
        return _lasso.Saml2Assertion_issueInstant_get(self._cptr)
    def set_issueInstant(self, value):
        _lasso.Saml2Assertion_issueInstant_set(self._cptr, value)
    issueInstant = property(get_issueInstant, set_issueInstant)


class Samlp2IDPList(Node):
    def get_iDPEntry(self):
        t = _lasso.Samlp2IDPList_iDPEntry_get(self._cptr)
        return cptrToPy(t)
    def set_iDPEntry(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2IDPList_iDPEntry_set(self._cptr, value)
    iDPEntry = property(get_iDPEntry, set_iDPEntry)

    def get_getComplete(self):
        return _lasso.Samlp2IDPList_getComplete_get(self._cptr)
    def set_getComplete(self, value):
        _lasso.Samlp2IDPList_getComplete_set(self._cptr, value)
    getComplete = property(get_getComplete, set_getComplete)


class Samlp2StatusResponse(Node):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_status_response_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_issuer(self):
        t = _lasso.Samlp2StatusResponse_issuer_get(self._cptr)
        return cptrToPy(t)
    def set_issuer(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2StatusResponse_issuer_set(self._cptr, value)
    issuer = property(get_issuer, set_issuer)

    def get_extensions(self):
        t = _lasso.Samlp2StatusResponse_extensions_get(self._cptr)
        return cptrToPy(t)
    def set_extensions(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2StatusResponse_extensions_set(self._cptr, value)
    extensions = property(get_extensions, set_extensions)

    def get_status(self):
        t = _lasso.Samlp2StatusResponse_status_get(self._cptr)
        return cptrToPy(t)
    def set_status(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2StatusResponse_status_set(self._cptr, value)
    status = property(get_status, set_status)

    def get_iD(self):
        return _lasso.Samlp2StatusResponse_iD_get(self._cptr)
    def set_iD(self, value):
        _lasso.Samlp2StatusResponse_iD_set(self._cptr, value)
    iD = property(get_iD, set_iD)

    def get_inResponseTo(self):
        return _lasso.Samlp2StatusResponse_inResponseTo_get(self._cptr)
    def set_inResponseTo(self, value):
        _lasso.Samlp2StatusResponse_inResponseTo_set(self._cptr, value)
    inResponseTo = property(get_inResponseTo, set_inResponseTo)

    def get_version(self):
        return _lasso.Samlp2StatusResponse_version_get(self._cptr)
    def set_version(self, value):
        _lasso.Samlp2StatusResponse_version_set(self._cptr, value)
    version = property(get_version, set_version)

    def get_issueInstant(self):
        return _lasso.Samlp2StatusResponse_issueInstant_get(self._cptr)
    def set_issueInstant(self, value):
        _lasso.Samlp2StatusResponse_issueInstant_set(self._cptr, value)
    issueInstant = property(get_issueInstant, set_issueInstant)

    def get_destination(self):
        return _lasso.Samlp2StatusResponse_destination_get(self._cptr)
    def set_destination(self, value):
        _lasso.Samlp2StatusResponse_destination_set(self._cptr, value)
    destination = property(get_destination, set_destination)

    def get_consent(self):
        return _lasso.Samlp2StatusResponse_consent_get(self._cptr)
    def set_consent(self, value):
        _lasso.Samlp2StatusResponse_consent_set(self._cptr, value)
    consent = property(get_consent, set_consent)


class Samlp2NameIDMappingResponse(Samlp2StatusResponse):
    def get_nameId(self):
        t = _lasso.Samlp2NameIDMappingResponse_nameId_get(self._cptr)
        return cptrToPy(t)
    def set_nameId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2NameIDMappingResponse_nameId_set(self._cptr, value)
    nameId = property(get_nameId, set_nameId)

    def get_encryptedId(self):
        t = _lasso.Samlp2NameIDMappingResponse_encryptedId_get(self._cptr)
        return cptrToPy(t)
    def set_encryptedId(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2NameIDMappingResponse_encryptedId_set(self._cptr, value)
    encryptedId = property(get_encryptedId, set_encryptedId)


class Samlp2ManageNameIDResponse(Samlp2StatusResponse):
    pass

class Samlp2LogoutResponse(Samlp2StatusResponse):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_logout_response_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_relayState(self):
        return _lasso.Samlp2LogoutResponse_relayState_get(self._cptr)
    def set_relayState(self, value):
        _lasso.Samlp2LogoutResponse_relayState_set(self._cptr, value)
    relayState = property(get_relayState, set_relayState)


class Samlp2ArtifactResponse(Samlp2StatusResponse):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_artifact_response_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_any(self):
        t = _lasso.Samlp2ArtifactResponse_any_get(self._cptr)
        return cptrToPy(t)
    def set_any(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Samlp2ArtifactResponse_any_set(self._cptr, value)
    any = property(get_any, set_any)


class Samlp2Response(Samlp2StatusResponse):
    def __init__(self, ):
        self._cptr = _lasso.samlp2_response_new()
        if self._cptr is None:
            raise Error('failed to create object')

    def get_assertion(self):
        l = _lasso.Samlp2Response_assertion_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_assertion(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Samlp2Response_assertion_set(self._cptr, value)
    assertion = property(get_assertion, set_assertion)

    def get_encryptedAssertion(self):
        l = _lasso.Samlp2Response_encryptedAssertion_get(self._cptr)
        if not l: return l
        return tuple([cptrToPy(x) for x in l])
    def set_encryptedAssertion(self, value):
        if value is not None:
            value = tuple([x._cptr for x in value])
        _lasso.Samlp2Response_encryptedAssertion_set(self._cptr, value)
    encryptedAssertion = property(get_encryptedAssertion, set_encryptedAssertion)


class Session(Node):
    def __init__(self, ):
        self._cptr = _lasso.session_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.session_new_from_dump(dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_assertions(self):
        d = _lasso.Session_assertions_get(self._cptr)
        if not d: return d
        d2 = {}
        for k, v in d.items():
            d2[k] = cptrToPy(v)
        return frozendict(d2)
    def set_assertions(self, value):
        _lasso.Session_assertions_set(self._cptr, value)
    assertions = property(get_assertions, set_assertions)

    def get_isDirty(self):
        return _lasso.Session_isDirty_get(self._cptr)
    def set_isDirty(self, value):
        _lasso.Session_isDirty_set(self._cptr, value)
    isDirty = property(get_isDirty, set_isDirty)

    def dump(self):
        '''
        Dumps C{self} content to an XML string.
        
        @return: the dump string.
        '''
        return _lasso.session_dump(self._cptr)

    def getAssertions(self, provider_id = None):
        '''
        Gets the assertions for the given C{provider_id}.
        
        @param provider_id:  the provider ID
        @return: a GList* of L{SamlAssertion}.  Caller must free the GList but
            NOT the assertions it contains.
        '''
        value = _lasso.session_get_assertions(self._cptr, provider_id)
        if value is not None:
            value = tuple([cptrToPy(x) for x in value])
        return value

    def getProviderIndex(self, index):
        '''
        Looks up and returns the nth provider id.
        
        @param index:  index of requested provider
        @return: the provider id; or None if there were no nth provider.
        '''
        return _lasso.session_get_provider_index(self._cptr, index)

    def isEmpty(self):
        '''
        Returns True if session is empty.
        
        @return: True if empty
        '''
        return _lasso.session_is_empty(self._cptr)


class Federation(Node):
    def __init__(self, remote_providerID):
        self._cptr = _lasso.federation_new(remote_providerID)
        if self._cptr is None:
            raise Error('failed to create object')

    def get_remoteProviderId(self):
        return _lasso.Federation_remoteProviderId_get(self._cptr)
    def set_remoteProviderId(self, value):
        _lasso.Federation_remoteProviderId_set(self._cptr, value)
    remoteProviderId = property(get_remoteProviderId, set_remoteProviderId)

    def get_localNameIdentifier(self):
        t = _lasso.Federation_localNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_localNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Federation_localNameIdentifier_set(self._cptr, value)
    localNameIdentifier = property(get_localNameIdentifier, set_localNameIdentifier)

    def get_remoteNameIdentifier(self):
        t = _lasso.Federation_remoteNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_remoteNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Federation_remoteNameIdentifier_set(self._cptr, value)
    remoteNameIdentifier = property(get_remoteNameIdentifier, set_remoteNameIdentifier)

    def buildLocalNameIdentifier(self, nameQualifier, format, content):
        '''
        Builds federation local name identifier.
        
        @param nameQualifier:  the name identifier qualifier
        @param format:  the name identifier format
        @param content:  the name identifier content
        '''
        _lasso.federation_build_local_name_identifier(self._cptr, nameQualifier, format, content)

    def verifyNameIdentifier(self, name_identifier):
        '''
        Checks whether federation is for C{name_identifier}.
        
        @param name_identifier:  the L{SamlNameIdentifier}
        @return: True if the federation is for C{name_identifier}.
        '''
        return _lasso.federation_verify_name_identifier(self._cptr, name_identifier._cptr)


class Profile(Node):
    def get_server(self):
        t = _lasso.Profile_server_get(self._cptr)
        return cptrToPy(t)
    def set_server(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Profile_server_set(self._cptr, value)
    server = property(get_server, set_server)

    def get_request(self):
        t = _lasso.Profile_request_get(self._cptr)
        return cptrToPy(t)
    def set_request(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Profile_request_set(self._cptr, value)
    request = property(get_request, set_request)

    def get_response(self):
        t = _lasso.Profile_response_get(self._cptr)
        return cptrToPy(t)
    def set_response(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Profile_response_set(self._cptr, value)
    response = property(get_response, set_response)

    def get_nameIdentifier(self):
        t = _lasso.Profile_nameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_nameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Profile_nameIdentifier_set(self._cptr, value)
    nameIdentifier = property(get_nameIdentifier, set_nameIdentifier)

    def get_remoteProviderId(self):
        return _lasso.Profile_remoteProviderId_get(self._cptr)
    def set_remoteProviderId(self, value):
        _lasso.Profile_remoteProviderId_set(self._cptr, value)
    remoteProviderId = property(get_remoteProviderId, set_remoteProviderId)

    def get_msgUrl(self):
        return _lasso.Profile_msgUrl_get(self._cptr)
    def set_msgUrl(self, value):
        _lasso.Profile_msgUrl_set(self._cptr, value)
    msgUrl = property(get_msgUrl, set_msgUrl)

    def get_msgBody(self):
        return _lasso.Profile_msgBody_get(self._cptr)
    def set_msgBody(self, value):
        _lasso.Profile_msgBody_set(self._cptr, value)
    msgBody = property(get_msgBody, set_msgBody)

    def get_msgRelayState(self):
        return _lasso.Profile_msgRelayState_get(self._cptr)
    def set_msgRelayState(self, value):
        _lasso.Profile_msgRelayState_set(self._cptr, value)
    msgRelayState = property(get_msgRelayState, set_msgRelayState)

    def get_identity(self):
        t = _lasso.profile_get_identity(self._cptr)
        return cptrToPy(t)
    getIdentity = get_identity
    identity = property(get_identity)

    def get_session(self):
        t = _lasso.profile_get_session(self._cptr)
        return cptrToPy(t)
    getSession = get_session
    session = property(get_session)

    def get_profile_get_federation_nameIdentifier(self):
        t = _lasso.profile_get_federation_nameIdentifier(self._cptr)
        return cptrToPy(t)
    profile_get_federation_nameIdentifier = property(get_profile_get_federation_nameIdentifier)

    def get_artifact(self):
        return _lasso.profile_get_artifact(self._cptr)
    getArtifact = get_artifact
    artifact = property(get_artifact)

    def get_artifactMessage(self):
        return _lasso.profile_get_artifact_message(self._cptr)
    getArtifactMessage = get_artifactMessage
    def set_artifactMessage(self, value):
        _lasso.profile_set_artifact_message(self._cptr, value)
    artifactMessage = property(get_artifactMessage, set_artifactMessage)

    def hasDirtyIdentity(self):
        '''
        Checks whether identity has been modified (and should therefore be
        saved).
        
        @return: True if identity has changed
        '''
        return _lasso.profile_has_dirty_identity(self._cptr)

    def hasDirtySession(self):
        '''
        Checks whether session has been modified (and should therefore be
        saved).
        
        @return: True if session has changed
        '''
        return _lasso.profile_has_dirty_session(self._cptr)

    def setIdentityFromDump(self, dump):
        '''
        Builds a new L{Identity} object from XML dump and binds it to C{self}.
        
        @param dump:  XML identity dump
        '''
        rc = _lasso.profile_set_identity_from_dump(self._cptr, dump)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def setSessionFromDump(self, dump):
        '''
        Builds a new L{Session} object from XML dump and binds it to C{self}.
        
        @param dump:  XML session dump
        '''
        rc = _lasso.profile_set_session_from_dump(self._cptr, dump)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class AssertionQuery(Profile):
    def __init__(self, server):
        self._cptr = _lasso.assertion_query_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    def initRequest(self, remote_provider_id, http_method, query_request_type):
        '''
        Initializes a new Assertion Query Request.
        
        @param remote_provider_id:  the providerID of the remote provider.
        @param http_method:  if set, then it get the protocol profile in
            metadata corresponding of this HTTP request method.
        @param query_request_type:  the type of request.
        '''
        rc = _lasso.assertion_query_init_request(self._cptr, remote_provider_id, http_method, query_request_type)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def validateRequest(self):
        '''
        Processes a Assertion query or request; caller must add assertions to
        the response afterwards.
        '''
        rc = _lasso.assertion_query_validate_request(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildRequestMsg(self):
        '''
        Builds the Name Id Management request message.
        '''
        rc = _lasso.assertion_query_build_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processRequestMsg(self, request_msg):
        '''
        Processes a Assertion query or request message.  Rebuilds a request
        object from the message and check its signature.
        
        @param request_msg:  the Assertion query or request message
        '''
        rc = _lasso.assertion_query_process_request_msg(self._cptr, request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildResponseMsg(self):
        '''
        Builds the Response message.
        '''
        rc = _lasso.assertion_query_build_response_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processResponseMsg(self, response_msg):
        '''
        Parses the response message and builds the corresponding response
        object.
        
        @param response_msg:  the response message
        '''
        rc = _lasso.assertion_query_process_response_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class Ecp(Profile):
    def __init__(self, server):
        self._cptr = _lasso.ecp_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    def get_assertionConsumerURL(self):
        return _lasso.Ecp_assertionConsumerURL_get(self._cptr)
    def set_assertionConsumerURL(self, value):
        _lasso.Ecp_assertionConsumerURL_set(self._cptr, value)
    assertionConsumerURL = property(get_assertionConsumerURL, set_assertionConsumerURL)

    def processAuthnRequestMsg(self, authn_request_msg):
        rc = _lasso.ecp_process_authn_request_msg(self._cptr, authn_request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processResponseMsg(self, response_msg):
        rc = _lasso.ecp_process_response_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class NameIdManagement(Profile):
    def __init__(self, server):
        self._cptr = _lasso.name_id_management_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, server, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.name_id_management_new_from_dump(server._cptr, dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def dump(self):
        '''
        Dumps C{self} content to an XML string.
        
        @return: the dump string.
        '''
        return _lasso.name_id_management_dump(self._cptr)

    def initRequest(self, remote_provider_id = None, new_name_id = None, http_method = HTTP_METHOD_ANY):
        '''
        Initializes a new Name Id Management Request.
        
        @param remote_provider_id:  the providerID of the remote provider.
        @param new_name_id:  the new NameId or None to terminate a federation
        @param http_method:  if set, then it get the protocol profile in
            metadata corresponding of this HTTP request method.
        '''
        rc = _lasso.name_id_management_init_request(self._cptr, remote_provider_id, new_name_id, http_method)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildRequestMsg(self):
        '''
        Builds the Name Id Management request message.
        '''
        rc = _lasso.name_id_management_build_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processRequestMsg(self, request_msg):
        '''
        Processes a Name Id Management request message.  Rebuilds a request
        object from the message and check its signature.
        
        @param request_msg:  the Name Id Management request message
        '''
        rc = _lasso.name_id_management_process_request_msg(self._cptr, request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def validateRequest(self):
        '''
        Processes a Name Id Management request, performing requested actions
        against principal federations.  Profile identity may have to be saved
        afterwards.
        '''
        rc = _lasso.name_id_management_validate_request(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildResponseMsg(self):
        '''
        Builds the Name Id Management response message.
        '''
        rc = _lasso.name_id_management_build_response_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processResponseMsg(self, response_msg):
        '''
        Parses the response message and builds the corresponding response
        object. Performs requested actions against principal federations.
        Profile identity may have to be saved afterwards.
        
        @param response_msg:  the response message
        '''
        rc = _lasso.name_id_management_process_response_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class Logout(Profile):
    def __init__(self, server):
        self._cptr = _lasso.logout_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, server, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.logout_new_from_dump(server._cptr, dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_nextProviderId(self):
        return _lasso.logout_get_next_providerID(self._cptr)
    getNextProviderId = get_nextProviderId
    nextProviderId = property(get_nextProviderId)

    def buildRequestMsg(self):
        '''
        Builds the logout request message.
        
        It gets the HTTP method retrieved to send the request and:
        
         - if it is a SOAP method, then it builds the logout request SOAP
           message,   sets the msg_body attribute, gets the single logout
           service url and sets   C{msg_url} in the logout object.
        
         - if it is a HTTP-Redirect method, then it builds the logout request
           QUERY   message, builds the logout request url, sets C{msg_url} in
           the logout   request url, sets C{msg_body} to None.
        
        If private key and certificate are set in server object it will also
        signs the message (either with X509 if SOAP or with a simple signature
        for query strings).
        '''
        rc = _lasso.logout_build_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildResponseMsg(self):
        '''
        Builds the logout response message.
        
        It gets the request message method and:
        
         - if it is a SOAP method, then it builds the logout response SOAP
           message,    sets the msg_body attribute, gets the single logout
           service return url    and sets C{msg_url} in the logout object.
        
         - if it is a HTTP-Redirect method, then it builds the logout response
           QUERY message,    builds the logout response url, sets C{msg_url}
           with the logout response url,    sets C{msg_body} to None
        
        If private key and certificate are set in server object it will also
        signs the message (either with X509 if SOAP or with a simple signature
        for query strings).
        '''
        rc = _lasso.logout_build_response_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def dump(self):
        '''
        Dumps C{self} content to an XML string.
        
        @return: the dump string.
        '''
        return _lasso.logout_dump(self._cptr)

    def initRequest(self, remote_providerID = None, request_method = HTTP_METHOD_ANY):
        '''
        Initializes a new SLO request.
        
        @param remote_providerID:  the providerID of the identity provider.
            If None the first identity provider is used.
        @param request_method:  if set, then it get the protocol profile in
            metadata corresponding of this HTTP request method.
        '''
        rc = _lasso.logout_init_request(self._cptr, remote_providerID, request_method)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processRequestMsg(self, request_msg):
        '''
        Processes a SLO LogoutRequest message.  Rebuilds a request object from
        the message and optionally verifies its signature.
        
        @param request_msg:  the logout request message
        '''
        rc = _lasso.logout_process_request_msg(self._cptr, request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processResponseMsg(self, response_msg):
        '''
        Parses the response message and builds the response object.
        
        Checks the status code value and if it is not success, then if the
        local provider is a Service Provider and response method is SOAP, then
        builds a new logout request message for HTTP Redirect / GET method and
        returns the error code LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE.
        
        If it is a SOAP method or, IDP type and http method is Redirect/GET,
        then removes assertion.
        
        If local server is an Identity Provider and if there is no more
        assertion (Identity Provider has logged out every Service Providers),
        then restores the initial response.
        
        @param response_msg:  the response message
        '''
        rc = _lasso.logout_process_response_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def resetProviderIdIndex(self):
        '''
        Reset the providerID_index attribute (set to 0).
        '''
        rc = _lasso.logout_reset_providerID_index(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def validateRequest(self):
        '''
        
        
         - Sets the remote provider id
        
         - Sets a logout response with status code value to success.
        
         - Verifies federation and authentication.
        
         - If the request http method is a SOAP method, then verifies every
           other   Service Providers supports SOAP method : if not, then sets
           status code   value to UnsupportedProfile and returns a code error
           with   LASSO_LOGOUT_ERROR_UNSUPPORTED_PROFILE.
        
         - Every tests are ok, then removes assertion.
        
         - If local server is an Identity Provider and if there is more than
           one   Service Provider (except the initial Service Provider), then
           saves the   initial request, response and remote provider id.
        '''
        rc = _lasso.logout_validate_request(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class NameRegistration(Profile):
    def __init__(self, server):
        self._cptr = _lasso.name_registration_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, server, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.name_registration_new_from_dump(server._cptr, dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_oldNameIdentifier(self):
        t = _lasso.NameRegistration_oldNameIdentifier_get(self._cptr)
        return cptrToPy(t)
    def set_oldNameIdentifier(self, value):
        if value is not None:
            value = value._cptr
        _lasso.NameRegistration_oldNameIdentifier_set(self._cptr, value)
    oldNameIdentifier = property(get_oldNameIdentifier, set_oldNameIdentifier)

    def buildRequestMsg(self):
        '''
        Builds a register name identifier request message.
        
        It gets the register name identifier protocol profile and:
        
         - if it is a SOAP method, then it builds the register name identifier
           request SOAP message, optionally signs his node, sets C{msg_body},
           gets the SoapEndpoint url and sets C{msg_url}.
        
         - if it is a HTTP-Redirect method, then it builds the register name
           identifier request QUERY message (optionally signs the request
           message),   builds the request url with register name identifier
           url with register   name identifier service url, sets C{msg_url} in
           the register name   identifier object, sets C{msg_body} to None.
        '''
        rc = _lasso.name_registration_build_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildResponseMsg(self):
        '''
        Builds the register name idendifier response message.
        
        It gets the request message method and:
        
         - if it is a SOAP method, then it builds the response SOAP message,
           sets    the msg_body attribute, gets the register name identifier
           service return    url and sets C{msg_url} of the object.
        
         - if it is a HTTP-Redirect method, then it builds the response QUERY
           message, builds the response url, sets C{msg_url} with the response
           url    and sets the msg_body with None
        
        If private key and certificate are set in server object it will also
        signs the message (either with X509 if SOAP or with a simple signature
        for query strings).
        '''
        rc = _lasso.name_registration_build_response_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def dump(self):
        '''
        Dumps C{self} content to an XML string.
        
        @return: the dump string.
        '''
        return _lasso.name_registration_dump(self._cptr)

    def initRequest(self, remote_providerID, http_method = HTTP_METHOD_ANY):
        '''
        Initializes a new lib:RegisterNameIdentifierRequest request; it sets
        C{self}->nameIdentifier to the new name identifier and
        C{self}->oldNameIdentifier to the old one.
        
        @param remote_providerID:  the providerID of the identity provider.
        @param http_method:  if set, then it get the protocol profile in
            metadata corresponding of this HTTP request method.
        '''
        rc = _lasso.name_registration_init_request(self._cptr, remote_providerID, http_method)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processRequestMsg(self, request_msg):
        '''
        Processes a lib:RegisterNameIdentifierRequest message.  Rebuilds a
        request object from the message and optionally verifies its signature.
        Sets profile->nameIdentifier to local name identifier.  If it changed
        (when this is IdP-initiated and there was no previously defined local
        name identifier) profile->nameIdentifier will be the new one and
        profile->oldNameIdentiifer the old one.
        
        @param request_msg:  the register name identifier request message
        '''
        rc = _lasso.name_registration_process_request_msg(self._cptr, request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processResponseMsg(self, response_msg):
        '''
        Processes a lib:RegisterNameIdentifierResponse message.  Rebuilds a
        response object from the message and optionally verifies its
        signature.
        
        If the response depicts Success it will also update Principal
        federation.
        
        @param response_msg:  the register name identifier response message
        '''
        rc = _lasso.name_registration_process_response_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def validateRequest(self):
        '''
        Checks profile request with regards to message status and principal
        federations, update them accordingly and prepares a
        lib:RegisterNameIdentifierResponse accordingly.
        '''
        rc = _lasso.name_registration_validate_request(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class NameIdentifierMapping(Profile):
    def __init__(self, server):
        self._cptr = _lasso.name_identifier_mapping_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    def get_targetNameIdentifier(self):
        return _lasso.NameIdentifierMapping_targetNameIdentifier_get(self._cptr)
    def set_targetNameIdentifier(self, value):
        _lasso.NameIdentifierMapping_targetNameIdentifier_set(self._cptr, value)
    targetNameIdentifier = property(get_targetNameIdentifier, set_targetNameIdentifier)

    def buildRequestMsg(self):
        '''
        Builds a name identifier mapping request message.
        
        
        
         - If it is a SOAP method, then it builds the request as a SOAP
           message,   optionally signs his node, sets C{msg_body} with that
           message and sets   C{msg_url} with the SOAP Endpoint URL
        
         - If it is a HTTP-Redirect method, then it builds the request as a
           query   string message, optionally signs it and sets C{msg_url} to
           that URL.
        '''
        rc = _lasso.name_identifier_mapping_build_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildResponseMsg(self):
        '''
        Builds a name identifier mapping response message.
        
        
        
         - If it is a SOAP method, then it builds the response as a SOAP
           message,   optionally signs his node, sets C{msg_body} with that
           message and sets   C{msg_url} with the register name identifier
           service return URL.
        
         - If it is a HTTP-Redirect method, then it builds the response as a
           query   string message, optionally signs it and sets C{msg_url} to
           that URL.
        
        If private key and certificate are set in server object it will also
        signs the message (either with X509 if SOAP or with a simple signature
        for query strings).
        '''
        rc = _lasso.name_identifier_mapping_build_response_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def initRequest(self, targetNamespace, remote_providerID = None):
        '''
        Initializes a new lib:NameIdentifierMappingRequest request.
        
        @param targetNamespace:  the request targetNamespace
        @param remote_providerID:  the providerID of the identity provider.
        '''
        rc = _lasso.name_identifier_mapping_init_request(self._cptr, targetNamespace, remote_providerID)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processRequestMsg(self, request_msg):
        '''
        Processes a lib:NameIdentifierMappingRequest message.  Rebuilds a
        request object from the message and optionally verifies its signature.
        
        @param request_msg:  the name identifier mapping request message
        '''
        rc = _lasso.name_identifier_mapping_process_request_msg(self._cptr, request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processResponseMsg(self, response_msg):
        '''
        Processes a lib:NameIdentifierMappingResponse message.  Rebuilds a
        response object from the message and optionally verifies its
        signature.
        
        If the response depicts Success it will also sets
        C{targetNameIdentifier}.
        
        @param response_msg:  the name identifier mapping response message
        '''
        rc = _lasso.name_identifier_mapping_process_response_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def validateRequest(self):
        '''
        Checks profile request with regards to message status and principal
        federations, update them accordingly and prepares a
        lib:NameIdentifierMappingResponse accordingly.
        '''
        rc = _lasso.name_identifier_mapping_validate_request(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class Provider(Node):
    def __init__(self, role, metadata, public_key = None, ca_cert_chain = None):
        self._cptr = _lasso.provider_new(role, metadata, public_key, ca_cert_chain)
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.provider_new_from_dump(dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_providerId(self):
        return _lasso.Provider_providerId_get(self._cptr)
    def set_providerId(self, value):
        _lasso.Provider_providerId_set(self._cptr, value)
    providerId = property(get_providerId, set_providerId)

    def get_role(self):
        return _lasso.Provider_role_get(self._cptr)
    def set_role(self, value):
        _lasso.Provider_role_set(self._cptr, value)
    role = property(get_role, set_role)

    def get_metadataFilename(self):
        return _lasso.Provider_metadataFilename_get(self._cptr)
    def set_metadataFilename(self, value):
        _lasso.Provider_metadataFilename_set(self._cptr, value)
    metadataFilename = property(get_metadataFilename, set_metadataFilename)

    def get_publicKey(self):
        return _lasso.Provider_publicKey_get(self._cptr)
    def set_publicKey(self, value):
        _lasso.Provider_publicKey_set(self._cptr, value)
    publicKey = property(get_publicKey, set_publicKey)

    def get_caCertChain(self):
        return _lasso.Provider_caCertChain_get(self._cptr)
    def set_caCertChain(self, value):
        _lasso.Provider_caCertChain_set(self._cptr, value)
    caCertChain = property(get_caCertChain, set_caCertChain)

    def get_base64SuccinctId(self):
        return _lasso.provider_get_base64_succinct_id(self._cptr)
    getBase64SuccinctId = get_base64SuccinctId
    base64SuccinctId = property(get_base64SuccinctId)

    def get_organization(self):
        return _lasso.provider_get_organization(self._cptr)
    getOrganization = get_organization
    organization = property(get_organization)

    def get_protocolConformance(self):
        return _lasso.provider_get_protocol_conformance(self._cptr)
    getProtocolConformance = get_protocolConformance
    protocolConformance = property(get_protocolConformance)

    def getAssertionConsumerServiceUrl(self, service_id):
        '''
        Extracts the AssertionConsumerServiceURL from the provider metadata
        descriptor.
        
        @param service_id:  the AssertionConsumerServiceID, None for default
        @return: the element value, None if the element was not found.
        '''
        return _lasso.provider_get_assertion_consumer_service_url(self._cptr, service_id)

    def getMetadataOne(self, name):
        '''
        Extracts the element C{name} from the provider metadata descriptor.
        
        @param name:  the element name
        @return: the element value, None if the element was not found.
        '''
        return _lasso.provider_get_metadata_one(self._cptr, name)

    def getMetadataList(self, name):
        '''
        Extracts zero to many elements from the provider metadata descriptor.
        
        @param name:  the element name
        @return: a #GList with the elements.  This GList is internally
            allocated and points to internally allocated strings.  It must not
            be freed, modified or stored.
        '''
        value = _lasso.provider_get_metadata_list(self._cptr, name)
        if value is not None:
            value = tuple([cptrToPy(x) for x in value])
        return value

    def getFirstHttpMethod(self, remote_provider, protocol_type):
        '''
        Looks up and returns a L{HttpMethod} appropriate for performing the
        C{protocol_type} between C{self} and C{remote_provider}.
        
        @param remote_provider:  a L{Provider} depicting the remote provider
        @param protocol_type:  a Liberty profile
        @return: the L{HttpMethod}
        '''
        return _lasso.provider_get_first_http_method(self._cptr, remote_provider._cptr, protocol_type)

    def acceptHttpMethod(self, remote_provider, protocol_type, http_method, initiate_profile):
        '''
        Gets if C{http_method} is an appropriate method for the
        C{protocol_type} profile between C{self} and C{remote_provider}.
        
        @param remote_provider:  a L{Provider} depicting the remote provider
        @param protocol_type:  a Liberty profile type
        @param http_method:  an HTTP method
        @param initiate_profile:  whether C{self} initiates the profile
        @return: True if it is appropriate
        '''
        return _lasso.provider_accept_http_method(self._cptr, remote_provider._cptr, protocol_type, http_method, initiate_profile)

    def hasProtocolProfile(self, protocol_type, protocol_profile):
        '''
        Gets if C{self} supports C{protocol_profile}.
        
        @param protocol_type:  a Liberty profile type
        @param protocol_profile:  a fully-qualified Liberty profile
        @return: True if it is supported
        '''
        return _lasso.provider_has_protocol_profile(self._cptr, protocol_type, protocol_profile)

    def setEncryptionMode(self, encryption_mode):
        '''
        Activate or desactivate encryption
        
        @param encryption_mode:  TRUE to activate, FALSE to desactivate
        '''
        _lasso.provider_set_encryption_mode(self._cptr, encryption_mode)

    def setEncryptionSymKeyType(self, encryption_sym_key_type):
        '''
        Set the type of the generated encryption symetric key
        
        @param encryption_sym_key_type:  enum type for generated symetric key
        '''
        _lasso.provider_set_encryption_sym_key_type(self._cptr, encryption_sym_key_type)


class Server(Provider):
    def __init__(self, metadata = None, private_key = None, private_key_password = None, certificate = None):
        self._cptr = _lasso.server_new(metadata, private_key, private_key_password, certificate)
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.server_new_from_dump(dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_providers(self):
        d = _lasso.Server_providers_get(self._cptr)
        if not d: return d
        d2 = {}
        for k, v in d.items():
            d2[k] = cptrToPy(v)
        return frozendict(d2)
    def set_providers(self, value):
        _lasso.Server_providers_set(self._cptr, value)
    providers = property(get_providers, set_providers)

    def get_services(self):
        d = _lasso.Server_services_get(self._cptr)
        if not d: return d
        d2 = {}
        for k, v in d.items():
            d2[k] = cptrToPy(v)
        return frozendict(d2)
    def set_services(self, value):
        _lasso.Server_services_set(self._cptr, value)
    services = property(get_services, set_services)

    def get_privateKey(self):
        return _lasso.Server_privateKey_get(self._cptr)
    def set_privateKey(self, value):
        _lasso.Server_privateKey_set(self._cptr, value)
    privateKey = property(get_privateKey, set_privateKey)

    def get_privateKeyPassword(self):
        return _lasso.Server_privateKeyPassword_get(self._cptr)
    def set_privateKeyPassword(self, value):
        _lasso.Server_privateKeyPassword_set(self._cptr, value)
    privateKeyPassword = property(get_privateKeyPassword, set_privateKeyPassword)

    def get_certificate(self):
        return _lasso.Server_certificate_get(self._cptr)
    def set_certificate(self, value):
        _lasso.Server_certificate_set(self._cptr, value)
    certificate = property(get_certificate, set_certificate)

    def get_signatureMethod(self):
        return _lasso.Server_signatureMethod_get(self._cptr)
    def set_signatureMethod(self, value):
        _lasso.Server_signatureMethod_set(self._cptr, value)
    signatureMethod = property(get_signatureMethod, set_signatureMethod)

    def addProvider(self, role, metadata, public_key = None, ca_cert_chain = None):
        '''
        Creates a new L{Provider} and makes it known to the C{self}
        
        @param role:  provider role, identity provider or service provider
        @param metadata:  path to the provider metadata file
        @param public_key:  provider public key file (may be a certificate) or
            None
        @param ca_cert_chain:  provider CA certificate chain file or None
        '''
        rc = _lasso.server_add_provider(self._cptr, role, metadata, public_key, ca_cert_chain)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def addService(self, service):
        '''
        ...
        
        '''
        rc = _lasso.server_add_service(self._cptr, service._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def addServiceFromDump(self, dump):
        rc = _lasso.server_add_service_from_dump(self._cptr, dump)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def dump(self):
        '''
        Dumps C{self} content to an XML string.
        
        @return: the dump string.
        '''
        return _lasso.server_dump(self._cptr)

    def getProvider(self, providerID):
        '''
        Looks up for a L{Provider} whose ID is C{providerID} and returns it.
        
        @param providerID:  the provider ID
        @return: the L{Provider}, None if it was not found.  The L{Provider}
            is owned by Lasso and should not be freed.
        '''
        return cptrToPy(_lasso.server_get_provider(self._cptr, providerID))

    def setEncryptionPrivateKey(self, filename):
        '''
        Load an encryption private key from a file and set it in the server
        object
        
        @param filename:  file name of the encryption key to load
        '''
        rc = _lasso.server_set_encryption_private_key(self._cptr, filename)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def loadAffiliation(self, filename):
        '''
        Load an affiliation metadata file into C{self}; this must be called
        after providers have been added to C{self}.
        
        @param filename:  file name of the affiliation metadata to load
        '''
        rc = _lasso.server_load_affiliation(self._cptr, filename)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class Login(Profile):
    def __init__(self, server):
        self._cptr = _lasso.login_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, server, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.login_new_from_dump(server._cptr, dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_protocolProfile(self):
        return _lasso.Login_protocolProfile_get(self._cptr)
    def set_protocolProfile(self, value):
        _lasso.Login_protocolProfile_set(self._cptr, value)
    protocolProfile = property(get_protocolProfile, set_protocolProfile)

    def get_assertionArtifact(self):
        return _lasso.Login_assertionArtifact_get(self._cptr)
    def set_assertionArtifact(self, value):
        _lasso.Login_assertionArtifact_set(self._cptr, value)
    assertionArtifact = property(get_assertionArtifact, set_assertionArtifact)

    def get_assertion(self):
        t = _lasso.Login_assertion_get(self._cptr)
        return cptrToPy(t)
    def set_assertion(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Login_assertion_set(self._cptr, value)
    assertion = property(get_assertion, set_assertion)

    def acceptSso(self):
        '''
        Gets the assertion of the response and adds it into the session.
        Builds a federation with the 2 name identifiers of the assertion and
        adds it into the identity. If the session or the identity are None,
        they are created.
        '''
        rc = _lasso.login_accept_sso(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildArtifactMsg(self, http_method):
        '''
        Builds a SAML artifact. Depending of the HTTP method, the data for the
        sending of the artifact are stored in C{msg_url} (REDIRECT) or
        C{msg_url}, C{msg_body} and C{msg_relayState} (POST).
        
        @param http_method:  the HTTP method to send the artifact (REDIRECT or
            POST)
        '''
        rc = _lasso.login_build_artifact_msg(self._cptr, http_method)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildAssertion(self, authenticationMethod = None, authenticationInstant = None, reauthenticateOnOrAfter = None, notBefore = None, notOnOrAfter = None):
        '''
        Builds an assertion and stores it in profile session.
        C{authenticationInstant}, reauthenticateOnOrAfter, C{notBefore} and
        C{notOnOrAfter} may be None.  If C{authenticationInstant} is None, the
        current time will be used.  Time values must be encoded in UTC.
        
        @param authenticationMethod:  the authentication method
        @param authenticationInstant:  the time at which the authentication
            took place
        @param reauthenticateOnOrAfter:  the time at, or after which the
            service provider must reauthenticates the principal with the
            identity provider
        @param notBefore:  the earliest time instant at which the assertion is
            valid
        @param notOnOrAfter:  the time instant at which the assertion has
            expired
        '''
        rc = _lasso.login_build_assertion(self._cptr, authenticationMethod, authenticationInstant, reauthenticateOnOrAfter, notBefore, notOnOrAfter)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildAuthnRequestMsg(self):
        '''
        Converts profile authentication request (C{request} member) into a
        Liberty message, either an URL in HTTP-Redirect profile or an URL and
        a field value in Browser-POST (form) profile.
        
        The URL is set into the C{msg_url} member and the eventual field value
        (LAREQ) is set into the C{msg_body} member.
        '''
        rc = _lasso.login_build_authn_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildAuthnResponseMsg(self):
        '''
        Converts profile authentication response (C{response} member) into a
        Liberty message.
        
        The URL is set into the C{msg_url} member and the field value (LARES)
        is set into the C{msg_body} member.
        '''
        rc = _lasso.login_build_authn_response_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildRequestMsg(self):
        '''
        Converts profile artifact request into a Liberty SOAP message.
        
        The URL is set into the C{msg_url} member and the SOAP message is set
        into the C{msg_body} member.
        '''
        rc = _lasso.login_build_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildResponseMsg(self, remote_providerID = None):
        '''
        Converts profile assertion response (C{response} member) into a
        Liberty SOAP messageresponse message.
        
        The URL is set into the C{msg_url} member and the SOAP message is set
        into the C{msg_body} member.
        
        @param remote_providerID:  service provider ID
        '''
        rc = _lasso.login_build_response_msg(self._cptr, remote_providerID)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def dump(self):
        '''
        Dumps C{self} content to an XML string.
        
        @return: the dump string.
        '''
        return _lasso.login_dump(self._cptr)

    def initAuthnRequest(self, remote_providerID = None, http_method = HTTP_METHOD_REDIRECT):
        '''
        Initializes a new AuthnRequest from current service provider to remote
        identity provider specified in C{remote_providerID} (if None the first
        known identity provider is used).
        
        @param remote_providerID:  the providerID of the identity provider
            (may be None)
        @param http_method:  HTTP method to use for request transmission
        '''
        rc = _lasso.login_init_authn_request(self._cptr, remote_providerID, http_method)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def initRequest(self, response_msg, response_http_method = HTTP_METHOD_REDIRECT):
        '''
        Initializes an artifact request.  C{response_msg} is either the query
        string (in redirect mode) or the form LAREQ field (in browser-post
        mode).
        
        @param response_msg:  the authentication response received
        @param response_http_method:  the method used to receive the
            authentication response
        '''
        rc = _lasso.login_init_request(self._cptr, response_msg, response_http_method)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def initIdpInitiatedAuthnRequest(self, remote_providerID):
        '''
        Generates an authentication response without matching authentication
        request.
        
        If C{remote_providerID} is None, the first known provider is used.
        
        @param remote_providerID:  the providerID of the remote service
            provider (may be None)
        '''
        rc = _lasso.login_init_idp_initiated_authn_request(self._cptr, remote_providerID)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def mustAskForConsent(self):
        '''
        Evaluates if consent must be asked to the Principal to federate him.
        
        @return: True if consent must be asked
        '''
        return _lasso.login_must_ask_for_consent(self._cptr)

    def mustAuthenticate(self):
        '''
        Evaluates if user must be authenticated.
        
        @return: True if user must be authenticated
        '''
        return _lasso.login_must_authenticate(self._cptr)

    def processAuthnRequestMsg(self, authn_request_msg = None):
        '''
        Processes received authentication request, checks it is signed
        correctly, checks if requested protocol profile is supported, etc.
        
        @param authn_request_msg:  the authentication request received
        '''
        rc = _lasso.login_process_authn_request_msg(self._cptr, authn_request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processAuthnResponseMsg(self, authn_response_msg):
        '''
        Processes received authentication response.
        
        @param authn_response_msg:  the authentication response received
        '''
        rc = _lasso.login_process_authn_response_msg(self._cptr, authn_response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processRequestMsg(self, request_msg):
        '''
        Processes received artifact request.
        
        @param request_msg:  the artifact request received
        '''
        rc = _lasso.login_process_request_msg(self._cptr, request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processResponseMsg(self, response_msg):
        '''
        Processes received assertion response.
        
        @param response_msg:  the assertion response received
        '''
        rc = _lasso.login_process_response_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def setResourceId(self, content):
        '''
        ...
        
        '''
        rc = _lasso.login_set_resourceId(self._cptr, content)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def validateRequestMsg(self, authentication_result, is_consent_obtained):
        '''
        Initializes a response to the authentication request received.
        
        @param authentication_result:  whether user has authenticated
            succesfully
        @param is_consent_obtained:  whether user consent has been obtained
        '''
        rc = _lasso.login_validate_request_msg(self._cptr, authentication_result, is_consent_obtained)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processPaosResponseMsg(self, msg):
        rc = _lasso.login_process_paos_response_msg(self._cptr, msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class Lecp(Login):
    def __init__(self, server):
        self._cptr = _lasso.lecp_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    def get_authnRequestEnvelope(self):
        t = _lasso.Lecp_authnRequestEnvelope_get(self._cptr)
        return cptrToPy(t)
    def set_authnRequestEnvelope(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Lecp_authnRequestEnvelope_set(self._cptr, value)
    authnRequestEnvelope = property(get_authnRequestEnvelope, set_authnRequestEnvelope)

    def get_authnResponseEnvelope(self):
        t = _lasso.Lecp_authnResponseEnvelope_get(self._cptr)
        return cptrToPy(t)
    def set_authnResponseEnvelope(self, value):
        if value is not None:
            value = value._cptr
        _lasso.Lecp_authnResponseEnvelope_set(self._cptr, value)
    authnResponseEnvelope = property(get_authnResponseEnvelope, set_authnResponseEnvelope)

    def get_assertionConsumerServiceURL(self):
        return _lasso.Lecp_assertionConsumerServiceURL_get(self._cptr)
    def set_assertionConsumerServiceURL(self, value):
        _lasso.Lecp_assertionConsumerServiceURL_set(self._cptr, value)
    assertionConsumerServiceURL = property(get_assertionConsumerServiceURL, set_assertionConsumerServiceURL)

    def buildAuthnRequestEnvelopeMsg(self):
        '''
        Builds an enveloped authentication request message.  Sets C{msg_body}
        to that message.
        '''
        rc = _lasso.lecp_build_authn_request_envelope_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildAuthnRequestMsg(self):
        '''
        Builds an authentication request. The data for the sending of the
        request are stored in C{msg_url} and C{msg_body} (SOAP POST).
        '''
        rc = _lasso.lecp_build_authn_request_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildAuthnResponseMsg(self):
        '''
        Builds the lecp authentication response message (base64).  Sets
        C{msg_body} to that message.
        '''
        rc = _lasso.lecp_build_authn_response_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def buildAuthnResponseEnvelopeMsg(self):
        '''
        Builds the enveloped LECP authentication response message (SOAP
        message). Sets C{msg_body} to that message.
        '''
        rc = _lasso.lecp_build_authn_response_envelope_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def initAuthnRequest(self, remote_providerID = None):
        '''
        Initializes a new lib:AuthnRequest.
        
        @param remote_providerID:  the providerID of the identity provider.
            When None, the first known identity provider is used.
        '''
        rc = _lasso.lecp_init_authn_request(self._cptr, remote_providerID)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processAuthnRequestMsg(self, authn_request_msg):
        '''
        Processes received authentication request, checks it is signed
        correctly, checks if requested protocol profile is supported, etc.
        
        @param authn_request_msg:  the authentication request received
        '''
        rc = _lasso.lecp_process_authn_request_msg(self._cptr, authn_request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processAuthnRequestEnvelopeMsg(self, request_msg):
        '''
        Processes received enveloped authentication request, extracts the
        authentication request out of it.
        
        @param request_msg:  the enveloped authentication request received
        '''
        rc = _lasso.lecp_process_authn_request_envelope_msg(self._cptr, request_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processAuthnResponseEnvelopeMsg(self, response_msg):
        '''
        Processes received enveloped authentication response, extracts the
        authentication response out of it and stores it in C{response}.
        
        @param response_msg:  the enveloped authentication response received
        '''
        rc = _lasso.lecp_process_authn_response_envelope_msg(self._cptr, response_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class Defederation(Profile):
    def __init__(self, server):
        self._cptr = _lasso.defederation_new(server._cptr)
        if self._cptr is None:
            raise Error('failed to create object')

    def buildNotificationMsg(self):
        '''
        Builds the federation termination notification message.
        
        It gets the federation termination notification protocol profile and:
        
         - if it is a SOAP method, then it builds the federation termination
           notification SOAP message, optionally signs the notification node,
           sets   C{msg_body}, gets the SoapEndpoint url and sets C{msg_url}
           of the federation   termination object.
        
         - if it is a HTTP-Redirect method, then it builds the federation
           termination   notification QUERY message (optionally signs the
           notification message),   builds the federation termination
           notification url with federation   termination service url, sets
           C{msg_url} in the federation termination   object, sets C{msg_body}
           to None.
        '''
        rc = _lasso.defederation_build_notification_msg(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def initNotification(self, remote_providerID = None, http_method = HTTP_METHOD_ANY):
        '''
        Sets a new federation termination notification to the remote provider
        id with the provider id of the requester (from the server object) and
        the name identifier of the federated principal.
        
        @param remote_providerID:  the provider id of the federation
            termination notified provider.
        @param http_method:  the HTTP method to send the message.
        '''
        rc = _lasso.defederation_init_notification(self._cptr, remote_providerID, http_method)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def processNotificationMsg(self, notification_msg):
        '''
        Processes a lib:FederationTerminationNotification message.  Rebuilds a
        request object from the message and optionally verifies its signature.
        
        Set the msg_nameIdentifier attribute with the NameIdentifier content
        of the notification object and optionally set the msg_relayState
        attribute with the RelayState content of the notification object.
        
        @param notification_msg:  the federation termination notification
            message
        '''
        rc = _lasso.defederation_process_notification_msg(self._cptr, notification_msg)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)

    def validateNotification(self):
        '''
        Checks notification with regards to message status and principal
        federations; update them accordingly.
        '''
        rc = _lasso.defederation_validate_notification(self._cptr)
        if rc == 0:
            return
        raise Error.raise_on_rc(rc)


class Identity(Node):
    def __init__(self, ):
        self._cptr = _lasso.identity_new()
        if self._cptr is None:
            raise Error('failed to create object')

    @classmethod
    def newFromDump(cls, dump):
         obj = cls.__new__(cls)
         obj._cptr = _lasso.identity_new_from_dump(dump)
         if obj._cptr is None:
             raise RuntimeError('lasso failed to create object')
         return obj

    def get_federations(self):
        d = _lasso.Identity_federations_get(self._cptr)
        if not d: return d
        d2 = {}
        for k, v in d.items():
            d2[k] = cptrToPy(v)
        return frozendict(d2)
    def set_federations(self, value):
        _lasso.Identity_federations_set(self._cptr, value)
    federations = property(get_federations, set_federations)

    def get_isDirty(self):
        return _lasso.Identity_isDirty_get(self._cptr)
    def set_isDirty(self, value):
        _lasso.Identity_isDirty_set(self._cptr, value)
    isDirty = property(get_isDirty, set_isDirty)

    def getFederation(self, providerID):
        '''
        Looks up and returns the L{Federation} for this provider ID.
        
        @param providerID:  the provider ID
        @return: the L{Federation}; or None if it didn't exist.  The
            L{Federation} is internally allocated.  It must not be freed,
            modified or stored.
        '''
        return cptrToPy(_lasso.identity_get_federation(self._cptr, providerID))

    def dump(self):
        '''
        Dumps C{self} content to an XML string.
        
        @return: the dump string.
        '''
        return _lasso.identity_dump(self._cptr)


init = _lasso.init
shutdown = _lasso.shutdown
checkVersion = _lasso.check_version
strError = _lasso.strError
registerDstService = _lasso.register_dst_service
getPrefixForDstServiceHref = _lasso.get_prefix_for_dst_service_href
registerIdwsf2DstService = _lasso.register_idwsf2_dst_service
getPrefixForIdwsf2DstServiceHref = _lasso.get_prefix_for_idwsf2_dst_service_href
isSamlQuery = _lasso.isSamlQuery
getRequestTypeFromSoapMsg = _lasso.get_request_type_from_soap_msg
isLibertyQuery = _lasso.isLibertyQuery


import lasso

# backward compatibility with the SWIG binding

WSF_SUPPORT = WSF_ENABLED

Profile.isIdentityDirty = property(Profile.hasDirtyIdentity)
Profile.isSessionDirty = property(Profile.hasDirtySession)

def identity_get_provider_ids(self):
    return self.federations.keys()
Identity.providerIds = property(identity_get_provider_ids)

def server_get_provider_ids(self):
    return self.providers.keys()
Server.providerIds = property(server_get_provider_ids)

def session_get_provider_ids(self):
    return self.assertions.keys()
Session.providerIds = property(session_get_provider_ids)

Samlp2AuthnRequest.nameIDPolicy = Samlp2AuthnRequest.nameIdPolicy
LibAuthnRequest.nameIDPolicy = LibAuthnRequest.nameIdPolicy
Saml2Subject.nameID = Saml2Subject.nameId
MiscTextNode.text_child = MiscTextNode.textChild
NodeList = list
StringList = list
StringDict = dict
registerIdWsf2DstService = registerIdwsf2DstService

if WSF_SUPPORT:
    DiscoDescription_newWithBriefSoapHttpDescription = DiscoDescription.newWithBriefSoapHttpDescription
    Discovery.buildRequestMsg = Discovery.buildSoapRequestMsg
    InteractionProfileService.buildRequestMsg = InteractionProfileService.buildSoapRequestMsg
    InteractionProfileService.buildResponseMsg = InteractionProfileService.buildSoapResponseMsg
    DataService.buildRequestMsg = DataService.buildSoapRequestMsg
    DiscoModifyResponse.newEntryIds = DiscoModifyResponse.newEntryIDs

